Sat Dec 25 11:11:48 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.8.2 released.

Sat Dec 25 04:23:49 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (mkdir, mkdir_p): should ensure directory
	  permission. (backportted from HEAD, 1.47)

	* lib/fileutils.rb (traverse, remove_dir): untaint trasted
	  objects. (backportted from HEAD, 1.46)

Sat Dec 25 01:28:23 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c: cancel io_reopen() change on Dec. 24th.

	* dln.c: use <dlfcn.h> for NetBSD.  [ruby-dev:25313]

	* io.c (rb_f_select): [ruby-dev:25312]

Fri Dec 24 23:51:48 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* bcc32/Makefile.sub: bcc32 should use RTL dll (backport from HEAD)
	  [ruby-dev:25306]

	* win32/win32.[ch]: ditto.

Fri Dec 24 23:27:18 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/image.rb: TkPhotoImage#cget bug fix

Fri Dec 24 18:39:25 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* win32/win32.[ch]: failed to compile on bcc32 (and probably wince)
	  [ruby-dev:25306]

Fri Dec 24 02:52:52 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_reopen, rb_io_reopen): prohibit to change access mode for
	  special IO ports.  [ruby-dev:25225]

Fri Dec 24 02:22:53 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/syck/rubyext.c (rb_syck_io_str_read): [ruby-core:03973]

	* ext/syck/rubyext.c (syck_loader_transfer): check type conversion.

	* ext/syck/rubyext.c (syck_parser_assign_io, rb_new_syck_node): duck
	  typing.

	* ext/syck/rubyext.c (syck_parser_s_alloc, syck_parser_initialize):
	  allocation framework.

	* ext/syck/rubyext.c (syck_emitter_s_alloc, syck_emitter_initialize):
	  ditto.

Fri Dec 24 01:21:00 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tkextlib/blt.rb: add BLT extension support

	* ext/tk/lib/tkextlib/blt/*.rb: ditto

	* ext/tk/lib/tkextlib/blt/tile/*.rb: ditto

Thu Dec 23 23:36:28 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (proc_setgroups): check if the argument lenght is
	  modified.  fixed: [ruby-dev:25285]

Thu Dec 23 13:13:33 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: define TclTkLib::COMPILE_INFO and
	  RELEASE_DATE

	* ext/tcltklib/extconf.rb: ditto

	* ext/tk/tkutil.c: define TkUtil::RELEASE_DATE

	* ext/tk/lib/tk.rb: define Tk::RELEASE_DATE

Thu Dec 23 09:38:31 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_reopen): restore exact mode.  fixed: [ruby-core:04003]

Thu Dec 23 00:16:32 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (bsdi): use $(CC) for LDSHARED.  fixed [ruby-dev:25270]

Wed Dec 22 11:14:55 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_mode_modenum): replace O_ACCMODE with O_RDWR.
	  fixed: [ruby-dev:25273]

Wed Dec 22 08:34:32 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/sym.c (rb_dlsym_initialize): extract internal pointers after
	  all argument conversion.  fixed: [ruby-dev:25271]

Wed Dec 22 00:08:01 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/soap/*, test/soap/*, sample/soap/authheader/*: eval cleanup.

Tue Dec 21 22:07:33 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_asn1.c (ossl_asn1_traverse, ossl_asn1_decode,
	  ossl_asn1_decode_all): temporary value should be marked volatile.

Tue Dec 21 14:40:02 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_asn1.c (ossl_asn1_traverse, ossl_asn1_decode,
	  ossl_asn1_decode_all): use rb_str_new4 to avoid SEGV.
	  fix [ruby-dev:25261]

	* test/openssl/test_asn1.rb: add tests for OpenSSL::ASN1.

Tue Dec 21 12:22:40 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_reopen): keep duplex pipe in correct mode for exception
	  safeness.  fixed: [ruby-dev:25152]

Tue Dec 21 12:10:04 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/grid.rb: rescue bug of 'grid configure' on Tcl/Tk8.3-

Tue Dec 21 00:53:01 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/openssl/ossl_asn1.c (ossl_asn1_traverse): [ruby-dev:25261]

	* ext/openssl/ossl_asn1.c (ossl_asn1_decode): ditto.

	* ext/openssl/ossl_asn1.c (ossl_asn1_decode_all): ditto.

Mon Dec 20 23:22:26 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* added files:
	  * lib/soap/mapping/wsdl*.rb
	  * lib/wsdl/soap/element.rb
	  * lib/wsdl/xmlSchema/simpleContent.rb

	* modified files:
	  * lib/soap/*
	  * lib/wsdl/*
	  * lib/xsd/*
	  * test/soap/*
	  * test/wsdl/*
	  * test/xsd/*
	  * sample/soap/*
	  * sample/sdl/*

	* summary
	  * imported from the soap4r repository.  Version: 1.5.3-ruby1.8.2

	  * added several XSD basetype support: nonPositiveInteger,
	    negativeInteger, nonNegativeInteger, unsignedLong, unsignedInt,
	    unsignedShort, unsignedByte, positiveInteger

	  * HTTP client connection/send/receive timeout support.

	  * HTTP client/server gzipped content encoding support.

	  * improved WSDL schema definition support; still is far from
	    complete, but is making step by step improovement.

Mon Dec 20 22:56:39 2004  Tanaka Akira  <akr@m17n.org>

	* gc.c (stack_end_address): gcc noinline attribute is available since
	  gcc-3.1.

Mon Dec 20 14:07:02 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/multi-tk.rb: supports new features of Tcl/Tk8.5a2

	* ext/tk/lib/tk/clock.rb: ditto

	* ext/tk/lib/tk/text.rb: ditto

	* ext/tk/lib/tk/panedwindow.rb: ditto

Mon Dec 20 12:47:13 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/lib/net/https.rb,protocols.rb,telnets.rb: delete
	  doc and code about SSLContext#{key_file,cert_file}.
	  fixed: [ruby-dev:25243]

Mon Dec 20 12:42:17 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (io_fwrite): workaround for MSVCRT's bug.
	  fixed: [ruby-core:03982]

Mon Dec 20 11:21:04 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_eof): check if closed before clearerr().
	  fixed: [ruby-dev:25251]

Mon Dec 20 03:30:40 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/cgi/session.rb (CGI::Session#initialize): empty session id was
	  used if request had no session key.  fixed: [ruby-core:03981]

Mon Dec 20 01:51:01 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* struct.c (make_struct): [ruby-dev:25249]

Mon Dec 20 00:28:20 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/encodings/SHIFT-JIS.rb: backported from CVS HEAD.

	* lib/rexml/encodings/SHIFT_JIS.rb: ditto.

Sun Dec 19 17:19:48 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_x509store.c
	  (ossl_x509store_set_time): add OpenSSL::X509::Store#time=.
	  (ossl_x509stctx_set_time): add OpenSSL::X509::StoreContext#time=.

	* test/openssl/ossl_x509store.rb: test certificate validity times.

	* ext/openssl/ossl_x509name.c (ossl_x509name_to_s): add optional
	  second argument to specify the output format (see also
	  X509_NAME_print_ex).

	* ext/openssl/ossl_x509name.c (ossl_x509name_init): new constants:
	  OpenSSL::X509::Name::COMPAT, OpenSSL::X509::Name::RFC2253,
	  OpenSSL::X509::ONELINE, OpenSSL::X509::MULTILINE.

	* ext/openssl/lib/openssl/x509.rb (OpenSSL::X509::Name::RFC2253DN):
	  new module to provide the parse for RFC2253 DN format.

	* ext/openssl/lib/openssl/x509.rb (OpenSSL::X509::Name.parse_rfc2253):
	  new method to parse RFC2253 DN format.

	* test/openssl/ossl_x509name.rb: add tests about RFC2253 DN.

	* text/openssl/ssl_server.rb: try to listen ports from 20443 to 20542
	  while EADDRINUSE is raised.

	* all changes in this entry are backport from 1.9.

Sun Dec 19 17:24:59 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (enable_rpath): use rpath flag to embed the library
	  path into extensions on ELF environment.  [ruby-dev:25035]

Sun Dec 19 11:01:25 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit.rb: use standalone runner for -e.

	* lib/test/unit/autorunner.rb (Test::Unit::AutoRunner#options): accept
	  multiple -p and -x options.

	* lib/test/unit/collector/dir.rb (Test::Unit::Collector::Dir#recursive_collect):
	  ditto.

Sat Dec 18 16:36:23 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/zlib/zlib.c (rb_deflate_s_deflate, rb_inflate_s_inflate):
	  disallow interrupt by type conversion.  fixed: [ruby-dev:25226]

Sat Dec 18 15:16:41 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/webrick/httpauth.rb,
	  lib/webrick/httpauth/{basicauth.rb,digestauth.rb}: use
	  pack/unpack-template char "m" instead of lib/base64.rb to do base64
	  encoding/decoding.

Sat Dec 18 10:51:01 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (dir_open_dir): new function.  [ruby-dev:25242]

Fri Dec 17 18:07:01 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* test/readline/test_readline.rb: fix for BSD. Thanks, GOTOU Yuuzou.
	  fixed: [ruby-dev:25218]

Fri Dec 17 16:28:12 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: fix bug on setting up system encoding

	* ext/tk/lib/tk/event.rb: fix error on require process

	* ext/tk/lib/tk/font.rb: fix abnormal termination error on Windows

	* ext/tk/lib/tk/virtevent.rb: TkVirtualEvent::PreDefVirtEvent.new()
	  accepts event-sequence arguments

	* ext/tk/lib/tk/text.rb: fail to dump embedded images

	* ext/tk/lib/tk/text.rb: tag_nextrange and tag_prevrange returns wrong
	  types of values

	* ext/tk/lib/tk/texttag.rb: nextrange and prevrange returns wrong
	  types of values

	* ext/tk/lib/tk/text.rb: add TkText::IndexModMethods module and
	  TkText::IndexString class to treat text index modifiers

	* ext/tk/lib/tk/texttag.rb: use TkText::IndexModMethods module

	* ext/tk/lib/tk/textmark.rb: ditto

	* ext/tk/lib/tk/textimage.rb: ditto

	* ext/tk/lib/tk/textwindow.rb: ditto

	* ext/tk/lib/tk/textimage.rb: wrong gravity of text mark for embedded
	  image

	* ext/tk/lib/tk/textwindow.rb: wrong gravity of text mark for
	  embedded window

Fri Dec 17 13:50:00 2004  Akiyoshi, Masamichi (akiyoshi@hp.com)

	* vms/vmsruby_private.c, vms/vmsruby_private.h: private routines
	  for VMS port are added.

	* eval.c (ruby_init): change to call VMS private intialization routine.

Fri Dec 17 13:33:58 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/cgi/session.rb (CGI::Session#initialize): control adding
	  session_id hidden fields.  fixed: [ruby-talk:123850]

Thu Dec 16 23:25:25 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb, lib/drb/ssl.rb: backported from CVS HEAD.
	  [druby-ja:101]

	* test/drb/test_drb.rb: adjust and reduce sleep (backported from
	  CVS HEAD.)

Thu Dec 16 18:44:58 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httpserver.rb (WEBrick::HTTPServer#run): should wait
	  for reading request till data arrive. [ruby-talk:121068]

	* lib/webrick/server.rb (WEBrick::GenericServer#start_thread):
	  should log about all accepted socket. [ruby-core:03962]

	* lib/webrick/accesslog.rb (WEBrick::AccessLog#setup_params):
	  "%%" and "%u" are supported. [webricken:135]

	* lib/webrick/httpservlet/filehandler.rb
	  (WEBrick::HTTPServlet::FileHandler#check_filename):
	  :NondisclosureName is acceptable if it is Enumerable.

	* lib/webrick/config.rb (WEBrick::Config::FileHandler):
	  default value of :NondisclosureName is [".ht*", "*~"].

Thu Dec 16 18:36:52 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl.c (ossl_raise): refine message format.

Thu Dec 16 16:29:44 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/sample/demos-en/widget: modify version check for
	  supporting features

Thu Dec 16 16:03:50 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/bindtag.rb: bug fix [ruby-talk: 123667]

	* ext/tk/lib/tk/timer.rb: accept :idle for the interval argument

	* ext/tk/lib/tk.rb: add TkComm._callback_entry?()

	* ext/tk/lib/multi-tk.rb: add MultiTkIp.cb_entry_class

	* ext/tk/lib/tk/canvas.rb: use TkComm._callback_entry?()

	* ext/tk/lib/tk/canvastag.rb: ditto

	* ext/tk/lib/tk/dialog.rb: ditto

	* ext/tk/lib/tk/optiondb.rb: ditto

	* ext/tk/lib/tk/text.rb: ditto

	* ext/tk/lib/tk/texttag.rb: ditto

	* ext/tk/lib/tk/textwindow.rb: ditto

	* ext/tk/lib/tk/timer.rb: ditto

	* ext/tk/lib/tk/validation.rb: ditto

	* ext/tk/lib/tkextlib/*: ditto

Thu Dec 16 03:14:28 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb (basic_encode): return value of pack('m') may
	  include multiple CR/LFs.  Backported from main trunk (rev 1.112).
	  [ruby-dev:25212]

Thu Dec 16 00:33:37 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (Init_Hash): remove custom "hash" and "eql?".

Wed Dec 15 18:57:01 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/set.rb (Set::eql): wrong definition.  [ruby-dev:25207]

Wed Dec 15 18:48:42 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/curses/curses.c (window_subwin): call NUM2INT() before
	GetWINDOW(). (backported from CVS HEAD)

Wed Dec 15 17:03:50 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.[ch] (rb_w32_isatty): new function to replace MSVCRT's
	  isatty because it never sets errno. (backported from CVS HEAD)

Wed Dec 15 15:39:32 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_x509name.c (ossl_x509name_to_a): avoid SEGV
	  (rollback the previous commit).

Wed Dec 15 16:10:23 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_obj_id_obsolete): warn always.

	* eval.c (rb_enable_super): ditto.

Wed Dec 15 15:31:02 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/set.rb (Set#==): [ruby-dev:25206]

Wed Dec 15 14:22:10 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_fdisset): check whether the handle is valid.
	  fixed: [ruby-core:03959]

Wed Dec 15 10:30:37 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/openssl/ossl_digest.c (ossl_digest_initialize): [ruby-dev:25198]

Tue Dec 14 17:10:09 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_close): need to reset osfhnd().

Tue Dec 14 14:03:57 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl.c (ossl_raise): avoid buffer overrun.
	  [ruby-dev:25187]

Tue Dec 14 12:36:04 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/cgi/session.rb (CGI::Session::initialize): generate new
	  session if given session_id does not exist.  [ruby-list:40368]

Mon Dec 13 18:13:52 2004  Tanaka Akira  <akr@m17n.org>

	* gc.c (stack_end_address): new function to obtain stack end address.
	  stack_end_address calls __builtin_frame_address(0) to obtain the
	  frame pointer of a stack frame of stack_end_address.  The address
	  is the stack pointer of the caller's stack frame.
	  (SET_STACK_END): use stack_end_address.
	  This makes the conservative garbage collector to scan a stack frame
	  of the garbage_collect function itself.  This is required because
	  callee-save registers may be stored in the frame.
	  [ruby-dev:25158]

Mon Dec 13 00:58:02 2004  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb (cleanpath_aggressive): make it private.
	  (cleanpath_conservative): ditto.
	  Suggested by Daniel Berger.  [ruby-core:3914]

Sun Dec 12 20:06:38 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb: backported from CVS HEAD.

Sun Dec 12 10:35:10 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/template/html/html.rb (RDoc::Page): Don't
	  show an accessor's r/w flag if none was specified

Sun Dec 12 10:14:03 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/rdoc.rb (RDoc::RDoc::parse_files): Never exclude files
	  explicitly given on the command line.

Sat Dec 11 20:12:21 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb: add DRbRemoteError. [ruby-list:40348],
	  [ruby-list:40390]

	* test/drb/drbtest.rb: ditto.

	* test/drb/ut_drb.rb: ditto.

Sat Dec 11 15:38:14 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/jcode.rb (String::succ): [ruby-dev:25156]

Sat Dec 11 12:41:55 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* eval.c (run_trap_eval): prototype; avoid VC++ warnings.

	* ext/socket/getaddrinfo.c: fix typo. fixed: [ruby-core:03947]

	* win32/win32.c: need to include dln.h.

Sat Dec 11 00:10:18 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_reopen): [ruby-dev:25150]

Fri Dec 10 08:39:27 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/socket.c (sock_listen): get OpenFile just before calling
	  listen(2).  fixed: [ruby-dev:25149]

Thu Dec  9 17:00:00 2004  Akiyoshi, Masamichi <akiyoshi@hp.com>

	* ext/socket/socket.c, ext/socket/getaddrinfo.c: port to VMS

Thu Dec  9 16:31:02 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/sdbm/init.c (GetDBM): typo.

Thu Dec  9 16:05:00 2004  Akiyoshi, Masamichi <akiyoshi@hp.com>

	* defines.h: change path of vms.h
	* vms/vms.h: delete reference for snprintf()
	* vms/config.h: new file
	* vms/config.h_in: deleted

Thu Dec  9 14:38:35 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_inspect): escape # which starts an expression
	  substitution.  fixed: [ruby-core:03922]

	* string.c (rb_str_dump): not escape # which isn't a substitution.

Thu Dec  9 10:54:36 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/dbm/dbm.c (fdbm_select): [ruby-dev:25132]

	* ext/sdbm/init.c: ditto.

	* ext/gdbm/gdbm.c: ditto.

Thu Dec  9 03:08:36 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c (ip_init): set root-win title to "ruby" when
	  the running script is '-e one-liner' or '-' (stdin).

	* ext/tcltklib/extconf.rb: add find_library("#{lib}#{ver}",..) for
	  stub libs

	* ext/tk/lib/tk/textmark.rb: TkTextMarkCurrent and TkTextMarkAnchor
	  have a wrong parent class.

	* ext/tk/lib/tk/dialog.rb: rename TkDialog2 --> TkDialogObj and
	  TkWarning2 --> TkWarningObj (old names are changed to alias names)

	* ext/tk/lib/tk/dialog.rb: bug fix of treatment of 'prev_command'
	  option and hashes for configuration

	* ext/tk/lib/tk/dialog.rb: add TkDialogObj#name to return the
	  button name

	* ext/tk/lib/tk/radiobutton.rb: rename enbugged method value() ==>
	  get_value() and value=(val) ==> set_value(val).

	* ext/tk/lib/tk/menu.rb: add TkMenu.new_menuspec

	* ext/tk/lib/tk/menu.rb: add alias (TkMenuButton = TkMenubutton,
	  TkOptionMenuButton = TkOptionMenubutton)

	* ext/tk/lib/tk/event.rb: new method aliases (same as option keys of
	  event_generate) for Event object

	* ext/tk/lib/tk/font.rb: configinfo returns proper types of values

	* ext/tk/lib/tk.rb: bind methods accept subst_args + block

	* ext/tk/lib/tk/canvas.rb: ditto

	* ext/tk/lib/tk/canvastag.rb: ditto

	* ext/tk/lib/tk/frame.rb: ditto

	* ext/tk/lib/tk/text.rb: ditto

	* ext/tk/lib/tk/texttag.rb: ditto

	* ext/tk/lib/tk/toplevel.rb: ditto

	* ext/tk/lib/tkextlib/*: ditto and bug fix

Wed Dec  8 23:54:29 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/template/html/html.rb (RDoc::Page): Typo
	  meant that h2 tag was invisible.

Wed Dec  8 21:56:31 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss, test/rss, sample/rss: backported from CVS HEAD.

Wed Dec  8 14:31:36 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_fwrite): change dereference for cosmetic reason.

	* sprintf.c (rb_f_sprintf): [ruby-dev:25104]

Tue Dec  7 19:08:00 2004  Akiyoshi, Masamichi <akiyoshi@hp.com>

	* io.c (io_fwrite): fix offset incrementation (for VMS and Human68k)

Tue Dec  7 00:27:37 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* process.c (proc_setgroups): [ruby-dev:25081]

Mon Dec  6 18:08:10 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_eqq): document fix.  [ruby-talk:122541]

Mon Dec  6 17:19:13 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* rubysig.h (TRAP_BEG, TRAP_END): safe errno around CHECK_INTS.
	  (backported from CVS HEAD)  [ruby-dev:24993]

Mon Dec  6 10:18:17 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::look_for_directives_in):
	  Oops - 1.8 doesn't have String#clear

Mon Dec  6 09:59:23 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (sock_connect): use rb_str_new4().
	  [ruby-dev:25052]

Mon Dec  6 01:42:08 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_pkey_rsa.c (ossl_rsa_public_encrypt,
	  ossl_rsa_public_decrypt, ossl_rsa_private_encrypt,
	  ossl_rsa_private_decrypt): should take an optional argument
	  to specify padding mode. [ruby-talk:122539]

	* ext/openssl/ossl_pkey_rsa.c (Init_ossl_rsa): add new constants
	  PKCS1_PADDING, SSLV23_PADDING, NO_PADDING and PKCS1_OAEP_PADDING
	  under OpenSSL::PKey::RSA.

	* test/openssl/test_pkey_rsa.rb: new file.

Sun Dec  5 19:39:17 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::Completion#complete): new parameter
	  to direct case insensitiveness.

	* lib/optparse.rb (OptionParser#order!): ignore case only for long
	  option.  [ruby-dev:25048]

Sat Dec  4 22:54:15 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_write): remove rb_str_locktmp().  [ruby-dev:25050]

	* io.c (io_fwrite): takes VALUE string as an argument.
	  [ruby-dev:25050]

	* ext/socket/socket.c (sock_connect): remove rb_str_locktmp().
	  [ruby-dev:25050]

	* ext/socket/socket.c (udp_connect): [ruby-dev:25045]

	* ext/socket/socket.c (udp_bind): ditto.

	* ext/socket/socket.c (udp_send): ditto.

	* ext/socket/socket.c (bsock_send): ditto.

	* ext/socket/socket.c (s_recvfrom): ditto.

	* hash.c (rb_hash_hash): should provide "hash" method where "eql?"
	  is redefined.  [ruby-talk:122482]

Sat Dec  4 14:54:52 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* eval.c (proc_invoke): use volatile `tmp' rather than `args'.
	  [ruby-core:03882]

Sat Dec  4 14:28:56 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/code_objects.rb (RDoc::Context::Section::set_comment):
	  Section comments may now be bracketed by lines which are
	  ignored. You can now write
	      # -----------
	      # :section: Dave's Section
	      # comment material
	      # -----------
	   The lines before :section: are removed, and identical lines at the end are
	   also removed if present.

Sat Dec  4 03:33:45 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/readline/readline.c: check $SAFE. (backported from CVS HEAD)

	* test/readline/test_readline.rb: added tests for readline.
	  (backported from CVS HEAD)

Fri Dec  4 02:24:00 2004  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf.c: add constant NKF::VERSION

	* ext/nkf/nkf.c(guess): this becomes an alias of guess2

	* ext/nkf/test.rb(mime_out2): add --no-cp932

	* ext/nkf/nkf-utf8/nkf.c: original nkf2 revision 1.47

Sat Dec  4 00:35:08 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (bsock_setsockopt): [ruby-dev:25039]

Fri Dec  3 18:57:03 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/ostruct.rb: 1.9 marshaling support back-ported.
	  [ruby-core:03871]

Fri Dec  3 13:45:20 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_invoke): copy arguments to frame.argv.
	  [ruby-core:03861]

Fri Dec  3 12:25:41 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* st.h: fix prototypes.

Fri Dec  3 00:21:05 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (convert_type): use rb_respond_to() again.
	  [ruby-dev:25021]

	* eval.c (rb_respond_to): funcall respond_to? if it's redefined.
	  [ruby-dev:25021]

Fri Dec  3 01:55:24 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: widget configuration by TkWindow#method_missing
	  returns proper object. "widget.option = val" returns val, and
	  "widget.option(val)" returns self.

	* ext/tk/lib/tk/font.rb: TkFont#replace accepts only one font argument.

	* ext/tk/lib/tk/radiobutton.rb: add TkRadiobutton#value and
	  TkRadiobutton#value=(val).

	* ext/tk/lib/tk/spinbox.rb: callback substitution support on
	  command option.

	* ext/tk/sample/demos-en/widget: bug fix (wrong image height)

	* ext/tk/sample/demos-jp/widget: ditto.

Fri Dec  3 00:11:48 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_file_initialize): [ruby-dev:25032]

Thu Dec  2 16:41:03 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_protect): prevent continuations created inside from being
	  called from the outside.  [ruby-dev:25003]

	* eval.c (rb_callcc, rb_cont_call): prohibit calling from different
	  signal contexts.  [ruby-dev:25022]

Thu Dec  2 09:57:24 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/ostruct.rb (OpenStruct::Marshaler): OpenStruct can be
	  marshaled again.  [ruby-core:03862]

Thu Dec  2 09:30:06 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (thread_mark): mark thread group.  [ruby-dev:25020]

	* eval.c (thgroup_add): check whether the argument is really a Thread.

Thu Dec  2 07:57:16 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_ctl): [ruby-dev:25019]

Wed Dec  1 02:21:02 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* signal.c (sighandler): call handler immediately only for default
	  handlers.  [ruby-dev:25003]

Tue Nov 30 23:38:18 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_fread): need not to null terminate.  [ruby-dev:24998]

	* io.c (read_all): remove unnecessary rb_str_resize().
	  [ruby-dev:24996]  (backported from CVS HEAD)

	* io.c (io_readpartial): ditto.

	* io.c (io_read): ditto.

Tue Nov 30 16:18:50 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_fread): need not to null terminate.  [ruby-dev:24998]

	* io.c (read_all): remove unnecessary rb_str_resize().
	  [ruby-dev:24996]

	* io.c (io_read): ditto.

Tue Nov 30 00:49:08 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_sysread): use temporary lock.  [ruby-dev:24992]

Mon Nov 29 16:06:04 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_write): insufficiently filled string
	  being extended when overwriting.  [ruby-core:03836]

Mon Nov 29 15:59:05 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/ostruct.rb (OpenStruct::method_missing): check method
	  duplication for -d.

	* lib/ostruct.rb (OpenStruct::initialize): ditto.

Mon Nov 29 15:22:28 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/io/nonblock/test_flush.rb: abandon tests when io/nonblock is
	  not supported.

Mon Nov 29 03:08:30 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (convert_type): [ruby-core:03845]

	* eval.c (rb_funcall_rescue): new function.

	* object.c (rb_Array): avoid using rb_respond_to().

	* object.c (rb_Integer): ditto.

	* parse.y (reduce_nodes): empty body should return nil.

	* string.c (rb_str_aset): [ruby-dev:24981]

Mon Nov 29 13:57:38 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (CreateChild): search executable file if no program
	  name given. (backported from CVS HEAD)

Mon Nov 29 13:37:54 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (fptr_finalize): must not use FILE after fclose().
	  [ruby-dev:24985]

Mon Nov 29 13:16:31 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (CreateChild): push back the last space before next
	  loop because CharNext() eats it.

Mon Nov 29 01:18:18 2004  Tanaka Akira  <akr@m17n.org>

	* io.c (rb_io_check_writable): call io_seek regardless of
	  NEED_IO_SEEK_BETWEEN_RW.  [ruby-dev:24986]

Sat Nov 27 21:43:39 2004  Tanaka Akira  <akr@m17n.org>

	* io.c: avoid data lost with nonblocking fd and
	  stdio buffering in sync mode.  [ruby-dev:24966]
	  based on matz's patch [ruby-dev:24967]
	  (io_fwrite): new primitive writing function which writes
	  directly if sync mode.
	  (rb_io_fwrite): wrapper for io_fwrite now.
	  (io_write): call io_fwrite instead of rb_io_fwrite.

Sat Nov 27 14:44:15 2004  Kent Sibilev  <ksibilev@bellsouth.net>

	* lib/cgi/session.rb (CGI::Session::initialize): [ruby-core:03832]

Sat Nov 27 09:41:21 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_fread): old rb_io_fread with file closing checking.
	  (rb_io_fread): wrapper for io_fread now.
	  [ruby-dev:24964]

Fri Nov 26 18:02:44 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: Tk.destroy uses TkWindow#epath

	* ext/tk/lib/tk/image.rb: bug fix

	* ext/tk/lib/tk/wm.rb: add 'iconphoto' method(Windows only)

	* ext/tk/lib/tkextlib/*: some methods uses TkWindow#epath

Fri Nov 26 13:49:06 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (method_missing): raise TypeError for classes do not
	  have allocators.  [ruby-core:03752]

	* lib/erb.rb: add RDoc by James Edward Gray II.  [ruby-core:03786]

Fri Nov 26 13:29:02 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::look_for_directives_in): Break
	  out of preprocessing when we find a :section: directive (previously cleared out the
	  comment, but this apparently now generates an error in gsub!)

Fri Nov 26 00:17:40 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_read): move StringValue() check before GetOpenFile().
	  [ruby-dev:24959]

Thu Nov 25 20:14:57 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/thwait.rb (ThreadsWait#join_nowait): abnormally terminated
	  threads should be also processed.  [ruby-talk:121320]

Thu Nov 25 10:14:26 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (push_braces): do not reuse buffer strings.  [ruby-core:03806]

Thu Nov 25 07:59:41 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (read_all): stringify non-nil buffer argument, and always
	  taint the result.  [ruby-dev:24955]

Wed Nov 24 01:01:31 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_read): integer conversion should be prior to
	  GetOpenFile().  [ruby-dev:24952]

	* configure.in, io.c: cancel [ ruby-Patches-1074 ].

Tue Nov 23 08:09:50 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/menu.rb: improve usability of TkOptionMenubutton

Tue Nov 23 02:00:21 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_file_chown): integer conversion should be prior to
	  GetOpenFile().  [ruby-dev:24949]

Tue Nov 23 00:10:48 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_file_chown): integer conversion should be prior to
	  GetOpenFile().  [ruby-dev:24947]

	* file.c (rb_file_truncate): ditto.

	* file.c (rb_file_s_truncate): ditto.

	* dir.c (dir_seek): use NUM2OFFT().

	* misc/ruby-mode.el (ruby-non-block-do-re): [ruby-core:03719]

Mon Nov 22 22:33:02 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::parse_require): Don't use names
	  of variables or constants when oarsing 'require'

Mon Nov 22 00:13:35 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (dir_seek): should retrieve dir_data after NUM2INT().
	  [ruby-dev:24941]

Sat Nov 20 23:57:33 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/README (et al): Add a new directive, :section:, and
	  change the output format to accomodate. :section: allows to to
	  group together methods, attributes, constants, etc under
	  headings in the output. If used, a table of contents is
	  generated.

Sat Nov 20 23:56:54 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/options.rb (Options::parse): Force --inline-source if
	  --one-file option given

Sat Nov 20 23:55:19 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_splice): should place index wrapping after
	  possible modification.  [ruby-dev:24940]

Tue Nov 20 13:26:03 2004  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/utf8tbl.c: original revision 1.7

Tue Nov 20 05:34:24 2004  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c: original nkf.c rev:1.40

	* ext/nkf/test.rb: add test for mime encode/decode

Sat Nov 20 01:37:34 2004  Johan Holmberg  <holmberg@iar.se>

	* eval.c (error_print): nicer traceback at interrupt.
	  [ruby-core:03774]

Sat Nov 20 00:07:16 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (str_gsub): internal buffer should not be listed by
	  ObjectSpace.each_object() by String#gsub.  [ruby-dev:24931]

Fri Nov 19 01:20:22 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/cgi/session.rb (CGI::Session::FileStore::initialize): raise
	  exception if data corresponding to session specified from the
	  client does not exist.

Fri Nov 19 00:59:31 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (str_gsub): internal buffer should not be listed by
	  ObjectSpace.each_object().  [ruby-dev:24919]

Thu Nov 18 18:41:08 2004  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/ruby/test_stringchar.rb (test_bang): added.

	* string.c (rb_str_upcase_bang, rb_str_capitalize_bang)
	(rb_str_swapcase_bang): missing rb_str_modify().  [ruby-dev:24915]

Thu Nov 18 00:21:15 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* process.c (proc_getpgrp): prohibit for $SAFE=2.
	  [ruby-dev:24899]

	* process.c (get_pid): ditto.  [ruby-dev:24904]

	* process.c (get_ppid): ditto.

	* array.c (rb_ary_delete): defer rb_ary_modify() until actual
	  modification.  [ruby-dev:24901]

Thu Nov 18 10:10:14 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c, rubyio.h (rb_io_modenum_flags): exported.

	* ext/stringio/stringio.c (strio_initialize): allow Fixnum as mode as
	  well as IO.new does.  [ruby-dev:24896]

Wed Nov 17 23:42:40 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* test/ruby/test_settracefunc.rb: added.  [ruby-dev:24884]

Wed Nov 17 13:56:57 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (newline_node): should not use FL_SET. [ruby-dev:24874]

	* parse.y (string_content): should not use FL_UNSET.

	* node.h (NODE_NEWLINE): remove unused bit to utilize flag field
	  in nodes.

Wed Nov 17 13:09:40 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* {bcc32,win32,wince}/Makefile.sub (test): should build ruby.exe
	  before running test. [ruby-core:03756]

Wed Nov 17 04:33:01 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* pack.c: all features are backport from 1.9. [ruby-dev:24826]

	* bignum.c (rb_big2ulong_pack): new function to pack Bignums.

Wed Nov 17 03:42:45 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_splice): move rb_str_modify() after
	  StringValue(), which may alter the receiver.  [ruby-dev:24878]

Tue Nov 16 23:45:07 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (flo_divmod): protect float values from GC by
	  assignment to local variables.  [ruby-dev:24873]

Tue Nov 16 16:30:21 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* {bcc32,win32,wince}/setup.mak (-epilogue-): remove config.h and
	  config.status to force updating them.

Tue Nov 16 16:20:45 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): position was ignored when a
	  buffer was passed.  http://www.yo.rim.or.jp/~nov/d/?date=20041116#p03

Tue Nov 16 11:19:07 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/autorunner.rb (Test::Unit::AutoRunner::options): use
	  Regexp conversion.

Tue Nov 16 01:41:31 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (str_mod_check): frozen check should be separated.
	  [ruby-core:3742]

	* array.c (rb_ary_update): pedantic check to detect
	  rb_ary_to_ary() to modify the receiver.  [ruby-dev:24861]

Mon Nov 15 13:50:52 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_justify): typo fixed.  [ruby-dev:24851]

Mon Nov 15 11:50:32 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-special-char-p, ruby-parse-partial): handle
	  operator symbols.  [ruby-talk:120177]

Sun Nov 14 13:27:03 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/pp.rb (PP#object_address_group): remove odd number of 'f'
	  prefixed to negative address.

Sun Nov 14 08:51:04 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* test/logger/test_logger.rb: Logger just expects
	  Logger#datetime_format to be used for Time#strftime independently of
	  locale. [ruby-dev:24828]

Fri Nov 12 15:03:26 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* eval.c (ruby_options): now we cannot call rb_glob() before
	  ruby_init(), so call rb_w32_cmdvector() at ruby_options().

	* win32.{c,h} (rb_w32_cmdvector): rename make_cmdvector() and
	  export it.

Fri Nov 12 14:08:01 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/event.rb: remove $LOADED_FEATURES trick

	* ext/tk/lib/tk.rb: ditto

Fri Nov 12 00:31:05 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/gdbm/gdbm.c (fgdbm_store): StringValue() may alter string
	  pointer.  [ruby-dev:24783]

Thu Nov 11 17:36:12 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (rb_globi): also should call back via rb_glob_caller().
	  [ruby-dev:24775]

Thu Nov 11 16:47:21 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_file.rb (test_truncate_wbuf): we want to test
	  only File#truncate, not behaviour of seek(2).

Thu Nov 11 09:41:01 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (push_braces): was confusing VALUE and char*.

	* dir.c (rb_push_glob): Dir.glob should have called its block.

Thu Nov 11 01:52:52 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (syserr_initialize): use stringified object.
	  [ruby-dev:24768]

Wed Nov 10 22:49:01 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/delegate.rb (SimpleDelegator::dup): wrong number of
	  arguments.

	* lib/delegate.rb (DelegateClass::dup): ditto.

Wed Nov 10 12:31:21 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* README.EXT (Example): extconf.rb is indispensable now.

Wed Nov 10 03:33:36 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: fix SEGV when compiled with Tcl/Tk8.3.x
	  or older

	* ext/tk/lib/tkextlib/tile/style.rb: bug fix

Tue Nov  9 14:27:18 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::Officious): moved from DefaultList.

Tue Nov  9 01:05:04 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (rb_glob2): do not allocate buffer from heap to avoid
	  memory leaks.  use string object for buffering instead.
	  [ruby-dev:24738]

	* dir.c (join_path): ditto.

	* io.c (io_read): external input buffer may be modified even after
	  rb_str_locktmp().  [ruby-dev:24735]

	* dir.c (fnmatch): p or s may be NULL.  [ruby-dev:24749]

Tue Nov  9 00:53:53 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* regex.c (slow_match): avoid GCC 3.4.x warnings.

Tue Nov  9 00:50:06 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/rdoc.rb: Change version numbering of RDoc and ri

Mon Nov  8 23:38:35 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/extservm.rb: add DRb::ExtServManager#uri=.
	  [ruby-dev:24743]

Mon Nov  8 22:20:19 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_class):
	  Fix bug where parent class wasn't being detected if the
	  child class was defined using the A::B notation.

Mon Nov  8 00:14:13 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: add setup for mignw32 cross compiling.
	  [ruby-talk:119413]

Sun Nov  7 23:49:26 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: bind-event methods accept multi substitution
	  arguments.

	* ext/tk/lib/tk/canvas.rb: ditto.

	* ext/tk/lib/tk/canvastag.rb: ditto.

	* ext/tk/lib/tk/text.rb: ditto.

	* ext/tk/lib/tk/texttag.rb: ditto.

	* ext/tk/lib/tkextlib: ditto.

Sat Nov  6 14:58:44 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/server.rb (WEBrick::HTTPServer#start): remove
	  :DoNotReverseLookup option. (Socket#do_not_reverse_lookup is a
	  ruby 1.9 feature)

Sat Nov  6 11:31:04 2004  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date.rb (_parse): checks whether zone was given.

Sat Nov  6 00:46:27 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_locktmp): check STR_TMPLOCK flag before
	  locking.  [ruby-dev:24727]

Fri Nov  5 18:12:42 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/scrollable.rb: divide Scrollable module into
	  X_Scrollable and Y_Scrollable

	* ext/tk/lib/tk/entry.rb: include X_Scrollable instead of Scrollable

	* ext/tk/lib/tk/autoload.rb: define autoload for X_Scrollable and
	  Y_Scrollable

Fri Nov  5 16:05:32 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: TkComm._at() supprts both of "@x,y" and "@x"

Fri Nov  5 13:22:58 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/text.rb: sorry. bug fix again.

Fri Nov  5 13:17:54 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/text.rb: bug fix

Fri Nov  5 08:52:48 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (gc_mark): stricter GC stack check.

Fri Nov  5 08:52:48 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (gc_mark): stricter GC stack check.

Fri Nov  5 08:34:43 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (str_gsub): should have removed rb_str_unlocktmp(str).
	  [ruby-dev:24708]

Thu Nov  4 21:25:38 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (str_gsub): string modify check no longer based on
	  tmplock.  [ruby-dev:24706]

Thu Nov  4 19:27:46 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (rb_f_open): fix typo.

Thu Nov  4 15:02:14 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/variable.rb: forget to initialize instance_variables
	  of TkVarAccess objects

Thu Nov  4 09:11:35 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (gc_mark): enable GC stack checking.

Thu Nov  4 03:11:33 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (str_gsub): lock strings temporarily.  [ruby-dev:24687]

	* ext/socket/socket.c (s_recvfrom): tmplock input buffer.
	  [ruby-dev:24705]

Wed Nov  3 22:32:12 2004  NARUSE, Yui  <naruse@ruby-lang.org>

	* process.c: On NetBSD don't use setruid() and setrgid().

Wed Nov  3 22:24:17 2004  Daigo Moriwaki  <techml@sgtpepper.net>

	* lib/webrick/httpauth/digestauth.rb: use Base64.encode64 to
	  avoid warnings.

Wed Nov  3 17:19:59 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_uniq_bang): do not push frozen string from hash
	  table.  [ruby-dev:24695]

	* array.c (rb_ary_and): ditto.

	* array.c (rb_ary_or): ditto.

Wed Nov  3 17:13:02 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* io.c (pipe_open): fix compile error

Wed Nov  3 16:58:07 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: support to use different Tcl commands between
	  configure and configinfo

	* ext/tk/lib/font.rb: ditto.

	* ext/tk/lib/itemconfig.rb: support to use different Tcl commands
	  between item_configure and item_configinfo

	* ext/tk/lib/itemfont.rb: ditto.

	* ext/tk/extconf.rb: install SUPPORT_STATUS

	* ext/tk/lib/tkextlib: some bug fixes (see ext/tk/ChangeLog.tkextlib)

Wed Nov  3 16:30:41 2004  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf: follow nkf 2.0.4

Wed Nov  3 15:53:34 2004  Kouhei Sutou  <kou@cozmixng.org>

	* test/rss/test_maker_*.rb: added tests for RSS Maker.

	* lib/rss/maker.rb: added RSS Maker.

	* lib/rss/maker/*.rb: ditto.

Tue Nov  2 16:35:57 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/enumerator/enumerator.c (each_cons_i): pass copy of an
	  internal consequent array.  [ruby-talk:118691]

Tue Nov  2 16:05:21 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* process.c (rb_f_fork): need to flush stdout and stderr before
	  fork(2).  [ruby-talk:117715]

Tue Nov  2 01:20:09 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_invoke): nail down dyna_var node when Proc object
	  or continuation is created.  [ruby-dev:24671]

Mon Nov  1 13:59:28 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb (MANIFEST): do not use anymore, use extconf.rb instead.

	* ext/enumerator/extconf.rb, ext/fcntl/extconf.rb,
	  ext/stringio/extconf.rb: added.

	* MANIFEST, ext/**/MANIFEST: removed.

	* README.EXT, README.EXT.ja: remove MANIFEST stuff.

Mon Nov  1 01:14:52 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_f_open): create copy of popen specifier.  [ruby-dev:24656]

Mon Nov  1 00:36:48 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* main.c (_stklen): move to gc.c.

Sun Oct 31 00:22:28 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_locktmp): lock string temporarily.

	* string.c (str_independent): add tmplock check.

	* io.c (io_write): lock output string temporarily.
	  [ruby-dev:24649]

	* io.c (io_write): use rb_str_locktmp().

	* io.c (read_all): ditto.

Sat Oct 30 06:53:24 2004  Peter Vanbroekhoven  <peter.vanbroekhoven@cs.kuleuven.ac.be>

	* eval.c (rb_eval): NODE_XSTR should pass copy of literal string.

Sat Oct 30 00:19:40 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* enum.c (enum_sort_by): protect continuation jump in.
	  [ruby-dev:24642]

Fri Oct 29 21:27:51 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_check_initialized): new function to check uninitialized
	  object.  [ruby-talk:118234]

	* file.c (rb_file_path), io.c (rb_io_closed): check if initialized.

Fri Oct 29 10:00:30 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_start_0): forget to free some memory chunks.
	  [ruby-core:03611]

	* eval.c (ruby_cleanup): ruby_finalize_1 may cause exception,
	  should be wrapped by PUSH_TAG/POP_TAG().  [ruby-dev:24627]

Thu Oct 28 08:42:02 2004  Tanaka Akira  <akr@m17n.org>

	* io.c (argf_forward): use ANSI style.
	  (argf_read): call argf_forward with argv argument.
	  [ruby-dev:24624]

Thu Oct 28 23:32:54 2004  akira yamada  <akira@ruby-lang.org>

	* ext/zlib/zlib.c (zstream_detach_input): resets klass of z->input if
	  z->input isn't nil.

Thu Oct 28 23:19:31 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/extmk.rb: prefer relative path.  [ruby-talk:93037]

Wed Oct 27 18:49:11 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* gc.c: prototype; rb_io_fptr_finalize() doesn't return any value
	  at this version.

Wed Oct 27 17:27:45 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (gc_sweep): recover ruby_in_compile variable.

Wed Oct 27 09:17:30 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_gsub): use a string object for exception safeness.
	  [ruby-dev:24601]

Tue Oct 26 23:52:32 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_getline): rs modification check should not interfere in the loop.

Tue Oct 26 23:30:39 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/code_objects.rb (RDoc::Context::add_class_or_module):
	  Restore correct :nopdoc: behavior with nested classes and modules.

Tue Oct 26 18:21:29 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (RESIZE_CAPA): check string attribute before modifying
	  capacity member of string structure.  [ruby-dev:24594]

Tue Oct 26 11:33:26 2004  David G. Andersen  <dga@lcs.mit.edu>

	* ext/zlib/zlib.c (gzreader_gets): use memchr() to to gain
	  performance.  [ruby-talk:117701]

Tue Oct 26 10:56:55 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* sprintf.c (rb_f_sprintf): raise ArgumentError for extra
	  arguments, unless (digit)$ style used.

Tue Oct 26 11:33:26 2004  David G. Andersen  <dga@lcs.mit.edu>

	* ext/zlib/zlib.c (gzreader_gets): use memchr() to to gain
	  performance.  [ruby-talk:117701]

Tue Oct 26 10:56:55 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* sprintf.c (rb_f_sprintf): raise ArgumentError for extra
	  arguments, unless (digit)$ style used.

Mon Oct 25 18:35:39 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c (isUNCRoot): should check NUL after '.'.
	  [ruby-dev:24590]

	* win32/win32.c (isUNCRoot): fixed buffer overrun.

Mon Oct 25 08:03:26 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (get_backtrace): ignore illegal backtrace.  [ruby-dev:24587]

Sun Oct 24 00:41:09 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_load, search_required, rb_require_safe, rb_require): use
	  frozen shared string to avoid outside modification.  [ruby-dev:24580]

Sat Oct 23 22:18:32 2004  Guy Decoux  <ts@moulon.inra.fr>

	* eval.c (frame_free): Guy Decoux solved the leak problem.
	  Thanks.  [ruby-core:03549]

Sat Oct 23 00:20:55 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/zlib/zlib.c (zstream_append_input): clear klass for z->input
	  to avoid potential vulnerability.

	* ext/zlib/zlib.c (zstream_run): always use zstream_append_input()
	  to avoid SEGV.  [ruby-dev:24568]

Fri Oct 22 12:02:28 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_alias): was warning for wrong condition.
	  [ruby-dev:24565]

Fri Oct 22 10:36:37 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httprequest.rb (WEBrick::HTTPRequest#meta_vars):
	  should check if path_info is not nil.

Fri Oct 22 00:22:31 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/zlib/zlib.c (zstream_shift_buffer): should restore class
	  field of a buffer.  [ruby-dev:24562]

Fri Oct 22 00:20:33 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_include): should not treat char as negative value.
	  [ruby-dev:24558]

Thu Oct 21 21:32:30 2004  IWATSUKI Hiroyuki  <don@na.rim.or.jp>

	* lib/pstore.rb (PStore#transaction): Use the empty content when a
	  file is not found.  [ruby-dev:24561]

Thu Oct 21 19:06:15 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httpresponse.rb (WEBrick::HTTPResponse#send_body_io):
	  ensure to close @body. (http://bugs.debian.org/277520)

Thu Oct 21 00:36:41 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_alias): should warn on method discarding.
	  [ruby-dev:24546]

	* ext/zlib/zlib.c (zstream_expand_buffer_into): hide internal
	  string buffer by clearing klass.  [ruby-dev:24548]

Wed Oct 20 19:45:13 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (str_gsub): 	reentrant check.  [ruby-dev:24432]

	* backport all SEGV bug fixes from CVS HEAD.  [ruby-dev:24536]

Wed Oct 20 04:17:55 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/dbm/dbm.c (fdbm_delete_if): should check if deleting element
	  is a string.  [ruby-dev:24490]

	* ext/sdbm/init.c (fsdbm_delete_if): ditto.

Wed Oct 20 01:37:18 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_times): Array#* should return an instance of
	  the class of right operand.  [ruby-dev:24526]

	* ext/zlib/zlib.c (zstream_detach_buffer): should not expose
	  class-less object to Ruby world. [ruby-dev:24530]

	* eval.c (proc_dup): provide Proc#dup as well.  [ruby-talk:116915]

	* eval.c (ruby_exec): stack marking position may be higher than
	  expected.  thanks to Guy Decoux.  [ruby-core:03527]

Tue Oct 19 22:43:12 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_attr): If
	  we come across 'attr' in a context where it isn't
	  followed by a symbol, just issue a warning.

Tue Oct 19 20:41:37 2004  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole.c(ole_invoke): retrieve the result value when
	  retrying the IDispatch::invoke.

Tue Oct 19 17:24:11 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (read_all): block string buffer modification during
	  rb_io_fread() by freezing it temporarily. [ruby-dev:24479]

	* dir.c (rb_push_glob): block call at once the end of method.
	  [ruby-dev:24487]

	* ext/enumerator/enumerator.c (enum_each_slice): remove
	  rb_gc_force_recycle() to prevent potential SEGV.
	  [ruby-dev:24499]

	* ext/zlib/zlib.c (zstream_expand_buffer): hide internal string
	  buffer by clearing klass.  [ruby-dev:24510]

Tue Oct 19 16:12:18 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/tkutil.c: backport from CVS HEAD

Tue Oct 19 08:54:26 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* intern.h, object.c (rb_class_inherited_p): export.

Tue Oct 19 08:46:57 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_upto): method result must be checked.  [ruby-dev:24504]

	* eval.c (error_print): ditto.  [ruby-dev:24519]

Mon Oct 18 23:37:05 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (r_object0): check inheritance by the internal function.
	  [ruby-dev:24515]

Mon Oct 18 15:58:01 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* range.c (range_step, range_each): need cast.

Fri Oct 29 16:34:19 2004  Daiki Ueno  <ueno@unixuser.org>

	* misc/ruby-mode.el (ruby-parse-partial): Parse the rest of the
	line after opening heredoc identifier.  [ruby-dev:24635]

Mon Oct 18 07:26:21 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_truncate): discard read buffer before truncation.
	  [ruby-dev:24197]

Mon Oct 18 02:11:21 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/config.rb (WEBrick::Config::General): add default values:
	  - WEBrick::Config[:DoNotReverseLookup]
	  - WEBrick::Config[:RequestCallback] (it used as an alias of
	    :RequestHandler in WEBrick::HTTPServer#run)
	  - WEBrick::Config::FileHandler[:AcceptableLanguages]

	* lib/webrick/httpservlet/filehandler.rb
	  (WEBrick::HTTPServlet::FileHandler#set_filename): search files
	  having suffix of language-name which Accept-Language header field
	  includes if :AcceptableLanguages options is present.

	* lib/webrick/httpservlet/filehandler.rb
	  (WEBrick::HTTPServlet::FileHandler#get_servlet): new method to
	  search servlet correspond to the suffix of filename.

	* lib/webrick/httprequest.rb: add attributes access methods: accept,
	  accept_charset, accept_encoding, accept_language, content_length
	  and content_type.

	* lib/webrick/httpresponse.rb: add attribute access methods:
	  content_length, content_length=, content_type and content_type=.

	* lib/webrick/httputils.rb (WEBrick::HTTPUtils.mime_types):
	  use the second suffix to detect media type. (the first suffix
	  may be a language name.)

	* lib/webrick/httputils.rb (WEBrick::HTTPUtils.parse_qvalues):
	  add method to parse Accept header field. it returns an Array of
	  values sorted by the qvalues.

Mon Oct 18 02:04:11 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httpserver.rb (WEBrick::HTTPServer#virtual_host): new
	  method to register virtual hosting servers.

	* lib/webrick/server.rb (WEBrick::GenericServer#accept): call
	  do_not_reverse_lookup for each socket if :DoNotReverseLookup
	  is set.  [ruby-core:02357]

Sun Oct 17 23:03:48 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/timer.rb: TkTimer#start and restart accept a block

Sun Oct 17 13:05:04 2004  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (fole_func_methods): correct argument mismatch.
	* ext/win32ole/win32ole.c (fole_get_methods): ditto.
	* ext/win32ole/win32ole.c (fole_put_methods): ditto.
	* ext/win32ole/tests/testWIN32OLE.rb: add test for WIN32OLE#ole_func_methods
	  WIN32OLE#ole_get_methods, WIN32OLE#ole_put_methods

Sat Oct 16 14:45:28 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/0.9.rb (RSS::Rss#to_s): removed garbage.

Sat Oct 16 13:42:49 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/: untabified.
	* test/rss/: untabified.
	* lib/rss/0.9.rb (RSS::Rss#to_s): inent -> indent.

Sat Oct 16 13:34:56 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss: supported prety print.
	* test/rss/test_1.0.rb: added test for calculating default indent size.

Fri Oct 15 18:04:35 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/timer.rb: TkTimer.new(interval, loop){ ... } is
	  acceptable. Add TkTimer.start ( == new + start ).

Fri Oct 15 12:43:09 2004  Tanaka Akira  <akr@m17n.org>

	* eval.c (Init_stack): make prototype declaration consistent with
	  the definition in gc.c.

Thu Oct 14 14:34:01 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* io.c (MODE_BINMODE, MODE_BINARY): fixed reversed condition.

Thu Oct 14 13:33:59 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/rss.rb: added link to Tutorial.

Mon Oct 11 13:48:20 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/*: untabify

Sun Oct 10 12:32:08 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::parse_require): Allow 'require'
	  to be used as a variable name

Sat Oct  9 21:23:37 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/converter.rb: changed to try to use Iconv for default
	  conversion.

	* lib/rss/rss.rb: 0.0.9 -> 0.1.0.

Sat Oct  9 19:50:36 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_getline): should not treat char as negative value.
	  [ruby-dev:24460]

Fri Oct  8 09:49:32 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): pointer modification check before each
	  iteration.  [ruby-dev:24445]

Fri Oct  8 01:13:05 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/optiondb.rb: make it more secure

Thu Oct  7 23:47:57 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/scrollbar.rb: When 'set' operation, a scrollbar
	  cannot propagate view port information from the source widget
	  (that calls 'set') to other assigned widgets.

Thu Oct  7 17:36:25 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: When CHILDKILLED and so on, Tk.errorCode returns
	  a Fixnum for 2nd element (it's pid) of the return value.

Thu Oct  7 12:55:04 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_read): should freeze buffer before thread context
	  switch. [ruby-dev:24442]

	* pack.c (pack_unpack): string conversion should at the top of the
Mon Oct 18 00:42:45 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (sock_s_getservbyaname): protocol string
	  might be altered.  [ruby-dev:24503]

	* string.c (rb_str_upto): check if return value from succ is a
	  string.  [ruby-dev:24504]

	  method.  [ruby-dev:24439]

	* io.c (io_read): buffer should be frozen only after the length
	  check.  [ruby-dev:24440]

Thu Oct  7 02:56:43 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c: use FMODE_APPEND.

Thu Oct  7 01:05:33 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: add Tk.errorInfo and Tk.errorCode

Thu Oct  7 00:08:37 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_s_sysopen): preserve path in the buffer allocated by
	  ALLOCA_N() to prevent modification.  [ruby-dev:24438]

Wed Oct  6 09:21:00 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_mode_flags): preserve append mode flag.
	  [ruby-dev:24436]

	* io.c (rb_io_modenum_mode): do not use external output buffer.

	* string.c (rb_str_justify): differ pointer retrieval to prevent
	  padding string modification.  [ruby-dev:24434]

	* range.c (range_each_func): allow func to terminate loop by
	  returning RANGE_EACH_BREAK.

	* range.c (member_i): use RANGE_EACH_BREAK. [ruby-talk:114959]

Mon Oct  4 14:04:14 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_file_open_internal, rb_io_reopen): fname might be altered
	  while GC.  [ruby-dev:24408]

Mon Oct  4 12:53:45 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/optiondb.rb: support definition of command
	  resources on widgets

	* ext/tk/lib/tk/image.rb: bug fix

Sun Oct  3 21:20:03 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (TEXT_REGEXP): allow 8-bit characters for the german
	version of Microsoft Exchange Server. (backported from HEAD)

	* lib/net/imap.rb (RTEXT_REGEXP): ditto.

	* lib/net/imap.rb (CTEXT_REGEXP): ditto.

Sat Oct  2 20:34:22 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* node.h (NEW_DVAR): extra semicolon.

Sat Oct  2 00:42:20 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (r_byte): retrieve pointer from string value for each
	  time.  [ruby-dev:24404]

	* marshal.c (r_bytes0): ditto.

	* enum.c (sort_by_i): re-entrance check added.  [ruby-dev:24399]

	* io.c (io_read): should freeze all reading buffer.
	  [ruby-dev:24400]

	* string.c (rb_str_sum): should use bignums when bits is greater
	  than or equals to sizeof(long)*CHAR_BITS. [ruby-dev:24395]

	* eval.c (specific_eval): defer pointer retrieval to prevent
	  unsafe sourcefile string modification.  [ruby-dev:24382]

	* eval.c (specific_eval): defer pointer retrieval to prevent
	  unsafe sourcefile string modification.  [ruby-dev:24382]

	* string.c (rb_str_sum): wrong cast caused wrong result.
	  [ruby-dev:24385]

	* enum.c (enum_sort_by): hide temporary array from
	  ObjectSpace.each_object.  [ruby-dev:24386]

	* string.c (rb_str_sum): check was done with false pointer.
	  [ruby-dev:24383]

	* string.c (rb_str_sum): string may be altered.  [ruby-dev:24381]
Mon Oct 11 17:51:34 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_popen): get mode string via rb_io_flags_mode() to
	  avoid mode string modification.  [ruby-dev:24454]

	* io.c (rb_io_getline_fast): should take delim as unsigned char to
	  distinguish EOF and '\377'.  [ruby-dev:24460]

	* io.c (rb_io_getline): add check for RS modification.
	  [ruby-dev:24461]

	* enum.c (enum_sort_by): use qsort() directly instead using
	  rb_iterate().  [ruby-dev:24462]

	* enum.c (enum_each_with_index): remove rb_gc_force_recycle() to
	  prevent access to recycled object (via continuation for
	  example).  [ruby-dev:24463]


Fri Oct  1 11:40:14 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_f_eval): defer pointer retrieval to prevent unsafe
	  sourcefile string modification.  [ruby-dev:24373]

	* io.c (io_read): block string buffer modification during
	  rb_io_fread() by freezing it temporarily. [ruby-dev:24366]

	* io.c (rb_io_s_popen): mode argument may be altered.
	  [ruby-dev:24375]

	* file.c (rb_file_s_basename): ext argument may be altered.
	  [ruby-dev:24377]

	* enum.c (enum_sort_by): use NODE instead of 2 element arrays.
	  [ruby-dev:24378]

	* string.c (rb_str_chomp_bang): StringValue() may change the
	  receiver.  [ruby-dev:24371]

Fri Oct  1 11:25:20 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/grid.rb: revive TkGrid.grid

	* ext/tk/lib/tk/pack.rb: revive TkPack.pack

	* ext/tk/lib/tk/place.rb: revive TkPlace.place

Thu Sep 30 00:50:44 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

Sat Oct  9 00:25:39 2004  Tanaka Akira  <akr@m17n.org>

	* io.c (rb_io_fread): rb_thread_wait_fd() was lost.
	  [ruby-dev:24457]

	* ext/tcltklib/tcltklib.c (ip_init): bug fix

	* ext/tk/tkutil.c (get_eval_string_core): accept a Regexp object

	* ext/tk/lib/multi-tk.rb: fix bug on 'exit' operation

	* ext/tk/lib/tk/text.rb: 'tksearch' accepts a Regexp object as a
	  matting pattern argument

Wed Sep 29 10:58:07 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enum.c (sort_by_i): internally used object must not be changed
	  outside.  [ruby-dev:24368]

Mon Sep 27 13:46:45 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* intern.h, struct.c (rb_struct_s_members, rb_struct_members): public
	  accessors.  [ruby-dev:24342]

	* marshal.c (w_object, r_object0): use accessors.

Mon Sep 27 09:14:03 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (s_accept): don't retry for EWOULDBLOCK.
	  [ruby-talk:113807]

Fri Sep 24 16:09:42 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_invoke): propagate DVAR_DONT_RECYCLE on termination
	  to avoid double call to rb_gc_force_recycle(). [ruby-dev:24311]

Fri Sep 24 08:29:45 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_subseq): original object might be modified after
	  sharing data creation.  [ruby-dev:24327]

	* array.c (rb_ary_replace): ditto.

	* array.c (ary_make_shared): freeze shared array. [ruby-dev:24325]

	* struct.c (struct_members): always check struct size and size of
	  members list in the class.  [ruby-dev:24320]

Thu Sep 23 09:29:14 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_sub_bang): check if string is not modified
	  during iteration.  [ruby-dev:24315]

	* hash.c (rb_hash_rehash): replace st_foreach() by its deep
	  checking counterpart.  [ruby-dev:24310]

Wed Sep 22 13:38:12 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_hash_rehash): add iteration check.  [ruby-dev:24301]

	* st.c (st_foreach): add deep check.

Wed Sep 22 13:06:14 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_call_handler): workaround for Ctrl-C.
	  merge from HEAD.

Wed Sep 22 00:11:12 2004  Dave Thomas  <dave@pragprog.com>

	* process.c: Add documentation for fork()

Wed Sep 22 09:04:41 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_collect_bang): element size might change during
	  comparison.  [ruby-dev:24300]

	* array.c (rb_ary_reject_bang): ditto. [ruby-dev:24300]

	* array.c (rb_ary_eql): ditto. [ruby-dev:24300]

Tue Sep 21 18:29:49 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_equal): merge miss.

	* array.c (rb_ary_uniq_bang): element size might change during
	  comparison.  [ruby-dev:24298]

Mon Sep 20 00:24:19 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* enum.c (enum_sort_by): do not use qsort directly.  use
	  rb_ary_sort_bang() instead.  [ruby-dev:24291]

	* enum.c (enum_sort_by): pedantic type check added.
	  [ruby-dev:24291]

	* hash.c (rb_hash_foreach_iter): check iter_lev after each
	  iteration.  [ruby-dev:24289]

	* array.c (rb_ary_and): element size might change during
	  comparison.  [ruby-dev:24290]

	* array.c (rb_ary_or): ditto. [ruby-dev:24292]

	* array.c (rb_ary_equal): wrong fix. [ruby-dev:24286]

Sat Sep 18 15:02:22 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_equal): element size might change during
	  comparison.  [ruby-dev:24254]

	* array.c (rb_ary_diff): ditto. [ruby-dev:24274]

	* array.c (rb_ary_select): ditto. [ruby-dev:24278]

	* array.c (rb_ary_delete): ditto. [ruby-dev:24283]

	* array.c (rb_ary_rindex): ditto. [ruby-dev:24275]

	* array.c (rb_ary_initialize): element size might change during
	  initializing block.  [ruby-dev:24284]

Sat Sep 18 14:10:23 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (dir_s_chdir): avoid memory leak and unnecessary chdir to
	  the original directory when exception has caused in changing
	  direcotry or within block.  thanks to Johan Holmberg
	  <holmberg@iar.se> [ruby-core:03446]

Fri Sep 17 20:20:27 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (mkdir_p): backport from CVS HEAD 1.45. [ruby-core:03420]

Fri Sep 17 17:11:08 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_delete): element comparison might change array
	  size. [ruby-dev:24273]

	* file.c (rb_file_truncate): clear stdio buffer before truncating
	  the file.  [ruby-dev:24191]

	* ext/digest/digest.c: use rb_obj_class() instead of CLASS_OF
	  which might return singleton class.  [ruby-dev:24202]

Fri Sep 17 16:07:09 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/multi-tk.rb: improve exit operation

Fri Sep 17 15:01:57 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: fix SEGV when (thread_)vwait or
	  (thread_)tkwait

	* ext/tk/lib/tk.rb: add alias wait_window to wait_destroy

	* ext/tk/lib/multi-tk.rb: support calling 'mainloop' on slave
	  interpreters (however, the 'real' eventloop must be run on the
	  Default Master IP)

	* ext/tk/lib/remote-tk.rb: follow the changes of ext/tk/lib/multi-tk.rb

	* ext/tk/sample/remote-ip_sample2.rb: ditto

	* ext/tk/sample/tkoptdb-safeTk.rb: ditto

Thu Sep 16 18:12:32 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/cgi.rb (WEBrick::CGI#start): should set REMOTE_USER
	  to request.user attribute.

	* lib/webrick/httpservlet/filehandler.rb
	  (WEBrick::HTTPServlet::FileHandler#initialize): should expand
	  the pathname of document root directory.

Thu Sep 16 15:49:28 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_intern): protect string argument from GC.
	  [ruby-core:03411]

Wed Sep 15 20:22:23 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/sample/tkoptdb-safeTk.rb: fix a bug depend on the changes
	  of MultiTkIp

Tue Sep 14 23:54:11 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/multi-tk.rb: MultiTkIp#eval_string was en-bugged by
	  the previous changes.

Tue Sep 14 23:45:44 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_formatter.rb (RI::TextFormatter::TextFormatter.for):
	  Add Eric Hodel's simpleformatter.

Tue Sep 14 16:59:37 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: fix SEGV

	* ext/tk/lib/multi-tk.rb: improve safe-level handling of argument proc

	* ext/tk/sample/multi-ip_sample.rb: rename of old 'safe-tk.rb'

	* ext/tk/sample/safe-tk.rb: new sample script

Tue Sep 14 00:15:15 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/zlib/zlib.c: backported from HEAD.

Mon Sep 13 19:16:33 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* eval.c (blk_copy_prev): need frame_dup().  [ruby-dev:24103]

Mon Sep 13 16:23:27 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/multi-tk.rb: MultiTkIp.new_master and new_slave accept
	  safe-level value argument

Mon Sep 13 10:20:45 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* object.c (nil_inspect): fix typo.

Mon Sep 13 01:03:02 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: improve control of preserv/release tcltkip

	* ext/tcltklib/tcltklib.c: store original 'exit' command

	* ext/tk/tkutil.c: fix(?) SEGV

Sun Sep 12 23:46:23 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* util.c (ruby_strdup): remove unnecessary code. (xmalloc never
	  returns NULL.)

	* util.c (ruby_getcwd): fix memory leak on failure.

Sun Sep 12 02:41:58 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: add TclTkIp#allow_ruby_exit? and
	  allow_ruby_exit=


	* ext/tk/lib/multi-tk.rb: ditto.

	* ext/tk/lib/remote-tk.rb: ditto.

	* ext/tcltklib/MANUAL.euc: ditto.

	* ext/tcltklib/MANUAL.eng: ditto.

	* ext/tcltklib/tcltklib.c: fix some reasons of SEGV

	* ext/tk/tkutil.c: ditto.

	* ext/tk/lib/multi-tk.rb: ditto.

	* ext/tk/lib/tk/timer.rb: ditto.

Sat Sep 11 16:09:46 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb: Fix up cross-file class merging.

Fri Sep 10 20:20:53 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* ext/tcltklib/tcltklib.c (lib_merge_tklist): fix suspicious
	  pointer conversion.

Fri Sep 10 02:43:54 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/template/kilmer.rb: James Buck's
	  patch for call-seq.

Thu Sep  9 13:58:56 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c (ip_init): change flag value for setting
	  'argv' and 'argv0' variable

	* ext/tk/lib/remote-tk.rb: follow changes of multi-tk.rb

Thu Sep  9 11:46:18 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::do_classes): Allow
	  spaces aroun parameter to define_method_under (James Buck)

Wed Sep  8 18:44:03 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_write): zero fill a gap if exsts.
	  [ruby-dev:24190]

Wed Sep  8 15:19:49 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c (ip_init): cannot create a IP at level 4

	* ext/tk/lib/multi-tk.rb: improve 'exit' operation, security check,
	  and error treatment

	* ext/tk/lib/multi-tk.rb: allow a trusted slave IP to create slave IPs

	* ext/tk/lib/tk/listbox.rb: add TkListbox#value, value=, clear,	and
	  erase

	* ext/tk/lib/tk/text.rb: add TkText#clear and erase

Mon Sep  6 11:08:50 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* ext/tk/lib/tk/menu.rb(TkOptionMenubutton#insert): call correct method

Mon Sep  6 11:00:47 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (dir_s_chdir): the patch to shut up false warning when
	  exception occurred within a block.  a patch was given from Johan
	  Holmberg <holmberg@iar.se>.  [ruby-core:03292]

Mon Sep  6 07:51:42 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (cvar_cbase): singletons should refer outer cvar scope.
	  [ruby-dev:24223]

	* eval.c (rb_load): should preserve previous ruby_wrapper value.
	  [ruby-dev:24226]

Sat Sep  4 01:14:57 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (cvar_cbase): class variables cause SEGV in
	  instance_eval() for fixnums and symbols. [ruby-dev:24213]

Fri Sep  3 17:47:58 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* struct.c (make_struct): remove redefining constant when
	  conflict.  [ruby-dev:24210]

Fri Sep  3 11:31:44 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: Tk.after makes TkCore::INTERP.tk_cmd_tbl grow
	  [ruby-dev:24207]

Fri Sep  3 02:12:48 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: fix typo [ruby-talk:111266]

	* ext/tk/lib/tk/text.rb: fix typo

	* ext/tk/lib/multi-tk.rb: improve safe-level treatment on slave IPs

Fri Sep  3 01:54:20 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/extmk.rb: already built-in libraries satisfy dependencies.
	  [ruby-dev:24028]

Thu Sep  2 11:36:20 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* eval.c (rb_obj_instance_eval): backported from HEAD.

Wed Sep  1 21:18:25 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* ext/tk/lib/tk/spinbox.rb: fix typo

Tue Aug 31 18:24:04 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* ext/tk/tkutil.c (cbsubst_init): fix memory leak

	* ext/tk/tkutil.c (cbsubst_get_all_subst_keys): fix SEGV

Tue Aug 31 16:04:22 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c (ip_delete): when a tcltkip is deleted,
	  destroy its root widget

Tue Aug 31 12:30:36 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c (del_root): fix SEGV

Mon Aug 30 23:11:06 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_driver.rb (and others): ri now merges documentation
	  if it finds the same class in multiple places.

Mon Aug 30 22:40:30 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/multi-tk.rb: 'restart' method accepts arguments

Mon Aug 30 21:50:14 2004  Dave Thomas  <dave@pragprog.com>

	* object.c: Add RDoc for Module.included.

Mon Aug 30 15:10:46 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in (GNU/k*BSD): fixed FTBFS on GNU/k*BSD. [ruby-dev:24051]

Mon Aug 30 11:29:35 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (CreateChild): strip trailing spaces. [ruby-dev:24143]
	  merge from HEAD.

Sun Aug 29 14:08:56 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: compile error on bcc32 [ruby-dev:24081]

	* ext/tk/lib/multi-tk.rb: MultiTkIp#eval_string does not work

Sat Aug 28 23:04:41 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_and): protect parameters from GC.
	  [ruby-talk:110664]

Thu Aug 26 04:38:29 2004  Dave Thomas  <dave@pragprog.com>

	* eval.c (return_jump): Minor typo in error message. Now reads
	  "return can't jump across threads".

Tue Aug 24 17:30:00 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/cgi/session.rb (CGI::Session::FileStore#initialize): do not
	  use a session id as a filename. (backported from HEAD)

	* lib/cgi/session/pstore.rb (CGI::Session::PStore#initialize): ditto.

	* lib/cgi/session/pstore.rb (CGI::Session::PStore#initialize): use
	  Dir::tmpdir. (backported from HEAD)

Tue Aug 24 14:40:16 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/cgi/session.rb (CGI::Session::FileStore#initialize): untaint
	  session id after check. (backported from HEAD)

Tue Aug 24 09:09:01 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_x509attr.c (ossl_x509attr_initialize): d2i
	  functions may replace the pointer indicated by the first argument.

	* ext/openssl/ossl_x509ext.c (ossl_x509ext_initialize): ditto.

	* ext/openssl/ossl_x509name.c (ossl_x509name_initialize): ditto.

Mon Aug 23 14:04:51 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_read):
	  - should return an empty string if specified length to read is 0.
	  - should check for pending data and wait for fd before reading.
	  - call underlying IO's sysread if SSL session is not started.
	  [ruby-dev:24072], [ruby-dev:24075]

	* ext/openssl/ossl_ssl.c (ossl_ssl_write):
	  - call underlying IO's syswrite if SSL session is not started.

	* ext/openssl/ossl_ssl.c (ossl_ssl_pending): new method
	  OpenSSL::SSL#pending.

	* ext/openssl/lib/openssl/buffering.rb: should not use select.

Mon Aug 23 12:40:56 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/resolv.rb (Config.default_config_hash): when multiple domains
	  are set, Win32::Resolv.get_resolv_info returns Array.

Sun Aug 22 01:15:31 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httpproxy.rb (WEBrick::HTTPProxyServer#proxy_connect):
	  should call :ProxyContentHandler before finishing CONNECT.

Sat Aug 21 06:41:16 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/tcltklib/extconf.rb (find_tcl, find_tk): find stub library.

	* lib/mkmf.rb (arg_config, with_config): deal with '-' and '_'
	  uniformly.  [ruby-dev:24118]

Thu Aug 19 16:29:45 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: Fail to treat a hash value of 'font' option.

	* ext/tk/lib/tk.rb: bindinfo cannot return '%' substiturion infomation.

	* ext/tk/lib/menu.rb: typo bug.

Thu Aug 19 15:15:24 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (free_dir): fix memory leak.  reported by yamamoto
	  madoka.

Thu Aug 20 11:00:00 2004 Akiyoshi, Masamichi <masamichi.akiyoshi@hp.com>

	* dln.c (dln_load): Modify to call lib$find_image_symbol for VMS.
	* io.c (rb_io_fwrite): Use fputc() for VMS non-stream file.

Thu Aug 19 06:07:45 2004  why the lucky stiff  <why@ruby-lang.org>

	* ext/syck/token.c: re2c no longer compiled with bit vectors.  caused
	  problems for non-ascii characters. [ruby-core:03280]
	* ext/syck/implicit.c: ditto.
	* ext/syck/bytecode.c: ditto.

	* lib/yaml/baseemitter.rb: folding now handles double-quoted strings,
	  fixed problem with extra line feeds at end of folding, whitespace
	  opening scalar blocks.

	* lib/yaml/rubytypes.rb: subtelties in handling strings with
	  non-printable characters and odd whitespace patterns.

Wed Aug 18 23:41:33 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/net/protocol.rb (rbuf_fill): OpenSSL::SSL::SSLSocket has its own
	  buffer, select(2) might not work. [ruby-dev:24072]

Wed Aug 18 17:10:12 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/tcltklib/stubs.c (ruby_tcltk_stubs): need to call
	  Tcl_FindExecutable() for Tcl/Tk 8.4.

Wed Aug 18 12:52:55 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_obj_instance_eval): evaluates under special singleton
	  classes as for special constants.

Tue Aug 17 17:20:59 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_reopen): should clear allocated OpenFile.  pointed
	  out by Guy Decoux. [ruby-core:03288]

Tue Aug 17 01:36:32 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/usage.rb: Remove extra indent. Tidy 'ri' option
	  parsing so RDoc::usage plays better with OptionParser.

Sat Aug 14 13:09:10 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb: backport from CVS HEAD (rev1.44).

	* lib/fileutils.rb: cp_r should copy symlink itself, except cp_r
	  root.

	* lib/fileutils.rb: new option mv :force.

	* lib/fileutils.rb: new module FileUtils::DryRun.

Sat Aug 14 02:48:16 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/usage.rb: Added. Allows command line programs
	  to report usage using their initial RDoc comment.

Fri Aug 13 13:23:17 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httputils.rb (WEBrick::HTTPUtils.parse_range_header):
	  fix regex for range-spec.

	* lib/webrick/httpservlet/filehandler.rb
	  (WEBrick::HTTPServlet::DefaultFileHandler#make_partial_content):
	  multipart/byteranges response was broken.

	* lib/webrick/httpservlet/erbhandler.rb
	  (WEBrick::HTTPServlet::ERBHandler#do_GET): should select media type
	  by suffix of script filename.

	* lib/xmlrpc/server.rb: refine example code.

Wed Aug 11 17:17:50 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in (RPATHFLAG): stop setting RPATHFLAG on Interix.

Sun Aug  8 00:43:31 2004  why the lucky stiff  <why@ruby-lang.org>

	* lib/implicit.c: added sexagecimal float#base60.

	* ext/syck/rubyext.c (yaml_org_handler): ditto.

	* lib/token.c: indentation absolutely ignored when processing flow
	  collections.  plain scalars are trimmed if indentation follows in
	  an ambiguous flow collection.

Sat Aug  7 00:50:01 2004  Tanaka Akira  <akr@m17n.org>

	* ext/zlib/zlib.c: Zlib::GzipReader#read(0) returns "" instead of nil.

Tue Aug  3 13:49:20 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/namespace.rb: bug fix

	* ext/tk/lib/tkextlib/treectrl/tktreectrl.rb: add Tk::TreeCtrl.loupe

Mon Aug  2 18:04:21 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/msgcat.rb (set_translation): bug fix (fail to set
	  trans_str to the same as src_str when trans_str is not given.)

Mon Aug  2 11:53:06 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/code_objects.rb (RDoc::Context::find_symbol): Fix infinite recursion
	  looking up some top level symbols (batsman)

Mon Aug  2 11:48:29 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::do_methods): Allow '.'s in
	  variable names to support SWIG generated files (Hans Fugal)

Sat Jul 31 17:40:16 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-expr-beg, ruby-parse-partial,
	  ruby-calculate-indent, ruby-move-to-block, ruby-forward-sexp,
	  ruby-backward-sexp): keywords must match word-wise.

Sat Jul 31 05:47:37 2004  why the lucky stiff  <why@ruby-lang.org>

	* lib/yaml.rb (YAML::load_file, YAML::parse_file): added.

	* lib/yaml/rubytypes.rb: exceptions were using an older
	  YAML.object_maker. [ruby-core:03080]

	* ext/syck/token.c (sycklex_yaml_utf8): using newline_len to
	  handline CR-LFs.  "\000" was showing up on folded blocks which
	  stopped at EOF.

	* ext/syck/token.c: re2c compiled with bit vectors now.
	* ext/syck/implicit.c: ditto.
	* ext/syck/bytecode.c: ditto.

Fri Jul 30 16:10:54 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c (lib_fromUTF8_core): raise ArgumentError when
	  the unknown encoding name is given.

	* ext/tcltklib/tcltklib.c (lib_toUTF8_core): ditto.

	* ext/tk/lib/tk.rb (Tk::Encoding.encoding_convertfrom): bug fix.

	* ext/tk/lib/tk.rb (Tk::Encoding.encoding_convertto): ditto.

Wed Jul 28 18:59:17 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/cgi.rb (CGI::initialize): remove at_exit code for CGI_PARAMS
	  and CGI_COOKIES.  they will no longer be used.

Wed Jul 28 01:04:44 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (run_final): wrong order of data. [ruby-dev:23984]

Tue Jul 27 07:05:04 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): copy on write for argument local variable
	  assignment.

	* eval.c (assign): ditto.

	* eval.c (rb_call0): update ruby_frame->argv with the default
	  value used for the optional arguments.

	* object.c (Init_Object): "===" calls rb_obj_equal() directly.
	  [ruby-list:39937]

Mon Jul 26 11:22:55 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httputils.rb (WEBrick::HTTPUtils.escape): should
	  escape space.

Sun Jul 25 11:05:21 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* win32/win32.{h,c} (rb_w32_{f,fd,fs}open): workaround for bcc32's
	  {f,fd,fs}open bug. set errno EMFILE and EBADF. [ruby-dev:23963]

Sat Jul 24 13:32:47 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* range.c (rb_range_beg_len): returns Qnil only when "beg" points
	  outside of a range.  No boundary check for "end".

Fri Jul 23 16:40:25 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (define_final): should not disclose NODE* to Ruby world.
	  [ruby-dev:23957]

Fri Jul 23 09:03:16 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (disconnected?): new method. (backported from HEAD)

Thu Jul 22 16:41:54 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/cgi/session.rb (CGI::Session::FileStore#update): sets the
	 permission of the session data file to 0600.

	* lib/cgi/session/pstore.rb (CGI::Session::Pstore#initialize):
	  ditto.

Thu Jul 22 00:02:21 2004  Masahiro Kitajima  <katonbo@katontech.com>

	* process.c (rb_f_system): not need to call last_status_set() any
	  longer on _WIN32.

Tue Jul 20 09:15:17 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* test/fileutils/test_fileutils.rb: File.link raises EINVAL on BeOS.

Mon Jul 19 01:15:07 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httpservlet/cgihandler.rb
	  (WEBrick::HTTPServlet::CGIhandler#do_GET): set SystemRoot environment
	  variable to CGI process on Windows native platforms. [ruby-dev:23936]

	* lib/webrick/httpservlet/cgihandler.rb
	  (WEBrick::HTTPServlet::CGIhandler#do_GET): use $?.exitstatus and
	  refine log message.

Sun Jul 18 16:14:29 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/msgcat.rb (TkMsgCatalog.callback): bug fix
	  ( wrong number of argument )

Sun Jul 18 08:13:58 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (rb_f_sprintf): remove extra sign digit.

Sun Jul 18 03:21:42 2004  Akinori MUSHA  <knu@iDaemons.org>

	* dir.c (range): use NULL instead of 0.

	* dir.c (range): get rid of a gcc 3.4 warning.

Sun Jul 18 03:12:11 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (receive_responses): return if a LOGOUT response
	received. (backported from HEAD)
	* lib/net/imap.rb (send_string_data): wait command continuation
	requests before sending octet data of literals. (backported from HEAD)

Sat Jul 17 23:54:59 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/variable.rb: TkVariable#ref returns a TkVariable object

Sat Jul 17 22:04:44 2004  akira yamada  <akira@ruby-lang.org>

	* lib/uri/ldap.rb: method hierarchical? should be in URI::LDAP.

Sat Jul 17 18:29:07 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (stmt): not to show same error messages twice.

Sat Jul 17 13:13:32 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/irb/ruby-lex.rb (RubyLex::identify_string): %s string do not
	  process expression interpolation.  [ruby-talk:106691]

Sat Jul 17 05:26:27 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/diagram.rb: Incorporate Micheal Neuman's
	  client-side imagemao patch

Sat Jul 17 01:57:03 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (THREAD_ALLOC): th->thread should be initialized to NULL.
	  [ruby-talk:106657]  The solution was found by Guy Decoux.

Fri Jul 16 22:30:28 2004  Michael Neumann  <mneumann@ntecs.de>

	* file.c (rb_stat_dev_major): new methods File::Stat#dev_major and
	  #dev_minor. [ruby-core:03195]

Fri Jul 16 15:23:53 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (return_jump, break_jump): raise unexpceted local jump
	  exception directly.  [ruby-dev:23740]

	* lib/base64.rb (Deprecated): super in bound method calls original
	  name method in stable version.  [ruby-dev:23916]

Fri Jul 16 11:31:49 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* lib/test/unit/ui/{fox,gtk,gtk2}/testrunner.rb: remove
	  garbage (patch from akira yamada) [ruby-dev:23911]

Fri Jul 16 11:20:00 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* sprintf.c (rb_f_sprintf): fix output of NaN, Inf and -Inf with
	  "%f" or etc on MSVCRT platforms. (backported from HEAD)

Fri Jul 16 11:17:38 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (exit_initialize): use EXIT_SUCCESS instead of 0.
	  [ruby-dev:23913]

	* error.c (exit_success_p): new method SystemExit#success?.
	  [ruby-dev:23912]

	* error.c (syserr_initialize): initialization for subclasses.
	  [ruby-dev:23912]

Thu Jul 15 23:53:38 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser#warn, OptionParser#abort): Exception
	  no longer has to_str method.

Thu Jul 15 22:59:48 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/readline/extconf.rb: added dir_config for curses, ncurses,
	termcap. (backported from HEAD)

Thu Jul 15 20:29:15 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* class.c, error.c, eval.c, intern.h, object.c, variable.c:
	  do not set path if it is a singleton class.  [ruby-dev:22588]
	  (backport from 1.9)

Thu Jul 15 10:15:04 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/, ext/tcltklib/: bug fix

	* ext/tk/lib/tk.rb: better operation for SIGINT when processing
	  callbacks.
	* ext/tk/lib/tk/msgcat.rb: ditto.
	* ext/tk/lib/tk/variable.rb: ditto.
	* ext/tk/lib/tk/timer.rb: ditto.

	* ext/tk/lib/tk/validation.rb: add Tk::ValidateConfigure.__def_validcmd
	  to define validatecommand methods easier

	* ext/tk/lib/tk.rb (_genobj_for_tkwidget): support autoload Tk ext
	  classes

	* ext/tk/lib/tk/canvas.rb and so on: remove the parent widget type
	  check for items (e.g. canvas items; depends on the class) to
	  avoid some troubles on Tk extension widget class definition.

	* ext/tk/lib/tkextlib/: add Iwidget and TkTable extension support

	* ext/tk/sample/tkextlib/: add samples of Iwidget and TkTable


Wed Jul 14 18:08:37 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_asn1.c (ossl_asn1cons_to_der): fix type of
	  argument. [ruby-dev:23891]

	* test/openssl/test_x509store.rb: prune tests for CRL checking
	  unless X509::V_FLAG_CRL_CHECK is defined.

Wed Jul 14 12:29:07 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* util.c (ruby_strtod): should not convert string in the form of
	  "-I.FE-X" which both "I" and "F" are ommitted. [ruby-dev:23883]

	* test/ruby/test_float.rb (test_strtod): add test for bug fix.

Wed Jul 14 01:18:45 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* array.c: rdoc patch - unified margin.

Wed Jul 14 00:31:15 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* array.c: rdoc patch. merged patch from Johan Holmberg
	  <holmberg@iar.se> [ruby-core:3170]

Tue Jul 13 19:39:12 2004  akira yamada  <akira@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic#merge_path):
	  "URI('http://www.example.com/foo/..') + './'" should return
	  "URI('http://www.example.com/')".  [ruby-list:39838]
	  "URI('http://www.example.com/') + './foo/bar/..'" should return
	  "URI('http://www.example.com/foo/')".  [ruby-list:39844]

	* test/uri/test_generic.rb (TestGeneric#test_merge): added tests.

Tue Jul 13 15:51:45 2004  Akinori MUSHA  <knu@iDaemons.org>

	* lib/mkmf.rb (init_mkmf): Do not add $(libdir) to $LIBPATH in
	   extmk mode.

	* lib/mkmf.rb (dir_config): Prepend a new library path instead of
	  appending so it is tried first.

Tue Jul 13 00:50:48 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb: Support call-seq: for Ruby files.

Mon Jul 12 21:20:36 2004  Dave Thomas  <dave@pragprog.com>

	* html_generator.rb: Support hyperlinks of the form {any text}[xxx]
	  as well as stuff[xxx]

Sat Jul 10 09:30:24 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* test/soap/marshal/test_struct.rb: use qualified build-tin class name
	  (::Struct) to avoid name crash.

Sat Jul 10 04:21:56 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: better operation for SIGINT when processing
	  callbacks.
	* ext/tk/lib/tk/msgcat.rb: ditto.
	* ext/tk/lib/tk/variable.rb: ditto.
	* ext/tk/lib/tk/timer.rb: ditto.

	* ext/tk/lib/tk/validation.rb (__def_validcmd):  add a module
	  function of Tk::ValidateConfigure to define validatecommand
	  methods easier

Fri Jul  9 22:36:36 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* array.c, enum.c, pack.c: rdoc patch from Johan Holmberg
	  <holmberg@iar.se> [ruby-core:3132] [ruby-core:3136]

	* numeric.c: rdoc patch.

Fri Jul  9 19:26:39 2004  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (URI::HTTPS#proxy_open): raise ArgumentError to
	  notice https is not supported.

Fri Jul  9 14:28:54 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_thread_raise): accept third argument as well as
	  Kernel#raise, and evaluate the arguments to create an exception in
	  the caller's context.  [ruby-talk:105507]

Fri Jul  9 01:47:08 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib : bug fix
	* ext/tk/lib/tkextlib/itcl : add [incr Tcl] support
	* ext/tk/lib/tkextlib/itk  : add [incr Tk] support
	* ext/tk/lib/tkextlib/iwidgets : midway point of [incr Widgets] support
	* ext/tk/sample/tkextlib/iwidgets : very simple examples of
	  [incr Widgets]

Thu Jul  8 22:52:19 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/{rss,parser,0.9,1.0,2.0}.rb: supported RSS 0.9x/2.0
	  validation and validation which disregard order of elements.
	* test/rss/test_parser.rb: added tests for RSS 0.9x/2.0
	  validation.
	* test/rss/{test_trackback,rss-testcase}.rb: fixed no good method
	  name.

Thu Jul  8 00:05:23 2004  akira yamada  <akira@ruby-lang.org>

	* lib/tempfile.rb (Tempfile::initialize): got out code of
	  generating tmpname.  [ruby-dev:23832][ruby-dev:23837]

Wed Jul  7 15:53:14 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* string.c (rb_str_match): raise TypeError when both arguments are
	  strings. [ruby-dev:22869] (backported from HEAD)

	* string.c (rb_str_match2): removed.

	* Makefile.in, bcc32/Makefile.sub, win32/Makefile.sub,
	  wince/Makefile.sub (string.c): now not depend on version.h.

Wed Jul  7 00:48:34 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/tk/lib/tkextlib/tktrans.rb,
	  ext/tk/lib/tkextlib/treectrl.rb: fix syntax errors.

Tue Jul  6 18:38:45 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib : improve framework of developping Tcl/Tk extension
	  wrappers

Mon Jul  5 23:56:42 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/{trackback,syndication,dublincore,content}.rb: worked
	  with ruby 1.6 again.

	* test/rss/rss-assertions.rb: ditto.

Mon Jul  5 22:54:39 2004  Tanaka Akira  <akr@m17n.org>

	* lib/uri/common.rb (Kernel#URI): new global method for parsing URIs.

Mon Jul  5 09:02:52 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_thread_yield, rb_f_catch): 4th argument to rb_yield_0()
	  is a set of bit flags.  [ruby-dev:23859]

Mon Jul  5 01:27:32 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* lib/drb/drb.rb(DRbConn self.open): If socket pool is full, close
	  the socket whose last-access-time is oldest. (and add new one)
	  [ruby-dev:23860]

Sun Jul  4 12:24:50 2004  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/rss.rb: added copyright header.

Sun Jul  4 00:24:40 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* added files
	  * lib/soap/attachment.rb
	  * lib/soap/header
	  * lib/soap/mimemessage.rb
	  * lib/soap/rpc/httpserver.rb
	  * lib/wsdl/soap/cgiStubCreator.rb
	  * lib/wsdl/soap/classDefCreator.rb
	  * lib/wsdl/soap/classDefCreatorSupport.rb
	  * lib/wsdl/soap/clientSkeltonCreator.rb
	  * lib/wsdl/soap/driverCreator.rb
	  * lib/wsdl/soap/mappingRegistryCreator.rb
	  * lib/wsdl/soap/methodDefCreator.rb
	  * lib/wsdl/soap/servantSkeltonCreator.rb
	  * lib/wsdl/soap/standaloneServerStubCreator.rb
	  * lib/wsdl/xmlSchema/enumeration.rb
	  * lib/wsdl/xmlSchema/simpleRestriction.rb
	  * lib/wsdl/xmlSchema/simpleType.rb
	  * lib/xsd/codegen
	  * lib/xsd/codegen.rb
	  * sample/soap/authheader
	  * sample/soap/raa2.4
	  * sample/soap/ssl
	  * sample/soap/swa
	  * sample/soap/whois.rb
	  * sample/soap/calc/samplehttpd.conf
	  * sample/soap/exchange/samplehttpd.conf
	  * sample/soap/sampleStruct/samplehttpd.conf
	  * sample/wsdl/raa2.4
	  * sample/wsdl/googleSearch/samplehttpd.conf
	  * test/openssl/_test_ssl.rb
	  * test/soap/header
	  * test/soap/ssl
	  * test/soap/struct
	  * test/soap/swa
	  * test/soap/wsdlDriver
	  * test/wsdl/multiplefault.wsdl
	  * test/wsdl/simpletype
	  * test/wsdl/test_multiplefault.rb

	* modified files
	  * lib/soap/baseData.rb
	  * lib/soap/element.rb
	  * lib/soap/generator.rb
	  * lib/soap/marshal.rb
	  * lib/soap/netHttpClient.rb
	  * lib/soap/parser.rb
	  * lib/soap/processor.rb
	  * lib/soap/property.rb
	  * lib/soap/soap.rb
	  * lib/soap/streamHandler.rb
	  * lib/soap/wsdlDriver.rb
	  * lib/soap/encodingstyle/handler.rb
	  * lib/soap/encodingstyle/literalHandler.rb
	  * lib/soap/encodingstyle/soapHandler.rb
	  * lib/soap/mapping/factory.rb
	  * lib/soap/mapping/mapping.rb
	  * lib/soap/mapping/registry.rb
	  * lib/soap/mapping/rubytypeFactory.rb
	  * lib/soap/mapping/wsdlRegistry.rb
	  * lib/soap/rpc/cgistub.rb
	  * lib/soap/rpc/driver.rb
	  * lib/soap/rpc/element.rb
	  * lib/soap/rpc/proxy.rb
	  * lib/soap/rpc/router.rb
	  * lib/soap/rpc/soaplet.rb
	  * lib/soap/rpc/standaloneServer.rb
	  * lib/wsdl/data.rb
	  * lib/wsdl/definitions.rb
	  * lib/wsdl/operation.rb
	  * lib/wsdl/parser.rb
	  * lib/wsdl/soap/definitions.rb
	  * lib/wsdl/xmlSchema/complexContent.rb
	  * lib/wsdl/xmlSchema/complexType.rb
	  * lib/wsdl/xmlSchema/data.rb
	  * lib/wsdl/xmlSchema/parser.rb
	  * lib/wsdl/xmlSchema/schema.rb
	  * lib/xsd/datatypes.rb
	  * lib/xsd/qname.rb
	  * sample/soap/calc/httpd.rb
	  * sample/soap/exchange/httpd.rb
	  * sample/soap/sampleStruct/httpd.rb
	  * sample/soap/sampleStruct/server.rb
	  * sample/wsdl/amazon/AmazonSearch.rb
	  * sample/wsdl/amazon/AmazonSearchDriver.rb
	  * sample/wsdl/googleSearch/httpd.rb
	  * test/soap/test_basetype.rb
	  * test/soap/test_property.rb
	  * test/soap/test_streamhandler.rb
	  * test/soap/calc/test_calc.rb
	  * test/soap/calc/test_calc2.rb
	  * test/soap/calc/test_calc_cgi.rb
	  * test/soap/helloworld/test_helloworld.rb
	  * test/wsdl/test_emptycomplextype.rb
	  * test/wsdl/axisArray/test_axisarray.rb
	  * test/wsdl/datetime/test_datetime.rb
	  * test/wsdl/raa/test_raa.rb
	  * test/xsd/test_xmlschemaparser.rb
	  * test/xsd/test_xsd.rb

	* summary
	  * add SOAP Header mustUnderstand support.

	  * add HTTP client SSL configuration and Cookies support (works
	    completely with http-access2).

	  * add header handler for handling sending/receiving SOAP Header.

	  * map Ruby's anonymous Struct to common SOAP Struct in SOAP Object
	    Model.  it caused error.

	  * add WSDL simpleType support to restrict lexical value space.

	  * add SOAP with Attachment support.

Sat Jul  3 17:19:44 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/tk/lib/tkextlib/tkDND.rb: fix syntax error.

Thu Jul  1 23:15:29 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/pstore.rb (transaction): safer backup scheme.  [ruby-list:39102]

	* lib/pstore.rb (commit_new): use FileUtils.copy_stream for Cygwin.
	  [ruby-dev:23157]

	* lib/pstore.rb (transaction): allow overriding dump and load.
	  [ruby-dev:23567]

	* lib/pstore.rb (PStore#transaction): get rid of opening in write mode
	  when read only transaction.  [ruby-dev:23842]

	* lib/yaml/store.rb: follow lib/pstore.rb's change.

Thu Jul  1 18:36:08 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tcltklib : bug fix

	* ext/tk/lib/tk : bug fix and add Tcl/Tk extension support libraries

Thu Jul  1 11:59:45 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/extconf.rb: check for EVP_CIPHER_CTX_copy, ENGINE_add,
	  EVP_CIPHER_CTX_set_padding, EVP_CipherFinal_ex, EVP_CipherInit_ex,
	  EVP_DigestFinal_ex and EVP_DigestInit_ex.

	* ext/openssl/openssl_missing.c (EVP_CIPHER_CTX_copy): new function.

	* ext/openssl/openssl_missing.h (EVP_DigestInit_ex, EVP_DigestFinal_ex,
	  EVP_CipherInit_ex, EVP_CipherFinal_ex, HMAC_Init_ex): new macro for
	  OpenSSL 0.9.6.

	* ext/openssl/ossl_cipher.c (ossl_cipher_encrypt, ossl_cipher_decrypt):
	  re-implemnt (the arguments for this method is ).

	* ext/openssl/ossl_cipher.c (ossl_cipher_pkcs5_keyivgen): new method
	  OpenSSL::Cipher::Cipher#pkcs5_keyivgen. it calls EVP_BytesToKey().

	* ext/openssl/ossl_cipher.c (ossl_cipher_alloc, ossl_cipher_initialize,
	  ossl_cipher_copy, ossl_cipher_reset ossl_cipher_final,
	  ossl_cipher_set_key, ossl_cipher_set_iv): replace all EVP_CipherInit
	  and EVP_CipherFinal into EVP_CipherInit_ex and EVP_CipherFinal_ex.
	  and EVP_CIPHER_CTX_init should only be called once.

	* ext/openssl/ossl_cipher.c (ossl_cipher_set_key_length): new method
	  OpenSSL::Cipher::Cipher#key_len=.

	* ext/openssl/ossl_cipher.c (ossl_cipher_init_deprecated): new
	  finction; print warning for Cipher#<<.

	* ext/openssl/ossl_digest.c: replace all EVP_DigestInit and
	  EVP_DigestFinal into EVP_DigestInit_ex and EVP_DigestFinal_ex.
	  and EVP_MD_CTX_init should only be called once.

	* ext/openssl/ossl_digest.c (digest_final): should call
	  EVP_MD_CTX_cleanup to avoid memory leak.

	* ext/openssl/ossl_hmac.c (ossl_hmac_initialize): repalce HMAC_init
	  into HMAC_init_ex. and HMAC_CTX_init is moved to ossl_hmac_alloc.

	* ext/openssl/ossl_hmac.c (hmac_final): should call
	  HMAC_CTX_cleanup to avoid memory leak.

	* test/openssl/test_cipher.rb, test/openssl/test_digest.rb,
	  test/openssl/test_hmac.rb: new file.

Thu Jul  1 04:08:30 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_asn1.c (ossl_i2d_ASN1_TYPE, ossl_ASN1_TYPE_free):
	  workaround for the versions earlier than OpenSSL-0.9.7.

Thu Jul  1 03:33:55 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_pkey_dh.c (ossl_dh_initialize): should create
	  empty pkey object if no argument is passed. [ruby-talk:103328]

	* ext/openssl/ossl_pkey_dsa.c (ossl_dsa_initialize): ditto.

	* ext/openssl/ossl_pkey_rsa.c (ossl_rsa_initialize): ditto.

	* ext/openssl/ossl_pkey_dh.c: add new methods: OpenSSL::PKey::DH#p,
	  OpenSSL::PKey::DH#p=, OpenSSL::PKey::DH#g, OpenSSL::PKey::DH#g=,
	  OpenSSL::PKey::DH#pub_key, OpenSSL::PKey::DH#pub_key=,
	  OpenSSL::PKey::DH#priv_key and OpenSSL::PKey::DH#priv_key=.

	* ext/openssl/ossl_pkey_dsa.c: add new methods: OpenSSL::PKey::DSA#p,
	  OpenSSL::PKey::DSA#p=, OpenSSL::PKey::DSA#q, OpenSSL::PKey::DSA#q=,
	  OpenSSL::PKey::DSA#g, OpenSSL::PKey::DSA#g=,
	  OpenSSL::PKey::DSA#pub_key, OpenSSL::PKey::DSA#pub_key=,
	  OpenSSL::PKey::DSA#priv_key and OpenSSL::PKey::DSA#priv_key=.

Thu Jul  1 03:16:09 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_read): take optional second argument
	  to specify a string to be written.

	* ext/openssl/lib/openssl/buffering.rb (OpenSSL::Buffering#read):
	  take optional second argument to specify a string to be written.

	* ext/openssl/lib/openssl/buffering.rb (OpenSSL::Buffering#gets):
	  refine regexp for end-of-line.

	* ext/opnessl/lib/openssl/ssl.rb
	  (OpenSSL::SSL::SocketForwarder#listen): fix typo.

Wed Jun 30 11:38:51 2004  Mikael Brockman <phubuh@phubuh.org>

	* parse.y (primary): should not be NULL.  [ruby-core:03098]

Wed Jun 30 02:53:24 2004  why the lucky stiff  <why@ruby-lang.org>

	* ext/syck/rubyext.c (syck_emitter_new): set buffer after
	  Data_Wrap_Struct to avoid possible GC. [ruby-talk:104835]

Tue Jun 29 10:31:19 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_eval_cmd, rb_thread_trap_eval): restore safe level.

	* gc.c (define_final, run_final): preserve and restore safe level for
	  finalizers.  [ruby-core:03058]

	* signal.c (signal_exec, rb_trap_exit, trap): preserve and restore
	  safe level for signal handlers.  [ruby-dev:23829]

Mon Jun 28 14:57:56 2004  Jeff Mitchell  <quixoticsycophant@yahoo.com>

	* configure.in, lib/mkmf.rb (LIBPATHFLAG): use double quotes due to
	  DOSISH compilers.  [ruby-core:03107]

Mon Jun 28 00:30:19 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* sample/drb/*.rb: using 'DRb.thread.join' instead of 'gets'

Sun Jun 27 22:39:51 2004  Kouhei Sutou  <kou@cozmixng.org>

	* sample/rss/tdiary_plugin/rss-recent.rb: supported Hiki.

Sun Jun 27 12:19:46 2004  Kouhei Sutou  <kou@cozmixng.org>

	* {lib,sample,test}/rss: added RSS Parser. [ruby-dev:23780]

Sat Jun 26 11:07:30 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (aix): -b must come at the start of the command line,
	  and -e must not appear while testing libraries.  [ruby-talk:104501]

	* lib/mkmf.rb (dir_config): quote directory names if necessary.
	  [ruby-talk:104505]

Fri Jun 25 15:33:19 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/iconv/extconf.rb: check stricter.  [ruby-talk:104501]

	* ext/iconv/extconf.rb: include iconv.h for libiconv.  [ruby-dev:22715]

Fri Jun 25 08:31:29 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_atfork): remove "fork terminates thread"
	  warning.  [ruby-dev:23768]

	* object.c (rb_obj_clone): backport FL_FINALIZE patch from 1.9.
	  [ruby-core:02786][ruby-core:03067]

	* ext/socket/socket.c (sock_sockaddr): Socket#gethostbyname()
	  should give us packed address, not struct sockaddr.
	  [ruby-core:03053]

Fri Jun 25 02:04:23 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* {bcc32,win32,wince}/setup.mak: remove RUBY_EXTERN lines when
	  including version.h. [ruby-talk:104456] (backported from HEAD)

Thu Jun 24 14:23:29 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_fread): return already read data when system call is
	  interrupted.  [ruby-talk:97206]

Thu Jun 24 01:32:43 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* version.h: added declarations of ruby_version,
	  ruby_release_date, ruby_platform.
	  (backported from HEAD)

Wed Jun 23 22:23:37 2004  Dave Thomas  <dave@pragprog.com>

	* ext/socket/socket.c (sock_s_gethostbyaddr): Work around problem
	  with OS X not returning 'from' parameter to recvfrom for
	  connection-oriented sockets.

Wed Jun 23 01:45:27 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RubyLex::identify_quotation):
	  Fix problem with the 'r' being dropped from %r{xxx}

Wed Jun 23 00:20:20 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* ext/win32ole/win32ole.c (ole_hresult2msg): remove trailing
	  CRs and LFs. (doesn't depend on CR+LF) [ruby-dev:23749]

Wed Jun 23 00:00:25 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_initialize): should check fcntl result.  [ruby-dev:23742]

Tue Jun 22 21:11:36 2004  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (OLE_FREE): should not call CoFreeUnuse-
	  dLibraries().

	* ext/win32ole/win32ole.c (ole_event_free): ditto.

	* ext/win32ole/win32ole.c (ole_hresult2msg): truncate error message
	  before CR.

Tue Jun 22 16:47:42 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (MDTM_REGEXP): fix for demon's ftp server.
	Thanks, Rutger Nijlunsing.

Mon Jun 21 10:19:23 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_opendir): use FindFirstFile()/FindNextFile()/
	  FindClose() instead of _findfirst()/_findnext()/_findclose().
	  merge from HEAD.

Sat Jun 19 13:24:15 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (method_call): allow changing $SAFE.  [ruby-dev:23713]

Fri Jun 18 23:12:22 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (proc_save_safe_level, rb_set_safe_level, safe_setter): limit
	  safe level.

Wed Jun 16 23:05:57 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_mod_freeze): prepare string representation before
	  freezing. [ruby-talk:103646]

Wed Jun 16 16:04:40 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_mod_le): singleton class inherits Class rather than its
	  object's class.  [ruby-dev:23690]

Wed Jun 16 16:01:17 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (stack_grow_direction): memoize the direction.

	* gc.c (Init_stack): should always move to end of VALUE.

Tue Jun 15 12:10:04 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: bug fix (TkWindow#grab)

Mon Jun 14 18:23:27 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/remote-tk.rb: bug fix

Sun Jun 13 00:23:04 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/extconf.rb: [EXPERIMENTAL] MacOS X (darwin) support

	* ext/tcltklib/tcltklib.c: fix thread trouble on callback proc, and
	                   eliminate warning about instance variable access

	* ext/tk/lib/tk/menubar.rb: improve supported menu_spec

	* ext/tk/lib/tk/menuspec.rb: [add] menu_spec support library

	* ext/tk/lib/tk/root.rb: add menu_spec support

	* ext/tk/lib/tk/text.rb: bug fix

	* ext/tk/lib/tk/toplevel.rb: add menu_spec support

	* ext/tk/sample/menubar?.rb: [add] sample of menu_spec usage

Sat Jun 12 11:15:53 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in (target_os): strip -gnu suffix on Linux.

Fri Jun 11 17:08:21 2004  Akinori MUSHA  <knu@iDaemons.org>

	* config.guess: Restore a wrongly removed hyphen.

Fri Jun 11 14:30:08 2004  Akinori MUSHA  <knu@iDaemons.org>

	* config.guess: Attempt to avoid system name change on
	  Darwin platforms also.

Fri Jun 11 14:22:45 2004  Akinori MUSHA  <knu@iDaemons.org>

	* config.guess, config.sub: Attempt to avoid system name change on
	  Linux platforms.  We have been using "linux" instead of
	  "linux-gnu" on this branch.

Thu Jun 10 19:19:41 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/sdbm/init.c (fsdbm_store): sdbm should use StringValue().
	  [ruby-talk:103062]

Wed Jun  9 18:04:14 2004  akira yamada  <akira@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic::merge,
	  URI::Generic::route_from): accepts non-hierarchical URI.
	  [ruby-dev:23631]

	* test/uri/test_generic.rb (TestGeneric::test_route,
	  TestGeneric::test_merge): added tests for above changes.

Wed Jun  9 17:39:37 2004  Akinori MUSHA  <knu@iDaemons.org>

	* config.guess, config.sub: Update to a more recent version as of
	  2004-01-20.

	* configure.in: Add support for DragonFly BSD.

Wed Jun  2 20:16:03 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_new4): should share shared instance if it already
	  exists.  [ruby-dev:23665]

Wed Jun  2 12:41:53 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_gets_m): set lastline ($_) even when read line is
	  nil.  [ruby-dev:23663]

Fri May 28 11:20:31 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_eval): bad influence on frame node.

	* eval.c (eval): reverted wrongly removed condition.  [ruby-dev:23638]

Thu May 27 23:15:18 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/logger.rb: leading 0 padding of timestamp usec part.

	* lib/csv.rb (CSV.parse): [CAUTION] behavior changed.  in the past,
	  CSV.parse accepts a filename to be read-opened (it was just a
	  shortcut of CSV.open(filename, 'r')).  now CSV.parse accepts a
	  string or a stream to be parsed e.g.
	  CSV.parse("1,2\n3,r") #=> [['1', '2'], ['3', '4']]

	* lib/csv.rb: CSV::Row and CSV::Cell are deprecated.  these classes
	  are removed in the future.  in the new csv.rb, row is represented
	  as just an Array.  since CSV::Row was a subclass of Array, it won't
	  hurt almost all programs except one which depended CSV::Row#match.
	  and a cell is represented as just a String or nil(NULL).  this
	  change will cause widespread destruction.

      	      CSV.open("foo.csv", "r") do |row|
		row.each do |cell|
		  if cell.is_null       # using Cell#is_null
		    p "(NULL)"
		  else
		    p cell.data         # using Cell#data
		  end
		end
	      end

	    must be just;

	      CSV.open("foo.csv", "r") do |row|
		row.each do |cell|
		  if cell.nil?
		    p "(NULL)"
		  else
		    p cell
		  end
		end
	      end

	* lib/csv.rb: [CAUTION] record separator(CR, LF, CR+LF) behavior
	  change.  CSV.open, CSV.parse, and CSV,generate now do not force
	  opened file binmode.  formerly it set binmode explicitly.

	  with CSV.open, binmode of opened file depends the given mode
	  parameter "r", "w", "rb", and "wb".  CSV.parse and CSV.generate open
	  file with "r" and "w".

	  setting mode properly is user's responsibility now.

	* lib/csv.rb: accepts String as a fs (field separator/column separator)
	  and rs (record separator/row separator)

	* lib/csv.rb (CSV.read, CSV.readlines): added.  works as IO.read and
	  IO.readlines in CSV format.

	* lib/csv.rb: added CSV.foreach(path, rs = nil, &block).  CSV.foreach
	  now does not handle "| cmd" as a path different from IO.foreach.
	  needed?

	* test/csv/test_csv.rb: updated.

	* test/ruby/test_float.rb: added test_strtod to test Float("0").

Thu May 27 21:37:50 2004  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb (Pathname#initialize): refine pathname initialization
	  by pathname.

Thu May 27 20:22:05 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* io.c (rb_io_fwrite): check all case errno != 0 [ruby-dev:23648]

Thu May 27 14:53:13 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* io.c (rb_io_fwrite): workaround for bcc32's fwrite bug.
	  add errno checking.  [ruby-dev:23627]

Wed May 26 14:19:42 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_eval, eval): make line number consistent on eval with
	  Proc.  [ruby-talk:101253]

Wed May 26 13:59:17 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::skip_for_variable): Allow for
	  'do' after for statement

Wed May 26 13:56:03 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb (Generators::MarkUp::style_url): Fix
	  relative path to code CSS file

Wed May 26 13:14:52 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_init_copy): copy also positions.  [ruby-talk:100910]

Wed May 26 00:00:00 2004  why the lucky stiff  <why@ruby-lang.org>

	* ext/syck/syck.c (syck_new_parser): clear parser on init.
	  thanks, ts. [ruby-core:02931]

	* ext/syck/token.c (sycklex_yaml_utf8): buffer underflow.
	  thanks, ts. [ruby-core:02929]

	* lib/yaml/baseemitter.rb (indent_text): simpler flow block code.

	* lib/yaml.rb: added rdoc to beginning of lib.

Mon May 24 10:46:26 2004  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/rdoc/generators/template/html/html.rb: SYSTEM identifiers
	  must be absolute URIs

Sat May 22 12:00:04 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* MANIFEST: add new encodings in rexml.

	* ext/tk/MANIFEST: add recent files.

Sat May 22 05:37:11 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/remote-tk.rb: (NEW library) controll Tk interpreters
	  on the other processes by Tcl/Tk's 'send' command

Fri May 21 09:22:05 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_method_parameters):
	  Add ()'s around parameters that don't have them

Thu May 20 17:02:03 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (check_sizeof): define result size.  [ruby-core:02911]

	* lib/mkmf.rb (create_header): macro name should not include equal
	  sign.

Thu May 20 15:59:50 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* ext/socket/socket.c: fix SEGV. [ruby-dev:23550]

Thu May 20 14:35:52 2004  Tanaka Akira  <akr@m17n.org>

	* ext/socket/socket.c: check SCM_RIGHTS macro addition to
	  the msg_control field to test existence of file descriptor passing
	  by msg_control.

Thu May 20 12:38:06 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (flo_eq): always check if operands are NaN.
	  [ruby-list:39685]

Thu May 20 12:34:39 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_visibility):
	  At Ryan Davis' suggestion, honor visibility modifers if guarded by a
	  statement modifier

Thu May 20 12:22:13 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (have_type): do not check pointer to incomplete type,
	  which always get compiled.  [ruby-list:39683]

Wed May 19 11:09:00 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: change permition of TkObject#tk_send from
	  private to public

Tue May 18 14:00:46 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* node.h (NEW_DSTR): adjust list length.

	* parse.y (literal_concat): ditto.

Mon May 17 16:14:25 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* numeric.c (flo_to_s): it's preferable that "p 0.0" outputs "0.0"
	  instead of "0.0e+00". [ruby-dev:23480]

	* numeric.c (flo_to_s): it's preferable that "p 0.00000000000000000001"
	  outputs "1.0e-20" instead of "9.999999999999999e-21". (the precision
	  is considered, but there is assumption DBL_DIG == 15 in current
	  implementation)

Mon May 17 10:13:33 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (setup_domain_and_type): honor duck typing.
	  [ruby-dev:23522]

	* ext/socket/socket.c (sock_s_getnameinfo): ditto.

Mon May 17 01:15:23 2004  why the lucky stiff  <why@ruby-lang.org>

	* lib/yaml.rb: removed fallback to pure Ruby parser.

	* lib/yaml/baseemitter.rb (indent_text): was forcing a mod value
	  of zero at times, which kept some blocks from getting indentation.

	* lib/yaml/baseemitter.rb (node_text): rewriting folded scalars.

	* ext/syck/syck.h: reports style of scalars now, be they plain, block
	  single-, or double-quoted.

	* ext/syck/syck.c: ditto.

	* ext/syck/gram.c: ditto.

	* ext/syck/node.c: ditto.

	* ext/syck/token.c: ditto.

	* ext/syck/rubyext.c (yaml_org_handler): symbols loaded only
	  if scalar style is plain.

	* ext/syck/rubyext.c (yaml_org_handler): some empty strings were
	  loaded as symbols.

	* test/yaml/test_yaml.rb (test_perl_regexp): updated test to
	  match new regexp serialization.

Mon May 17 00:03:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/drb/drb.rb: Cosmetic documentation changes.

Sun May 16 22:36:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/test/unit.rb: Removed :nodoc: directive (it prevented effective
	  RDoc operation), and added file-level comment.

Sun May 16 20:55:49 2004  Tanaka Akira  <akr@m17n.org>

	* ext/dbm/dbm.c (fdbm_initialize): accept optional 3rd argument to
	  specify an open flag.
	  (Init_dbm): define open flags: DBM::READER, DBM::WRITER, DBM::WRCREAT
	  and DBM::NEWDB.

Sun May 16 13:10:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/test/unit/**/*.rb: Removed :nodoc: directives (many were
	  generating warnings, many were on private methods).

Sat May 15 01:41:34 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (eval): forgot to restore $SAFE value before evaluating
	  compiled node.  [ruby-core:02872]

Sat May 15 01:33:12 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* range.c (range_each_func): terminates loop if generating value
	  is same to @end.  [ruby-talk:100269]

Fri May 14 22:08:38 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_new4): should not reuse frozen shared string if
	  the original is not an instance of String. [ruby-talk:100193]

Fri May 14 18:39:25 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/canvas.rb: improve coords support for canvas items.
	  Now, supports all of the followings.
	    TkcLine.new(c, 0, 0, 100, 100, :fill=>'red')
	    TkcLine.new(c, [0, 0, 100, 100], :fill=>'red')
	    TkcLine.new(c, [0, 0], [100, 100], :fill=>'red')
	    TkcLine.new(c, [[0, 0], [100, 100]], :fill=>'red')
	    TkcLine.new(c, :coords=>[0, 0, 100, 100], :fill=>'red')
	    TkcLine.new(c, :coords=>[[0, 0], [100, 100]], :fill=>'red')

Fri May 14 12:11:43 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* util.c (ruby_strtod): strtod("0", &end); => end should point '\0'.
	 [ruby-dev:23498]

Thu May 13 15:47:30 2004  akira yamada  <akira@ruby-lang.org>

	* lib/net/telnet.rb (Net::Telnet::login): "options" can specify
	  regexps for login prompt and/or password prompt.

Thu May 13 14:23:45 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* hash.c (delete_if_i): use st_delete_safe() (via
	  rb_hash_delete()) instead of returning ST_DELETE.
	  backport from HEAD.  [ruby-dev:23487]

Thu May 13 13:01:30 2004  akira yamada  <akira@ruby-lang.org>

	* lib/uri/mailto.rb (URI::MailTo::to_s): should include fragment.

Thu May 13 11:04:08 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* pack.c (pack_pack): always add with null for 'Z'.

	* pack.c (pack_unpack): terminated by null for 'Z'.  [ruby-talk:98281]

Wed May 12 19:59:43 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (have_type, check_sizeof): replace unusable characters.
	  [ruby-talk:99788]

Wed May 12 17:41:42 2004  Tanaka Akira  <akr@m17n.org>

	* lib/resolv.rb (Resolv::DNS::Config): make it configurable without
	  external file such as /etc/resolv.conf.

Wed May 12 14:37:27 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_x509name.c: attribute value of DC (short name of
	  domainComponent) should be IA5String.

Wed May 12 13:20:19 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk/composite.rb: improve configure methods (based on
	  the proposal of [ruby-talk:99671]).

Wed May 12 11:51:08 2004  Dave Thomas  <dave@pragprog.com>

	* class.c (rb_obj_singleton_methods): fix rdoc

Mon May 10 21:44:42 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb: Change scheme for
	  looking up symbols in  HTML generator.

Mon May 10 16:45:21 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (eval): warning during eval should not cause deadlock.
	  [ruby-talk:98651]

	* eval.c (rb_eval): raise TypeError exception for superclass
	  mismatch.  [ruby-list:39567]

Mon May 10 12:11:37 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb: Hack to search parents
	  for unqualified constant names.

Mon May 10 12:11:37 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb: Hack to search parents
	  for unqualified constant names.

Sun May  9 22:37:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/net/ftp.rb: improved documentation
	* lib/net/imap.rb: ditto
	* lib/net/pop.rb: ditto
	* lib/net/smtp.rb: ditto
	* lib/net/telnet.rb: ditto

Fri May  7 21:50:21 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::parse_include): Allow
	  multiple arguments to 'include'

Fri May  7 21:31:56 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (fu_list): Array() breaks pathes including "\n".
	  [ruby-core:02843]

Fri May  7 11:25:53 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* util.c (ruby_strtod): "0.0000000000000000001" should be converted
	  to 1.0e-19 instead of 0.0. (leading zeros aren't significant digits)
	  [ruby-talk:99318] [ruby-dev:23465]

Fri May  7 10:00:05 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/tkutil.c (get_eval_string_core): bug fix. [ruby-dev:23466]

Thu May  6 22:13:17 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* ext/socket/socket.c (ippaddr): use NUMERICHOST if can not resolve
	  hostname.

Thu May  6 14:22:29 2004  why the lucky stiff  <why@ruby-lang.org>

	* lib/yaml/rubytypes.rb (to_yaml): added instance variable handling
	  for Ranges, Strings, Structs, Regexps.

	* lib/yaml/rubytypes.rb (to_yaml_fold): new method for setting a
	  String's flow style.

	* lib/yaml.rb (YAML::object_maker): now uses Object.allocate.

	* ext/syck/gram.c: fixed transfer methods on structs, broke it
	  last commit.

Thu May  6 11:40:28 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (string): accept NIL.

	* lib/net/imap.rb (body_type_basic): allow body-fields omissions.

Thu May  6 01:59:04 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb (Generators::HtmlMethod::params):
	  Don't include the &block parameter if we have explicit
	  yield parameters.

Wed May  5 03:40:29 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/rinda/ring.rb: use recv instead of recvfrom.

Tue May  4 23:52:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/gserver.rb: documented

Tue May  4 23:46:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/xmlrpc/README.txt: introduced for documentation purposes

Mon May  3 09:47:24 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_method_or_yield_parameters):
	  Fix parsing bug if yield called within 1 line block

Sun May  2 01:04:38 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib, ext/tk: renewal Ruby/Tk

Fri Apr 30 20:08:41 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* time.c (SIZEOF_TIME_T): support SIZEOF_TIME_T == SIZEOF_INT.

Tue Apr 27 13:12:42 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): too many line trace call. (ruby-bugs PR#1320)

Tue Apr 27 08:41:28 2004  why the lucky stiff  <why@ruby-lang.org>

	* lib/yaml/rubytypes.rb: passing Range tests.

	* ext/syck/syck.h: version 0.44.

	* ext/syck/gram.c: transfers no longer open an indentation.
	  fixed transfers which precede blocks.

	* ext/syck/token.c: ditto.

	* ext/syck/syck.c: fixed segfault if an anchor has been released already.

	* ext/syck/node.c (syck_free_members): organized order of free'd nodes.

	* ext/syck/rubyext.c (syck_emitter_write_m): test for proper string with
	  StringValue.

Mon Apr 26 23:56:54 2004  Daniel Kelley  <news-1082945587@dkelley.gmp.san-jose.ca.us>

	* README.EXT, README.EXT.ja: fixed wrong function signature.
	  [ruby-talk:98349]

Mon Apr 26 21:40:09 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/code_objects.rb (RDoc::Context::add_alias): Only alias
	  to instance methods.

Sat Apr 24 10:38:31 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/markup/simple_markup.rb (SM::SimpleMarkup::group_lines):
	  Fix bug where consecutive headings are merged.

Fri Apr 23 23:26:13 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb: $hdrdir should not contain macros for backward
	  compatibilitiy.  [bruby-dev:28]

	* version.c (ruby_show_copyright): obtain copyright year from
	  RUBY_RELEASE_YEAR.

	* win32/resource.rb: ditto.

	* win32/resource.rb: default rubyw icon to ruby.ico, and let DLL also
	  include them.

	* win32/resource.rb: include winver.h for older WindowsCE.

Fri Apr 23 16:38:46 2004  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb: sync taint/freeze flag between
	  a pathname object and its internal string object.

Fri Apr 23 14:52:08 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (stmt, arg, aref_args): should not make sole splat into
	  array, in aref_args other than aref with op_asgn.

Fri Apr 23 14:14:38 2004  Tanaka Akira  <akr@m17n.org>

	* lib/resolv.rb: don't use Regexp#source to embed regexps.
	  [ruby-dev:23432]

Thu Apr 22 04:15:36 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (aref_args): should pass expanded list.  [ruby-core:02793]

Thu Apr 22 01:12:57 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (flo_to_s): tweak output string based to preserve
	  decimal point and to remove trailing zeros.  [ruby-talk:97891]

	* string.c (rb_str_index_m): use unsigned comparison for T_FIXNUM
	  search.  [ruby-talk:97342]

Wed Apr 21 22:57:27 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/rinda/rinda.rb, test/rinda/test_rinda.rb: check Hash tuple size.

Wed Apr 21 20:05:00 2004  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (URI::HTTP#proxy_open): set Host: field explicitly.
	  [ruby-list:39542]

Mon Apr 19 18:11:15 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_hash_equal): returns true if two hashes have same set
	  of key-value set.  [ruby-talk:97559]

	* hash.c (rb_hash_eql): returns true if two hashes are equal and
	  have same default values.

Mon Apr 19 08:19:58 2004  Doug Kearns  <djkea2@mugca.its.monash.edu.au>

	* dln.c, io.c, lib/benchmark.rb, lib/cgi.rb, lib/csv.rb, lib/date.rb,
	  lib/ftools.rb, lib/getoptlong.rb, lib/logger.rb, lib/matrix.rb,
	  lib/monitor.rb, lib/set.rb, lib/thwait.rb, lib/timeout.rb,
	  lib/yaml.rb, lib/drb/drb.rb, lib/irb/workspace.rb, lib/net/ftp.rb,
	  lib/net/http.rb, lib/net/imap.rb, lib/net/telnet.rb,
	  lib/racc/parser.rb, lib/rinda/rinda.rb, lib/rinda/tuplespace.rb,
	  lib/shell/command-processor.rb, lib/soap/rpc/soaplet.rb,
	  lib/test/unit/testcase.rb, lib/test/unit/testsuite.rb: typo fix.

Mon Apr 19 08:14:18 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::find_body): Allow for
	  #ifdef HAVE_PROTOTYPES

Fri Apr 16 22:33:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* ext/iconv/iconv.c: nearly finished RDoc comments.

Fri Apr 16 17:04:07 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_equal): always returns true or false, never
	  returns nil. [ruby-dev:23404]

Fri Apr 16 08:27:02 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/extmk.rb: skip linking when libraries to be preloaded not
	  compiled.  [ruby-list:39561]

Thu Apr 15 23:21:52 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (pst_success_p): new method Process::Status#success?.
	  [ruby-dev:23385]

Thu Apr 15 17:12:13 2004  Tanaka Akira  <akr@m17n.org>

	* ext/gdbm/gdbm.c (Init_gdbm): define GDBM::READER, GDBM::WRITER,
	  GDBM::WRCREAT and GDBM::NEWDB.
	  (fgdbm_initialize): use specified read/write flag.

Wed Apr 14 11:29:56 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* numeric.c (flo_eq): workaround for bcc32's bug.
	  (ruby-bugs-ja:PR#594)

Wed Apr 14 13:06:35 2004  Doug Kearns  <djkea2@mugca.its.monash.edu.au>

	* array.c, enum.c, eval.c, file.c, io.c, numeric.c, object.c, prec.c,
	  process.c, re.c, string.c: typos in RDoc comments.  [ruby-core:02783]

Wed Apr 14 11:06:38 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::scan): Changed
	  behavior of :enddoc: -- it now unconditionally terminates
	  processing of the current file.

Wed Apr 14 11:03:22 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* defines.h: include <net/socket.h> to get fd_set definition in BeOS.

Tue Apr 13 23:06:30 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/rinda/rinda.rb: change pattern matching.
	  a === b -> a == b || a === b. [druby-ja:98]

	* test/rinda/test_rinda.rb: ditto.

Tue Apr 13 19:54:29 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb: should not overwrite HTTP request header.
	  [ruby-list:39543]

Tue Apr 13 01:30:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* ext/iconv/iconv.c: RDoc documentation (from RD; nearly finished).
	* ext/iconv/charset_alias.rb: Prevent from RDoc'ing.

Mon Apr 12 19:11:29 2004  Eric Hodel  <drbrain@segment7.net>

	* gc.c (rb_gc_copy_finalizer): typo.  [ruby-core:02774]

Mon Apr 12 18:52:32 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_x509name.c (ossl_x509name_init_i): should return
	  a value.

Mon Apr 12 10:43:47 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* dir.c (rb_glob2, rb_glob, rb_globi, push_globs, push_braces,
	  rb_push_glob): fix memory leak. (leaked when block was interrupted)

Mon Apr 12 10:27:37 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* bcc32/Makefile.sub: backport SIZEOF_TIME_T definition from 1.9.

	* win32/Makefile.sub: ditto.

	* wince/Makefile.sub: ditto.

Sun Apr 11 19:12:35 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (require_libraries): restore source file/line after
	  statically linked extensions initialized.  [ruby-dev:23357]

Sun Apr 11 10:47:04 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/code_objects.rb (RDoc::TopLevel::add_class_or_module): Toplevel
	  classes and modules are a special case too... (handle extending existing
	  classes with or without :enddoc:)

Sat Apr 10 23:51:13 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/code_objects.rb (RDoc::Context::add_to): Implementation of :enddoc:
	  made one too many assumptions...

Sat Apr 10 00:00:19 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/markup/simple_markup/inline.rb: Fix problem
	  with \_cat_<b>dog</b>

Wed Apr  7 00:19:50 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/rinda/rinda.rb: fix hash tuple bug.

	* lib/rinda/tuplespace.rb: ditto.

	* test/rinda/test_rinda.rb

Tue Apr  6 18:24:18 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_reopen): should use rb_io_check_io().

Tue Apr  6 16:46:09 2004  Tanaka Akira  <akr@m17n.org>

	* configure.in: check the size of time_t.

	* time.c (time_add): new function.
	  (time_plus): use time_add.
	  (time_minus): use time_add.

Tue Apr  6 13:21:30 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket/socket.c (make_hostent): must return value.

Tue Apr  6 00:05:30 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/rinda/rinda.rb: add require 'drb/drb'

Mon Apr  5 08:18:23 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/rdoc.rb: Remove leading ./ from file names so that cross
	  references work properly.

Sun Apr  4 20:33:42 2004  Minero Aoki  <aamine@loveruby.net>

	* eval.c (Init_load): make $LOADED_FEATURES built-in.
	  [ruby-dev:23299]

	* ruby.c (ruby_prog_init): make $PROGRAM_NAME built-in.

	* lib/English.rb: remove $LOADED_FEATURES and $PROGRAM_NAME.

Sun Apr  4 14:01:20 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/options.rb (Options::parse): Allow multiple -x options to RDoc.
	  Fix bug where files weren't being excluded properly

Sat Apr  3 17:11:05 2004  why the lucky stiff  <why@ruby-lang.org>

	* ext/syck/syck.h: version 0.43.

	* ext/syck/lib/gram.c: allow root-level inline collections.
	 [ruby-talk:94922]

	* lib/yaml/rubytypes.rb (Symbol#to_yaml): emit symbols as implicits.
	 [ruby-talk:94930]

	* ext/syck/bytecode.c: turn off default implicit typing.

	* ext/syck/implicit.c: detect base60 integers.

	* ext/syck/rubyext.c: handle base60, as well as hex and octal
	  with commas.  implicit typing of ruby symbols.

Fri Apr  2 17:27:17 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (top_include): include in the wrapped load is done for
	  the wrapper, not for a singleton class for wrapped main.
	  [ruby-dev:23305]

Fri Apr  2 15:13:44 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_eq): use temporary double variable to save the
	  result (internal float register may be bigger than 64 bits, for
	  example, 80 bits on x86).  [ruby-dev:23311]

Fri Apr  2 14:35:26 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (block_pass): should generate unique identifier of the
	  pushing block.  [ruby-talk:96363]

Fri Apr  2 07:31:38 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (make_hostent): fix memory leak, based on
	  the patch from HORIKAWA Hisashi <vzw00011@nifty.ne.jp>.

Thu Apr  1 22:55:33 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb: Allow rdoc comments in
	  =begin rdoc/=end

	* lib/rdoc/parsers/parse_rb.rb: Fix problem with comment in
	  top-level method being taken as file comment.

Thu Apr  1 22:55:04 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_options.rb: Fix undefined variable warning.

Thu Apr  1 19:58:37 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/soap/mapping/{factory.rb,registry.rb}: fixed illegal mapped URI
	  object with soap/marshal.
	  added URIFactory class for URI mapping.  BasetypeFactory checks
	  instance_variables when original mapping is not allowed (ivar must
	  be empty).  Instance of URI have instance_variables but it must be
	  llowed whenever original mapping is allowed or not.

	* lib/xsd/datatypes.rb: check the smallest positive non-zero
	  single-precision float exactly instead of packing with "f".
	  [ruby-talk:88822]

	* lib/soap/mapping/rubytypeFactory.rb: should not dump singleton class.
	  [ruby-dev:22588]
	  c = class << Object.new; class C; self; end; end; SOAPMarshal.dump(c)

Wed Mar 31 19:06:23 2004  Tanaka Akira  <akr@m17n.org>

	* time.c (year_leap_p): new function.
	  (timegm_noleapsecond): ditto.
	  (search_time_t): use timegm_noleapsecond instead of
	  mktime for first guess.

Wed Mar 31 12:04:04 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/delegate.rb (DelegateClass): define internal methods of the
	  result class, but not metaclass of the caller.  [ruby-talk:96156]

	* intern.h: provide proper prototypes.  [ruby-core:02724]

	* ruby.h: missing.h is now prerequisite to intern.h.

Tue Mar 30 20:25:34 2004  Tanaka Akira  <akr@m17n.org>

	* time.c (search_time_t): limit guess range by mktime if it is
	  available.  [ruby-dev:23274]

Sun Mar 28 14:16:59 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/net/pop.rb (auth): failed when account/password include "%".
	  [ruby-talk:95933]

Sat Mar 27 21:40:41 2004  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb: permit extra semicolon in content-type field.

Sat Mar 27 10:40:48 2004  Tanaka Akira  <akr@m17n.org>

	* (lib/pp.rb, lib/prettyprint.rb): define seplist in PP::PPMethods
	  instead of PrettyPrint.

Thu Mar 25 23:28:52 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_overflow_p): backport 1.9 usec overflow function.
	  (ruby-bugs PR#1307)

Thu Mar 25 23:15:24 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_options.rb (RI::Options::show_version):
	  Add --version option

Thu Mar 25 04:16:18 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_options.rb (RI::Options): Add the --list-names option,
	  which dumps our all known names

Thu Mar 25 03:57:47 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_util.rb (NameDescriptor::initialize): No longer
	  allow nested classes to be designated using "."--you must
	  now use "::"

Thu Mar 25 02:00:18 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/template/html/one_page_html.rb (Page):
	  Fix to work with C modules.

Wed Mar 24 21:17:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/uri.rb: Documented (thanks Dmitry V. Sabanin).
	* lib/uri/common.rb: Ditto.
	* lib/uri/ftp.rb: Ditto.
	* lib/uri/generic.rb: Ditto.
	* lib/uri/http.rb: Ditto.
	* lib/uri/https.rb: Ditto.
	* lib/uri/ldap.rb: Ditto.
	* lib/uri/mailto.rb: Ditto.
	  (All backported from 1.9)

Wed Mar 24 18:48:26 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb ($ruby, $topdir, $hdrdir): should not be affected by
	  DESTDIR after installed.

	* lib/mkmf.rb (RUBY): / is not recognized as path separator on
	  nmake/bmake. [ruby-list:39388]

	* lib/mkmf.rb (init_mkmf): $INCFLAGS also should be lazy-evaluated.

Wed Mar 24 12:32:56 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::handle_class_module):
	  Don't document methods if we don't know for sure the
	  class or module.

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_class):
	  Don't store documentation for singleton classes if we
	  don't know the real class.

Wed Mar 24 11:11:26 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb (Generators::HTMLGenerator::load_html_template):
	  Allow non-RDoc templates by putting a slash in the template name

Mon Mar 22 16:19:57 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ruby.1: add -width option to .Bl for old groff.

Sun Mar 21 21:11:16 2004  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/shell/*: bug fix for Shell#system(command_line_string).

Sat Mar 20 20:57:10 2004  David Black  <dblack@wobblini.net>

	* lib/scanf.rb: Backported 1.9 branch
	  modifications/corrections to 1.8 branch

Sat Mar 20 23:51:03 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* eval.c (rb_require_safe): preserve old ruby_errinfo.
	  [ruby-talk:95409]

	* eval.c (rb_f_raise): should not clear backtrace information if
	  exception object already have one.

Sat Mar 20 15:25:36 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/template/html/html.rb (RDoc::Page): Force
	  page background to white.

Sat Mar 20 09:52:33 2004  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date.rb, lib/date/format.rb: _parse() now accepts fractional
	  part of second minute that follows a comma or a full stop.

Fri Mar 19 01:55:57 2004  Mauricio Fernandez  <batsman.geo@yahoo.com>

	* io.c (rb_io_sync): need not to check writable. [ruby-core:02674]

Thu Mar 18 21:44:38 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb: backport drb.rb 1.16.

Thu Mar 18 16:22:38 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_eq): avoid false positive by using scope and
	  dyna_vars.  no longer use frame.uniq.

Wed Mar 17 14:44:43 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* dir.c (range): fix possible "\0" overrun. (in case of "\0-")

Mon Mar 15 07:39:13 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_yield_0): should not re-submit TAG_BREAK if this
	  yield is not break destination. [ruby-dev:23197]

Sat Mar 13 14:28:16 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* test/drb/test_drbssl.rb: rescue LoadError. (Barkport from main
	  trunk)

	* test/drb/test_drbunix.rb: ditto.

Wed Mar 10 22:28:09 2004  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (remove_dir): should handle symlink correctly.
	  This patch is contributed by Christian Loew.  [ruby-talk:94635]
	  (Backport from main trunk)

Wed Mar 10 16:28:42 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (return_jump): set return value to the return
	  destination.  separated from localjump_destination().

	* eval.c (break_jump): break innermost loop (or thread or proc).

	* eval.c (rb_yield_0): set exit_value for block break.

Wed Mar 10 15:58:43 2004  Ryan Davis  <ryand@zenspider.com>

	* eval.c (eval): Only print backtrace if generating the backtrace
	  doesn't generate an exception.  [ruby-core:02621]

Tue Mar  9 13:04:26 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_ungetc): raise IOError instead of calling
	  rb_sys_fail().  [ruby-talk:23181]

Mon Mar  8 19:32:28 2004  akira yamada  <akira@ruby-lang.org>

	* lib/uri/common.rb (URI::REGEXP::PATTERN::HOSTPORT): (?:#{PORT})
	  -> (?::#{PORT}).  [ruby-dev:23170]

Mon Mar  8 15:31:41 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* dir.c (range): treat incomplete '[' as ordinary character (like
	  has_magic does).

	* dir.c (range):  Cancel above change. More discussion is needed.

Sun Mar  7 22:37:46 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* test/drb/ut_drb.rb: use 'druby://localhost:0'. [ruby-dev:23078]

	* test/drb/ut_eval.rb: ditto.

	* test/drb/ut_large.rb: ditto.

	* test/drb/ut_safe1.rb: ditto.

	* test/drb/ut_drb_drbssl.rb: use 'drbssl://localhost:0'.

Sun Mar  7 16:22:26 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* Makefile.in (lex.c): use $? instead of $<.

Fri Mar  5 00:54:14 2004  Dave Thomas  <dave@pragprog.com>

	* lib/test/unit.rb: MOve RDoc documentation so that you can
	  now say 'ri Test::Unit'

Tue Mar  2 12:32:59 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub, wince/Makefile.sub (config.h): shouldn't check
	  defined? NORETURN. [ruby-dev:23100]

Mon Mar  1 12:24:10 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_alias):
	  Allow aliases to have parentheses

Sun Feb 29 23:14:53 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_class):
	  Handle :nodoc: on singleton classes.

Sat Feb 28 10:58:49 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* MANIFEST: add test_erb.rb

	* lib/erb.rb, test/erb/test_erb.rb: don't forget filename,
	  if both filename and safe_level given. [ruby-dev:23050]

Fri Feb 27 01:00:09 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb, test/drb/drbtest.rb: require drb/eq.rb by default

Wed Feb 25 21:16:25 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* instruby.rb (with_destdir): should return the given argument if no
	  DESTDIR is given.

	* instruby.rb: use path name expansion of cmd.exe.

Wed Feb 25 09:35:22 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* error.c (NameError::Message): new class for lazy evaluation of
	  message to ensure replaced before marshalling. merge from HEAD.
	  (ruby-bugs-ja:PR#588)

	* eval.c (rb_method_missing): use NameError::Message. merge from
	  HEAD. (ruby-bugs-ja:PR#588)

Tue Feb 24 18:59:37 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* dir.c (glob_helper): '**/' should not match leading period
	  unless File::FNM_DOTMATCH is set. (like '*/') [ruby-dev:23014]

Tue Feb 24 13:22:21 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/rdoc.rb (RDoc::RDoc::normalized_file_list): Attempt to get better
	  heuristics on which files to include and exclude. Now only include
	  non-standard files if they are explicitly named in ARGV.

Tue Feb 24 07:23:30 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb: Deal with :stopdoc: when
	  choosing a default main page to display (ie. don't select a page
	  if we don't have documentation for it).

Tue Feb 24 06:40:14 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RubyLex::identify_identifier): Handle
	  class variables in code listings

Tue Feb 24 06:40:14 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RubyLex::identify_identifier): Handle
	  class variables in code listings

Tue Feb 24 06:32:27 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::do_aliases): Handle
	  aliases in C files.

Tue Feb 24 06:16:22 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/rdoc.rb (RDoc::RDoc::document): Now create op dir _before_
	  parsing files.

Tue Feb 24 06:08:47 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_constant):
	  Start collecting text of constant values earlier: was missing
	  values in output if there was no space after '='

Tue Feb 24 06:08:25 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb: Escape contant values.

Tue Feb 24 03:45:06 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_config.c (ossl_config_each): add new method
	  OpenSSL::Config#each. it iterates with section name, field name
	  and value.

	* ext/openssl/ossl_config.c (Init_ossl_config): include Enumerable.

Mon Feb 23 09:16:35 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* instruby.rb (DOSISH): embedded path in batch files should not be
	  prefixed by DESTDIR.  [ruby-core:02186]

Sun Feb 22 09:54:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* re.c: corrected documentation format (again)

Sun Feb 22 09:43:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* re.c: corrected documentation format (rb_reg_initialize_m)

Sat Feb 21 22:36:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* ext/zlib/zlib.c: documented, but needs more effort.

Sat Feb 21 11:12:15 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* missing/os2.c, missing/x68.c: typo fix.  pointed out by greentea.

Fri Feb 20 18:59:47 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/irb/init.rb (IRB::IRB.parse_opts): add -I option to
	  irb. [ruby-dev:39243]

Thu Feb 19 23:24:16 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb (Generators::HtmlClass::build_attribute_list):
	  Support visibility modifiers for attributes

Thu Feb 19 23:24:16 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb (Generators::HtmlClass::build_attribute_list):
	  Support visibility modifiers for attributes

Thu Feb 19 22:39:04 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* test/rinda/test_rinda.rb: DRb.start_service only once in testsuites.
	  DRb.start_service could handle this.

Thu Feb 19 22:19:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/ostruct.rb: documented

Thu Feb 19 21:28:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* ext/strscan/strscan.c: improved documentation

Thu Feb 19 03:10:52 2004  Minero Aoki  <aamine@loveruby.net>

	* ext/strscan/strscan.c: synchronized with main trunk (rev 1.11).

Thu Feb 19 02:30:34 2004  Minero Aoki  <aamine@loveruby.net>

	* ext/strscan/strscan.c: documentation checked.

Thu Feb 19 00:11:05 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/markup/simple_markup/preprocess.rb (SM::PreProcess::handle):
	  Strip extraneous space from filenames in :include:

Wed Feb 18 22:52:00 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/unix.rb: remove O_NONBLOCK, thanks \ay

Wed Feb 18 22:47:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* ext/strscan/strscan.c: documented

Wed Feb 18 22:03:11 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* test/*: should not depend on $KCODE.

Wed Feb 18 17:18:01 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/win32ole/win32ole.c: need to include <olectl.h> on Cygwin.

Wed Feb 18 10:40:38 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* sprintf.c (rb_f_sprintf): do not prepend dots for negative
	  numbers if FZERO is specified.  [ruby-dev:39218]

Tue Feb 17 23:40:34 2004  Guy Decoux  <ts@moulon.inra.fr>

	* sprintf.c (rb_f_sprintf): preserve original val for
	  format_integer. [ruby-talk:92975]

Tue Feb 17 23:28:45 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* test/ruby/marshaltestlib.rb: common marshal testcase added.

	* test/ruby/test_marshal.rb: use above testsuite.

	* test/soap/marshal/test_marshal.rb: ditto.

	* test/soap/marshal/cmarshal.rb: removed (not used).

Tue Feb 17 10:51:23 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/syck/rubyext.c (syck_emitter_end_object): takes only one arg.

Tue Feb 17 01:35:28 2004  Tanaka Akira  <akr@m17n.org>

	* eval.c (rb_eval): care that another thread replace NODE_DREGX_ONCE
	  to NODE_LIT.  [ruby-dev:22920]

Tue Feb 17 01:24:35 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* bcc32/Makefile.sub, win32/Makefile.sub (config.h): define
	  STACK_GROW_DIRECTION. [ruby-dev:22910]

	* bcc32/Makefile.sub (config.h): add newer checks.

	* wince/Makefile.sub (config.h): define NEED_IO_SEEK_BETWEEN_RW.

Tue Feb 17 00:38:10 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/rinda/tuplespace.rb: TupleSpace#initialize, stop doubling timeout

Tue Feb 17 00:18:03 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* test/rinda/test_rinda.rb: import test_rinda.rb

Tue Feb 17 00:14:30 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* bcc32/Makefile.sub: avoid warning "Redefinition of macro
	  'HAVE_GETLOGIN'".

	* vms/config.h_in: ditto.

Mon Feb 16 23:28:14 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/csv.rb: document reduction.  [ruby-core:02429]

Mon Feb 16 22:08:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/generator.rb: corrected doc format
	* lib/rinda/rinda.rb: added documentation (from Hugh Sasse)
	* lib/rinda/tuplespace.rb: ditto

Mon Feb 16 20:41:32 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* bcc32/Makefile.sub: show more warnings. (refering to mingw)

	* bcc32/setup.mak: ditto.

Mon Feb 16 13:39:44 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* dir.c (rb_glob, rb_globi): add const.

	* ruby.h: ditto.

Mon Feb 16 02:16:33 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* bcc32/Makefile.sub: should warn suspicious pointer conversion.

	* bcc32/setup.mak: ditto.

Sun Feb 15 19:06:42 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/rinda/tuplespace.rb: TupleSpace#read(tpl, 0), raise
	  RequestExpiredError if not found.

Sun Feb 15 15:56:46 2004  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c: add IDispatch wrapper in val2variant.
	  Thanks, arton.

Sun Feb 15 01:46:05 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/mkmf.rb: absolute path of ruby is assigned to $(RUBY).
	  [ruby-dev:22870]

Sat Feb 14 11:29:41 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* sample/drb/*: import lib/drb/sample

Sat Feb 14 11:08:23 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb: add pretty_print, thanks gotoken.

Fri Feb 13 12:35:08 2004  Minero Aoki  <aamine@loveruby.net>

	* test/fileutils/test_fileutils.rb: File.link may raise EINVAL and
	  EACCES on Windows.

Thu Feb 12 21:45:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/ftools.rb: documented

Thu Feb 12 21:25:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/base64.rb: backported from HEAD (modularised and documented)

Thu Feb 12 20:31:48 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (create_tmpsrc): cpp32 of Borland C++ ignores #error
	  directives in DOS line-ending files at all.

Thu Feb 12 02:23:56 2004  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb: use assert_raise instead of assert_raises.

	* lib/pp.rb: ditto.

	* lib/time.rb: ditto.

	* lib/tsort.rb: ditto.
	  use TSortHash and TSortArray instead of Hash and Array in test.

Wed Feb 11 20:01:12 2004  akira yamada  <akira@ruby-lang.org>

	* test/ruby/test_file.rb (TestFile::test_fnmatch): added tests for
	  File.fnmatch. [ruby-dev:22815][ruby-dev:22819]

	* test/ruby/test_proc.rb (TestProc::test_eq): added a
	  test.  [ruby-dev:22599]

	* test/ruby/test_proc.rb (TestProc::test_eq): added tests for
	   Proc#==.  [ruby-dev:22592], [ruby-dev:22601]

Tue Feb 10 16:43:56 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (umethod_bind): purge unused check.  [ruby-dev:22850]

Mon Feb  9 17:16:00 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/rdoc/parsers/parse_c.rb: escape '{' and '}' to avoid warnings.

Mon Feb  9 13:00:55 2004  Hirokazu Yamamoto  <ocean@m2.ccsnet.ne.jp>

	* dir.c (fnmatch): File.fnmatch('*?', 'a') should return true.
	  [ruby-dev:22815]

	* dir.c (fnmatch): File.fnmatch('\[1\]' , '[1]') should return true.
	  [ruby-dev:22819]

Sun Feb  8 16:46:13 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/pp.rb (PP::PPMethods::object_address_group): suppress negative
	  sign for higher heap areas.

Fri Feb  6 22:48:16 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb (gen_url): Support
	  https in RDoc hyperlinks

Fri Feb  6 22:41:22 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/pp.rb (PPInspectTest#test_to_s_with_iv): rollback the previous
	  commit.  [ruby-dev:22813]

Fri Feb  6 22:22:50 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/pp.rb (PPInspectTest#test_to_s_with_iv): remove instance
	  variable which is defined in the test.

Fri Feb  6 00:48:37 2004  Tanaka Akira  <akr@m17n.org>

	* lib/prettyprint.rb (PrettyPrint#first?): obsoleted.

Thu Feb  5 23:56:55 2004  Tanaka Akira  <akr@m17n.org>

	* lib/prettyprint.rb (PrettyPrint#seplist): added.

	* lib/pp.rb (PPMethods#pp_object): use seplist.
	  (PPMethods#pp_hash): ditto.
	  (Array#pretty_print): ditto.
	  (Struct#pretty_print): ditto.
	  (MatchData#pretty_print): ditto.

	* lib/set.rb (Set#pretty_print): use seplist.

Wed Feb  4 02:12:06 2004  Tanaka Akira  <akr@m17n.org>

	* file.c (test_l): fix wrong method name in document.
	  (test_S): ditto.
	  (test_b): ditto.
	  (test_c): ditto.
	  (test_suid): ditto.
	  (test_sgid): ditto.
	  (test_sticky): ditto.

Tue Feb  3 08:04:57 2004  Tanaka Akira  <akr@m17n.org>

	* lib/pp.rb (Struct#pretty_print_cycle): follow 1.8 style.

Mon Feb  2 19:33:49 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: backport from 1.9 for Interix.

	* dln.c (dln_load): ditto.

Mon Feb  2 13:31:51 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/net/http.rb (canonical_each): fix merge miss.

Mon Feb  2 01:54:00 2004  Tanaka Akira  <akr@m17n.org>

	* lib/pp.rb (Struct#pretty_print): make it 1.8 style.
	  (Numeric#pretty_print, FalseClass#pretty_print)
	  (TrueClass#pretty_print, Module#pretty_print): fix pp for objects
	  with instance variables.  [ruby-talk:91157]

	* lib/open-uri.rb (URI::Generic#find_proxy): return nil on loopback
	  address.

	* lib/resolv-replace.rb (BasicSocket#send): don't replace because
	  it has no hostname argument.
	  (IPSocket.getaddress): raise SocketError instead of
	  Resolv::ResolvError for errors.
	  (TCPSocket#initialize, UDPSocket#bind, UDPSocket#connect)
	  (SOCKSSocket#initialize): use IPSocket.getaddress instead of
	  Resolv.getaddress.
	  (UDPSocket#send): recognize 3 arguments form.  try all addresses on
	  4 arguments form.

Sun Feb  1 18:17:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/net/http.rb: merged coding style changes from HEAD.

Sun Feb  1 16:15:00 2004  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/test/unit.rb: rearranged documentation for RDoc's sake.
	* lib/matrix.rb: improved documentation.
	* lib/net/http.rb: slight documentation formatting improvement.

Sun Feb  1 05:30:06 2004  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (URI::Generic#find_proxy): warn HTTP_PROXY.
	 raise an errror on non-http proxy URI.
	 (OpenURI::Buffer#<<): make a tempfile binmode.  [ruby-talk:90793]

Sat Jan 31 09:20:32 2004  NAKAMURA, Hiroshi  <nakahiro@sairon.co.jp>

	* sample/openssl/gen_csr.rb: wrong usage string.

Sat Jan 31 01:00:32 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/soap/wsdlDriver.rb, lib/wsdl/soap/operation.rb: add support of
	  "parts" attribute of soap:body element in WSDL.

	* lib/wsdl/xmlSchema/schema.rb: friendly warning message for
	  simpleType element which is not supported for now.

	* lib/soap/mapping/factory.rb: deleted unused methods.

	* lib/soap/mapping/rubytypeFactory.rb: do no ignore case while xsi:type
	  string <-> Ruby class name matching.

	* test/wsdl/soap/{soapbodyparts.wsdl,test_soapbodyparts.wsdl}: new
	  files.

Thu Jan 29 23:56:00 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* util.c (mblen): fix overrun.  [ruby-dev:22672]

Thu Jan 29 22:41:53 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb: Allow 'link:' in Tidylinks.
	  THis means you can write "see f1[link:files/f1_rb.html]".

Thu Jan 29 15:33:23 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_x509hame.c (ossl_x509name_initialize): change
	  second argument. it expected to be a Hash not an Integer.

	* ext/openssl/ossl_x509name.c (ossl_x509name_add_entry): add new
	  function for OpenSSL::X509::Name#add_entry.

	* ext/openssl/ossl_x509name.c (ossl_x509name_to_a): append ASN.1
	  tag number to each element of return value.

	* ext/openssl/ossl_x509name.c (Init_ossl_x509name): add constants
	  OpenSSL::X509::Name::DEFAULT_OBJECT_TYPE and OBJECT_TYPE_TEMPLATE.

	* ext/openssl/lib/openssl/x509.rb (OpenSSL::X509::Name#initialize):
	  second argument takes OBJECT_TYPE_TEMPLATE by default.

	* sample/openssl/gen_csr.rb: use OpenSSL::X509::Name.parse.

Wed Jan 28 04:29:41 2004  Eric Schwartz  <emschwar@fc.hp.com>

	* lib/cgi/session.rb: use LOCK_SH to read, and a few other
	  improvements.  [ruby-core:02328]

Tue Jan 27 11:09:29 2004  FUKUMOTO Atsushi  <fukumoto@nospam.imasy.or.jp>

	* ext/socket/socket.c (s_recvfrom): sending length should be an
	  invariant while retrying on EAGAIN.  [ruby-talk:89962]

Tue Jan 27 10:35:18 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/win32ole/win32ole.c (set_argv): fix condition.

Tue Jan 27 02:26:31 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httputils.rb (WEBrick:HTTPUtils::parse_header):
	  refine regex for header-name.

Tue Jan 27 00:30:11 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub: rollback.

Mon Jan 26 22:53:04 2004  Dave Thomas  <dave@pragprog.com>

	* io.c: Remove documentation references to $defout.

Mon Jan 26 15:11:47 2004  NAKAMURA Usaku  <usa@ruby-lang.org>

	* sample/exyacc.rb: escape '}' to avoid warning.

Mon Jan 26 14:41:46 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/delegate.rb (Delegator::initialize): preserve
	  singleton_method_added method [ruby-dev:22685]

	* lib/delegate.rb (Delegator::initialize): use Kernel::raise
	  instead of mere raise.  [ruby-dev:22681]

Mon Jan 26 12:47:17 2004  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: define CONST84 when TCL_MAJOR_VERSION == 7

Mon Jan 26 11:35:23 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/extmk.rb: Makefiles should depend on also rbconfig.rb.
	  (ruby-bugs:PR#1256)

	* ext/win32ole/win32ole.c (set_argv): set real arguments to
	  WIN32OLE::ARGV.  [ruby-list:39073]

Thu Jan 22 22:54:53 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (BEG_REGEXP): allow 8-bit characters in quoted
	  strings for Novell GroupWise Internet Agent.
	* lib/net/imap.rb (DATA_REGEXP): ditto.

Thu Jan 22 16:21:33 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (string_content): reset lexical states at the beginning of
	  string contents.  [ruby-list:39061]

Wed Jan 21 21:55:51 2004  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb: remove O_NONBLOCK, thanks \ay
	* lib/drb/extserv.rb: typo

Wed Jan 21 17:57:56 2004  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (envelope): allow NIL.
	* lib/net/imap.rb (body): ditto.
	* lib/net/imap.rb (number): ditto.
	* lib/net/imap.rb (ensure_nz_number): show a detailed error
	  message.

Wed Jan 21 16:44:20 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (merge_libs): squeeze successive same libraries.
	  [ruby-dev:22652]

Wed Jan 21 16:01:37 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/digest/rmd160/extconf.rb: have_library appends found library.

Wed Jan 21 11:36:00 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (block_append): update nd_end for "real" head node.
	  [ruby-list:39058]

Tue Jan 20 14:48:13 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/extconf.rb: should check <openssl/conf_api.h> instead
	  of OPENSSL_VERSION_NUMBER. [ruby-list:39056]

Tue Jan 20 14:43:17 2004  Dave Thomas  <dave@pragprog.com>

	* lib/base64.rb: Add RDoc

Tue Jan 20 14:25:51 2004  Dave Thomas  <dave@pragprog.com>

	* lib/abbrev.rb: Add RDoc

Tue Jan 20 13:22:39 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb: Document aliases at
	  top-most level.

	* lib/English.rb: Document English.rb.

Tue Jan 20 02:49:22 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/extconf.rb: add check for OpenSSL version.
	  [ruby-list:39054]

Tue Jan 20 02:38:13 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_class): should not dump singleton class.
	  [ruby-dev:22631]

Tue Jan 20 01:31:36 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* io.c (lineno): typo fix(FIX2INT -> INT2FIX).

Mon Jan 19 21:53:38 2004  akira yamada  <akira@ruby-lang.org>

	* io.c, re.c, string.c, time.c: fixed up positions of RDocs.

Mon Jan 19 07:09:20 2004  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date.rb: zone was wrong when it was behind UTC.
	  Thanks Mark J. Reed.

	* lib/date/format.rb: %z is now always replaced by four digits
	  with a leading plus or minus sign.

	* sample/cal.rb: added a class, anyway.

Sun Jan 18 20:47:35 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ruby.c: use translate_char() on Cygwin.

Sun Jan 18 02:33:26 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* defines.h (_WIN32): undef _WIN32 on Cygwin before defining DOSISH.

Sun Jan 18 00:23:55 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (class2path): check anonymous class/module before
	  checking referable, and allow singleton classes.

Fri Jan 16 14:33:35 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (class2path): get class path and check referable.
	  [ruby-dev:22588]

Fri Jan 16 09:52:23 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_eq): Proc with empty body may not be equal.
	  [ruby-dev:22590]

Thu Jan 15 13:03:10 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (argf_read): do not append EOF.  (ruby-bugs-ja:PR#585)

	* io.c (rb_io_fwrite): ad-hockery hack to get rid of HP-UX stdio
	  weird behavior.  [ruby-dev:22424]

Wed Jan 14 13:31:06 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/iconv/extconf.rb: wrapper iconv.rb is dependent on platform.

Tue Jan 13 18:54:28 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/logger.rb(Logger#msg2str): no special treatment for the object
	  which responds to :to_str.  commited at 2004-01-11T21:46:27 by
	  gsinclair.

	* lib/logger.rb(LogDevice#initialize): remove type checking if the
	  given object is a String.  Kernel.open handles it correctly.
	  commited at 2004-01-11T21:46:27 by gsinclair.

	* test/logger/test_logger.rb: follow above change (ArgumentError ->
	  TypeError.)  follow above commit.

Tue Jan 13 14:27:13 2004  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/test/unit/ui/testrunnerutilities.rb (TestRunnerUtilities):
	  moved run method which allows output level.  [ruby-dev:22554]

Tue Jan 13 04:29:52 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_driver.rb (RiDriver::report_method_stuff):
	  Show fully-qualified class names in class list.

Tue Jan 13 01:04:37 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_paths.rb (RI::Paths): First attempt at
	  incorporating DESTDIR in the rdoc installation.

Mon Jan 12 23:27:19 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (primary): fix position after FCALL.  [ruby-dev:22574]

Mon Jan 12 12:07:22 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::do_methods):
	  Someone changed the "// in eval.c" comments to "/*...*/" style,
	  so the parsing of the source file name broke.

	* object.c: Remove spurious space in TrueClass documentation.

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::find_body): Fix
	  bad regexp: if the code before a documented method contained
	  a comment that wasn't terminated by whitespace, that comment
	  and all intervening code was included in the following
	  method's documentation.

	* lib/rdoc/ri/ri_formatter.rb (RI::HtmlFormatter::break_to_newline):
	  HTML formats need explicit line breaks.

Mon Jan 12 11:46:30 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (LIBPATHFLAG, RPATHFLAG): enclose paths with single
	  quotes.  [ruby-dev:22564]

	* lib/mkmf.rb (libpathflag): do not enclose with quotes always.

	* {bcc32,win32,wince}/Makefile.sub (LIBPATHFLAG): quoted.

Mon Jan 12 02:24:07 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_formatter.rb (RI::HtmlFormatter): Add HTML
	  generation support to ri (Elliot Hughes)

Mon Jan 12 02:24:07 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_formatter.rb (RI::HtmlFormatter): Add HTML
	  generation support to ri (Elliot Hughes)

Sun Jan 11 02:07:47 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_options.rb (RI::Options::OptionList::OptionList):
	  Also accept command line options via the 'RI' environment variable.

Sun Jan 11 02:07:47 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_options.rb (RI::Options::OptionList::OptionList):
	  Also accept command line options via the 'RI' environment variable.

Sat Jan 10 21:27:41 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (eval): need to add message delimiter. [ruby-dev:22561]

Sat Jan 10 01:54:50 2004  Eric Sunshine  <sunshine@sunshineco.com>

	* defines.h (__NeXT__): Ensure that all standard S_IRUSR, S_IWGRP,
	  S_IRWXO, etc. macros are defined since future code might require
	  them (even though present code only requires a subset).

	* defines.h (__NeXT__): Bug fix: WORDS_BIGENDIAN was not being set
	  correctly on Rhapsody when -arch compiler flag was used (via
	  configure's --enable-fat-binary option).

Fri Jan  9 10:05:14 2004  Siena.  <siena@faculty.chiba-u.jp>

	* lib/mkmf.rb (libpathflag): use single quotes.  [ruby-dev:22440]

Thu Jan  8 23:49:21 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in (RDOCTARGET): new macro.  if you want to install
	  rdoc documentation, you need to run configure with
	  --enable-install-doc.

Thu Jan  8 21:29:43 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_pkey.c (ossl_pkey_to_der): removed; it returns
	  public key only.

	* ext/openssl/ossl_pkey_dh.c (ossl_dh_to_der): new function for
	  OpenSSL::PKey::DH#to_der.

	* ext/openssl/ossl_pkey_dsa.c (ossl_dsa_to_der): new function for
	  OpenSSL::PKey::DSA#to_der.

	* ext/openssl/ossl_pkey_rsa.c (ossl_rsa_to_der): new function for
	  OpenSSL::PKey::RSA#to_der.

Thu Jan  8 16:51:04 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* test/wsdl/datetime/test_datetime.rb: fixed a stupid testcase which
	  dumps "E" at month-end.

Thu Jan  8 11:20:01 2004  WATANABE Hirofumi  <eban@ruby-lang.org>

	* eval.c, object.c, process.c, re.c: don't use C++ style comments.

Thu Jan  8 04:36:21 2004  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/cgi.rb (WEBrick::CGI#initialize): should create
	  @config[:Logger] if it was not given.

	* sample/webrick/*: new files.

	* MANIFEST: add sample/webrick/*

Wed Jan  7 13:00:18 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_driver.rb: Fix problem where ri was
	  being too eager to find matches of ambiguous method
	  names (such as "ri Thread.join" would return both
	  Thread.join and ThreadsWait.join)

Wed Jan  7 12:35:41 2004  NAKAMURA, Hiroshi  <nakahiro@sarion.co.jp>

	* lib/debug.rb: revert command parse regexps.  [ruby-list:39014] by
	  Shirai,Kaoru.

Wed Jan  7 08:21:04 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parserfactory.rb: Check for shebang
	  line in files that would otherwise be treated as
	  plain text.

Tue Jan  6 22:13:34 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_mod_modfunc): should break if m has no super class.
	  [ruby-dev:22498]

Tue Jan  6 21:55:02 2004  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (fptr_finalize): should save errno just after failure.
	  [ruby-dev:22492]

Tue Jan  6 14:53:14 2004  Dave Thomas  <dave@pragprog.com>

	* bin/ri: split out the display side, making it pluggable. Added
	  new ri_driver and ri_display files in lib/rdoc/ri.

Tue Jan  6 06:37:53 2004  Dave Thomas  <dave@pragprog.com>

	* bin/rdoc: Add --ri-system switch

	* lib/.document: Update with list of files that seem to have
	  documentation

	* lib/test/unit.rb: Reorder comment to make it RDoc friendly.

	* Makefile.in: add install-nodoc target, and make it
	  generate RDoc on default install.

	* lib/rdoc/ri/ri_options.rb (RI::Options::parse): Add
	  --doc-dir option to ri.

Tue Jan  6 00:04:40 2004  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_method_or_yield_parameters):
	  fix parsing if there are braces in a method parameter list

Fri Jan  2 14:54:11 2004  Dave Thomas  <dave@pragprog.com>

	* bin/ri: Add new --classes option, and arrange for
	  help messages to be paged too.

	* bin/rdoc: Add statistics.

	* process.c: (MG) Added Process documentation

	* lib/rdoc/ri/ri_formatter.rb (RI::AttributeFormatter::wrap):
	  Fix problem with labels not displaying in RI labeled
	  lists using BS and ANSI modes.

Fri Jan  2 01:50:13 2004  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_eof): ARGF.eof? should not have any side effect.
	  [ruby-dev:22469]

Wed Dec 31 17:25:17 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_each_byte): should return self.  [ruby-dev:22465]

Wed Dec 31 11:20:34 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::do_methods): Make
	  file referenced in "// in sss.c" relative to current file.

Wed Dec 31 11:17:37 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/generators/html_generator.rb: Fix problem when
	  a public method was aliased, but the alias is then
	  made private, and hence doesn't appear in RDoc output.

Wed Dec 31 01:33:05 2003  Dave Thomas  <dave@pragprog.com>

	* array.c, error.c, eval.c, io.c, prec.c, range.c, re.c,
	  string.c, time.c: Add RDoc for Kernel functions, and tidy.

Tue Dec 30 19:39:14 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_f_readline): should raise EOFError at the end of
	  files.  [ruby-dev:22458]

	* io.c (argf_read): should concatenate input files when length
	  argument is nil. [ruby-dev:22450]

	* io.c (argf_read): should update supplied string buffer (2nd
	  argument) even when IO#read is called multiple times.

	* io.c: should initialize lineno by zero. [ruby-dev:22460]

Tue Dec 30 12:30:30 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/code_objects.rb (RDoc::Context::find_symbol): If a
	  class and a method have the same name, finding Xxx.abc was trying
	  to find 'abc' in method 'Xxx', not class 'Xxx'.


Tue Dec 30 08:32:32 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_method):
	  Handle undoing nesting of yield parameters correctly for:

	  def each_entry(&b) Dir.foreach(@path) {|f| yield P.new(f) } end


Tue Dec 30 08:32:32 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_rb.rb (RDoc::RubyParser::parse_method):
	  Handle undoing nesting of yield parameters correctly for:

	    def each_entry(&block) Dir.foreach(@path) {|f| yield Pathname.new(f) } end

Mon Dec 29 12:51:02 2003  Dave Thomas  <dave@pragprog.com>

	* eval.c: Add RDoc for Kernel global functions.

Mon Dec 29 11:00:16 2003  Dave Thomas  <dave@pragprog.com>

	* array.c: Tidy up RDoc loose ends.

Mon Dec 29 05:05:51 2003  Dave Thomas  <dave@pragprog.com>

	* struct.c, random: Add RDoc comments

Mon Dec 29 02:20:54 2003  Dave Thomas  <dave@pragprog.com>

	* eval.c: Add RDoc for class Proc, Method, UnboundMethod

Mon Dec 29 00:41:44 2003  Dave Thomas  <dave@pragprog.com>

	* math.c: Add RDoc comments

Sun Dec 28 20:19:11 2003  Tanaka Akira  <akr@m17n.org>

	* ext/stringio/stringio.c (strio_sysread): StringIO.new.sysread didn't
	  raise EOFError.

	* ext/zlib/zlib.c (gzreader_gets): don't increment lineno when
	  gzfile_read_all returns "".

Sun Dec 28 15:25:08 2003  Dave Thomas  <dave@pragprog.com>

	* class.c,object.c,parse.y,sprintf.c,variable.c: Document classes
	  Object, Module, etc...

Sun Dec 28 11:55:29 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* test/csv/test_csv.rb: generate bom.csv and mac.csv files on the fly.
	  [ruby-talk:88852]

	* test/csv/{bom.csv,mac.csv}: removed.

Sun Dec 28 08:56:51 2003  Dave Thomas  <dave@pragprog.com>

	* eval.c: Thead[Group] RDoc (thanks to MG)

Sun Dec 28 03:50:05 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::find_override_comment):
	  Escape method names used in regexp

Sun Dec 28 01:46:02 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/ri/ri_formatter.rb (RI::TextFormatter::display_flow_item):
	  Add support for rules in 'ri' output.

Sun Dec 28 01:35:35 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::find_body):
	  Sometimes the Ruby source aliases two otherwise
	  unrelated methods (for example Kernel#object_id and
	  Kernel#hash are both the same C function). Provide a
	  facility to allow the methods to be documented
	  separately.

Sun Dec 28 01:05:31 2003  Dave Thomas  <dave@pragprog.com>

	* marshal.c, signal.c: RDoc collemts added by Elliott Hughes

Sun Dec 28 00:48:47 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/parsers/parse_c.rb (RDoc::C_Parser::find_class_comment):
	  Some source files use lower case class or module names
	  when naming the Init_XXX function in C.

Sat Dec 27 23:41:46 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: fix "test: too many arguments" error.

Sat Dec 27 15:32:19 2003  Dave Thomas  <dave@wireless_3.local.thomases.com>

	* time.c: RDoc comments added

Sat Dec 27 15:07:57 2003  Dave Thomas  <dave@pragprog.com>

	* object.c: Add RDoc comments for Symbol class.

Sat Dec 27 14:42:30 2003  Dave Thomas  <dave@pragprog.com>

	* numeric.c: Add RDoc comments.

Sat Dec 27 00:44:00 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (next_argv): warn always for stdin on inplace edit mode.

	* io.c (read_all): need to check string value.

	* io.c (argf_read): allow ARGF.read(nil).  [ruby-dev:22433]

Fri Dec 26 23:02:09 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_f_backquote): need not to check nil result.
	  [ruby-core:02078]

	* io.c (rb_io_getline): should return nil when read_all gives
	  empty string, even when nil rs is specified. [ruby-core:02077]

Fri Dec 26 18:50:59 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: check if getcontext and setcontext are available.

	* eval.c: use presence of getcontext/setcontext.

Fri Dec 26 16:40:53 2003  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb (PathnameTest#test_plus): add 2 assertions.

Fri Dec 26 09:26:58 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): add sign check for 'i', and 'l'.
	  [ruby-dev:22427]

	* bignum.c (rb_quad_pack): add range check for 'quad int'.

Thu Dec 25 22:39:59 2003  NAKAMURA Usaku  <usa@ruby-lang.org>

	* string.c (rb_str_update): don't return any value.

Thu Dec 25 15:30:17 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_update): call rb_str_modify().

Thu Dec 25 05:08:09 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (search_required): search actual file name once when no
	  extension specified.

Thu Dec 25 04:00:44 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.8.1 released.

Thu Dec 25 00:17:53 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* configure.in: check for nanosleep, -lrt if required.
	  [ruby-core:02059]

	* eval.c (thread_timer): use select(2) if nanosleep(2) is not
	  available.

	* eval.c: check __stub_getcontext for glibc on some platforms.
	  [ruby-list:38984]

Wed Dec 24 23:48:04 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* test/soap/test_basetype.rb, test/soap/marshal/test_marshal.rb
	  test/xsd/test_xsd.rb: use "(-1.0 / (1.0 / 0.0))" instead of "-0.0"
	  to express -0.0.  [ruby-talk:88786]

Wed Dec 24 23:29:30 2003  Tanaka Akira  <akr@m17n.org>

	* lib/tsort.rb (test_orphaned_break): removed.

Wed Dec 24 20:53:06 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/sample/tkmulticolumnlist.rb: new sample

	* ext/tk/sample/tkmultilistframe.rb: bug fix

Wed Dec 24 20:37:37 2003  Eric Sunshine  <sunshine@sunshineco.com>

	* configure.in (LDSHARED): Fixed typographical error in assignment of
	  LDSHARED for Rhapsody which caused linking of extension modules to
	  fail.

Wed Dec 24 17:51:18 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_thread_flock): enable thread support again.

Wed Dec 24 16:46:08 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (catch_timer): do not call rb_thread_schedule() inside to
	  avoid pthread_mutex_lock() deadlock.  interrupts to system calls
	  are detected by TRAP_END via EINTR error.

	* eval.c (thread_timer): do not post signal unless it is
	  absolutely necessary.

	* rubysig.h (TRAP_END): add CHECK_INTS to switch thread.

	* regex.c (re_compile_pattern): check if nextp is smaller than
	  pend.  [ruby-dev:22372]

	* eval.c (umethod_bind): remove method overridden check.
	  [ruby-dev:22366]

Wed Dec 24 16:13:05 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_read): should check for error
	  status by SSL_get_error().

	* ext/openssl/ossl_ssl.c (ossl_ssl_write): ditto.

Wed Dec 24 14:23:27 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): clear the buffer argument
	  when returning nil.  [ruby-dev:22363]

	* test/ruby/ut_eof.rb (TestEOF::test_eof_0, TestEOF::test_eof_1):
	  add buffer argument tests.

Wed Dec 24 14:07:55 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb: Modules are allowed to rescue.

	* lib/test/unit/autorunner.rb: show output_level in order.

	* lib/test/unit/collector/dir.rb: get rid of successive same
	  directories in load path.

	* test/testunit/test_assertions.rb (test_assert_nothing_raised,
	  test_assert_raise): test for modules.

Wed Dec 24 13:43:34 2003  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (authenticate): remove "\n" from base64 encoded
	  strings.

Wed Dec 24 11:26:41 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/fileutils/test_fileutils.rb: should not create any
	  files or directories in current directory.  [ruby-talk:88724]

Wed Dec 24 10:29:53 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): never return nil at
	  unlimited read.  [ruby-dev:22334]

	* ext/stringio/stringio.c (strio_read): support second
	  argument.  [ruby-dev:22350]

Wed Dec 24 09:38:49 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (arg): should return 0 after error.  [ruby-dev:22360]

Wed Dec 24 00:56:54 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (read_all): do not return nil at the end of file.
	  [ruby-dev:22334]

	* io.c (argf_read): do not depend on nil at eof behavior of
	  IO#read().

	* eval.c (rb_thread_join): dup exception before re-raising it.

	* io.c (rb_io_eof): call clearerr() to prevent side effect.  this
	  patch is supplied by Masahiro Sakai <sakai@tom.sfc.keio.ac.jp>.
	  [ruby-dev:22234]

	* pack.c (OFF16): get offset for big endian machines.

	* pack.c (pack_pack): use OFF16 instead of OFF16B.
	  [ruby-dev:22344]

	* pack.c (pack_unpack): ditto.

Tue Dec 23 22:47:14 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_check_readable): set FMODE_RBUF always, even if
	  NEED_IO_SEEK_BETWEEN_RW is not defined. [ruby-dev:22340]

	* io.c (rb_io_check_writable): clear FMODE_RBUF before writing
	  something.

Tue Dec 23 22:25:00 2003  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/optparse.rb: incomplete RDoc documentation added in place of
	  existing RD comments.  Tabs converted to spaces.

Tue Dec 23 19:44:47 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* test/soap/test_streamhandler.rb (test_basic_auth): removed.
	  soap4r + basic_auth is not officially supported in ruby/1.8.1 even
	  though soap4r + basic_auth + http-access2 should run fine.

Tue Dec 23 19:42:59 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_ungetc): raise an exception at unread stream to
	  avoid unspecified behavior.  [ruby-dev:22330]

	* test/ruby/test_system.rb (test_syntax): glob relatively from
	  __FILE__.

Tue Dec 23 18:09:40 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): remove unnecessary negative value check.
	  [ruby-dev:22329]

Tue Dec 23 17:26:55 2003  KONISHI Hiromasa   <konishih@fd6.so-net.ne.jp>

	* bcc32/Makefile.sub (config.h): bcc has finite(). [ruby-list:38940]

Tue Dec 23 16:08:16 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/rexml/encodings/US-ASCII.rb: typo.  [ruby-talk:88650]

	* test/ruby/test_system.rb: num of asserts depended on running dir.

	* test/xsd/test_noencoding.rb: rexml + without iconv/uconv cannot
	  handle euc-jp.  install iconv, uconv or xmlscan.

Tue Dec 23 14:13:51 2003  akira yamada  <akira@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic::check_userinfo,
	  URI::Generic::check_user, URI::Generic::check_password): tests
	  conflicts/depends with other components closely.

	* test/uri/test_generic.rb (TestGeneric::test_set_component):
	  added tets.

Tue Dec 23 11:08:34 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* test/xsd/test_noencoding.rb: rescue Errno::EINVAL and do not test.
	  "euc-jp" might not be in supported encoding name list.
	  [ruby-talk:88650]

Tue Dec 23 06:10:31 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/cgi.rb (CGI): add support for mod_ruby.

	* lib/webrick/cgi.rb (CGI::Socket): add check for existence of
	  OpenSSL module in all HTTPS related methods.

	* lib/webrick/cgi.rb (CGI::Socket#cipher): should create similar
	  value to OpenSSL::SSLSocket#cipher.

	* lib/webrick/httpresponse.rb (HTTPResponse#setup_header): should
	  set "connection: close" if @keep_alive is false.

	* lib/webrick/https.rb (HTTPrequest#meta_vars): add supprt for
	  SSL_PROTOCOL, SSL_CIPHER_USEKEYSIZE and SSL_CIPHER_ALGKEYSIZE.

Mon Dec 22 23:00:05 2003  akira yamada  <akira@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic::check_opaque): fixed typo.

Mon Dec 22 21:59:24 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/iconv/iconv.c (map_charset): always ensure code is a String.

Mon Dec 22 21:15:29 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mod_init_copy): always copy singleton class.
	  [ruby-dev:22325]

Mon Dec 22 20:44:36 2003  akira yamada  <akira@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic#route_from): accepts urls which
	  has no host-part.

	* test/uri/test_generic.rb (TestGeneric::test_route): added a test.

Mon Dec 22 20:38:44 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/cgi.rb: reduce eval.

	* lib/cgi.rb (CGI::QueryExtension::read_multipart): alias path to
	  local_path.  [ruby-list:38883]

Mon Dec 22 20:09:31 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* test/soap/test_property.rb: remove duplicated test method.

Mon Dec 22 18:22:04 2003  NAKAMURA Usaku  <usa@ruby-lang.org>

	* bcc32/Makefile.sub, win32/Makefile.sub (config.h): remove
	  HAVE_ISINF definition to follow previous commits of missing.h
	  and win32/win32.h.

Mon Dec 22 17:23:42 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ac_cv_func_setitimer): moved from defines.h

	* defines.h, rubysig.h, signal.c: removed macro handling which
	  should be done in configure.

	* configure.in (intrinsics.h): check if present.

	* ruby.h: include intrinsics.h if available.

	* bignum.c, marshal.c: include ieeefp.h if available.

	* missing.h (isinf): define as a macro if finite() and isnan()
	  are available.  [ruby-core:02032]

Mon Dec 22 17:07:31 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in (mingw): set isnan, finite and isinf to yes.

Mon Dec 22 13:40:19 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/property.rb: passing block by reference.

Mon Dec 22 00:32:43 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_with_disable_interrupt): use ENABLE_INTS instead of
	  ALLOW_INTS which may switch context.  [ruby-dev:22319]

	* ext/syck/emitter.c (syck_emitter_write): str bigger than
	  e->bufsize causes buffer overflow.  [ruby-dev:22307]

Sun Dec 21 17:29:00 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_check_inheritable): new function.  [ruby-dev:22316]

	* intern.h: add prototype.

	* eval.c (superclass): use rb_check_inheritable().

	* object.c (rb_class_initialize): check argument validity.

Sun Dec 21 16:25:10 2003  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb (Pathname#+): re-implemented to resolve ".." in
	  beginning of the argument.
	  (Pathname#join): concatenate from the last argument.
	  (Pathname#parent): just use Pathname#+.

Sun Dec 21 00:12:37 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: add new methods (TkScrollbar#assign, assign_list)

	* ext/tk/sample/tkmultilistframe.rb: use TkScrollbar#assign method

Sat Dec 20 21:59:03 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httprequest.rb (HTTPRequest#meta_vars): refine regexp.

	* lib/webrick/cgi.rb (CGI#start): NPH scripts return status line
	  instead of Status: header field.

	* lib/webrick/cgi.rb (CGI::Socket): refine some coditions.

Sat Dec 20 16:07:14 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::Completion::complete): wrong
	  Regexp for word boundary.  pointed out by Gavin Sinclair.

	* lib/optparse.rb (OptionParser::make_switch): [no-] prefix was
	  missing.

Sat Dec 20 11:40:10 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/yaml.rb (YAML::YAML): adjust Marshal version.

Sat Dec 20 03:56:02 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_with_disable_interrupt): prohibit thread context
	  switch during proc execution.  [ruby-dev:21899]

Sat Dec 20 02:41:02 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/cgi.rb: add file. (yet another CGI library)

	* MANIFEST: add lib/webrick/cgi.rb.

Sat Dec 20 02:18:31 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* misc/ruby-mode.el (ruby-calculate-indent): proper indentation
	  inside of parentheses.  [ruby-dev:22308]

Fri Dec 19 21:24:22 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httprequest.rb (HTTPRequest#meta_vars): should not set
	  HTTP_CONTENT_TYPE and HTTP_CONTENT_LENGTH.

	* lib/webrick/https.rb (HTTPRequest#parse): should check presence
	  of cert() method to detect SSLSocket.

Fri Dec 19 22:56:46 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/property.rb (SOAP::Property#load): new method for loading
	  property value into existing property tree.

	* test/soap/test_property.rb: add test.

Fri Dec 19 19:21:49 2003  akira yamada  <akira@ruby-lang.org>

	* lib/runit/cui/testrunner.rb (RUNIT::CUI::TestRunner::run):
	  should use Test::Unit::UI::{PROGRESS_ONLY,VERBOSE}.

Fri Dec 19 17:36:49 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/sample/tkmultilistbox.rb: bug fix

	* ext/tk/sample/tkmultilistframe.rb: new sample script

Fri Dec 19 03:44:27 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httputils.rb (parse_form_data): should return an
	  empty Hash if the body is empty.

Thu Dec 18 21:47:35 2003  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): should remove deffile if it's
	  made by miniruby. based on nobu's patch.

Thu Dec 18 21:44:21 2003  NAKAMURA Usaku  <usa@ruby-lang.org>

	* eval.c (stack_extend): ignore inline optimization on VC7.

	* win32/Makefile.sub (OS, RT): can override.

	* win32/Makefile.sub (LDFLAGS): ditto. shouldn't use pdb:none
	  option. based on Tietew's patch [ruby-dev:22289]

Thu Dec 18 16:38:44 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (fnmatch): unlike find_dirsep(), rb_path_next() never
	  return NULL.

Thu Dec 18 15:27:59 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/ipaddr.rb (IPSocket::getaddress): merge usa's patch.
	  [ruby-dev:21678]

Wed Dec 17 15:15:30 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/cgi.rb (CGI::QueryExtension::Value::[]): should work like
	  String#[] if more than one arguments are specified.

	* lib/delegate.rb: avoid using common instance name as "@obj".

	* lib/cgi.rb (CGI::QueryExtension::Value): Value is no longer
	  subclass of String, but DelegateClass(String).

	* ext/curses/extconf.rb: restore function check for init_color.
	  [ruby-list:38905]

	* Makefile.in: need to specify $(MAINLIBS) for the miniruby
	  generation rule.

	* configure.in: better FreeBSD -lc_r support.

Wed Dec 17 00:16:14 2003  Minero Aoki  <aamine@loveruby.net>

	* ext/strscan/strscan.c: new method
	  StringScanner#beginning_of_line? (alias #bol?)

	* ext/strscan/strscan.c: new method StringScanner#concat and #<<.

	* ext/strscan/strscan.c: StringScanner#new(str) does not duplicate
	  nor freeze STR (allow destructive modification).

	* test/strscan/test_stringscanner.rb: test new methods above.

	* test/strscan/test_stringscanner.rb: test destructive string
	  modification.

Tue Dec 16 21:20:47 2003  Tanaka Akira  <akr@m17n.org>

	* lib/pp.rb: don't use local variable `pp'.

	* lib/prettyprint.rb: ditto.

Tue Dec 16 13:20:43 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: condition bug of if statement on
	  {pack,grid}_propagate methods

Tue Dec 16 03:17:29 2003  why the lucky stiff  <why@ruby-lang.org>

	* lib/yaml/rubytypes.rb: comments in strings. [ruby-talk:88012]

	* test/yaml/test_yaml.rb: add test.

Tue Dec 16 01:14:44 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (catch_timer): check rb_thread_crtical in main native
	  thread.

	* eval.c (thread_timer): just sends signals periodically, to
	  prevent main native thread from receiving them in critical
	  section.  [ruby-core:01959]

Mon Dec 15 13:32:22 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (check_dirname): check string safety and remove extraneous
	  trailing directory separators.  [ruby-dev:22279]

	* file.c: renamed and externalized rb_path_next,
	  rb_path_skip_prefix, rb_path_last_separator, rb_path_end.

	* intern.h: prototypes for rb_path_next, rb_path_skip_prefix,
	  rb_path_last_separator, rb_path_end.

Mon Dec 15 09:27:46 2003  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/openssl/ossl_pkcs12.c (ossl_pkcs12_initialize): first argument
	  of rb_protect should take an argument of VALUE.

Sun Dec 14 18:46:48 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/socket/socket.c (Init_socket): IPv6 is not supported although
	  AF_INET6 is defined on MinGW.

	* lib/ipaddr.rb (AF_INET6): workaround in the environment which does
	  not support IPv6.

Sat Dec 13 18:55:16 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/iconv/charset_alias.rb: preserve original order.

	* ext/iconv/extconf.rb: remove wrapper file at clean.

Sat Dec 13 18:09:42 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (thread_timer): use timer by sub-thread and nanosleep.
	  [ruby-talk:87519]

	* gc.c (Init_stack): no stack adjustment for THREAD_SAFE.

Sat Dec 13 17:17:59 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (proc_alloc): cache the created object at first time.
	  [ruby-talk:61288], [ruby-dev:22240]

Sat Dec 13 09:01:23 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: check ucontext.h.

	* eval.c: use getcontext/setcontext() instead of setjmp/longjmp()
	  on ia64 or with native thread enabled.  [ruby-core:01932]

Sat Dec 13 03:09:14 2003  why the lucky stiff  <why@ruby-lang.org>

	* lib/yaml/rubytypes.rb: anonymous struct fix. [ruby-core:01946]

	* test/yaml/test_yaml.rb: add test.

Fri Dec 12 22:36:44 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/csv.rb: add Cell#to_str and Cell#to_s for /.../ =~ aCell,
	  "#{aCell}" and so on.

	* test/csv/test_csv.rb: add tests.

Fri Dec 12 19:33:06 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (mkdir): remove trailing `/' from pathes.

	* lib/fileutils.rb (rmdir): ditto. [ruby-dev:22238]

	* lib/fileutils.rb (rmdir_r): ditto.

	* lib/fileutils.rb (fu_copy_dir): check if it is a directory after
	  mkdir(2).

Fri Dec 12 06:06:09 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (proc_invoke): fix class name in warning message for
	  define_method.  [ruby-dev:22235]

Thu Dec 11 21:24:43 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_pkcs12.[ch]: new files. add OpenSSL::PKCS12.

	* ext/openssl/ossl.[ch]: ditto.

	* ext/openssl/MANIFEST: add ossl_pkcs12.[ch].

Thu Dec 11 20:54:28 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (mkdir_p): remove trailing `/' befere mkdir(2).
	  mkdir("nonexistdir/") does not work on NetBSD/Alpha 1.6.1.

	* lib/fileutils.rb (fu_list): call to_str for all arguments.

Thu Dec 11 20:07:01 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/ftools.rb (makedirs): sync with fileutils.

Thu Dec 11 19:53:03 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (mkdir_p): catch all SystemCallErrors.
	  (mkdir("C:\") causes EACCESS on Windows 2000/NTFS)

Thu Dec 11 19:08:02 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (mkdir_p): check if it is a directory after
	  mkdir(2) instead of before mkdir(2), to avoid race condition.
	  [ruby-talk:87730]
	  Refer: mkinstalldirs sh script, GNU mkdir(1) (coreutils 5.0)

Thu Dec 11 18:49:30 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb: def m( arg ) -> def m(arg).

Thu Dec 11 11:39:43 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ieeefp.h), numeric.c: needed for finite() on
	  Solaris.  [ruby-core:01921]

	* file.c (rb_stat_inspect): adjust format specifier.

	* parse.c (arg_prepend): nodetype() is for debug use.

	* ruby.h (ISASCII, etc): cast to int to get rid of warning.

	* ruby.h (alloca.h): include even in GCC.  [ruby-core:01925]

	* ext/bigdecimal/bigdecimal.c (GetVpValue): adjust format
	  specifier.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_prec, BigDecimal_coerce,
	  BigDecimal_divmod): use rb_assoc_new() to suppress memory usage.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_split): ditto.

	* ext/dl/sym.c (rb_dlsym_guardcall): guard itself should be
	  volatile.

	* ext/iconv/iconv.c (iconv_convert): ensure actual parameter with
	  format specifier.

	* ext/pty/pty.c (MasterDevice, SlaveDevice, deviceNo): do not
	  define unless used.

	* ext/pty/pty.c (getDevice): get rid of warning.

	* ext/socket/socket.c (port_str, sock_s_getaddrinfo,
	  sock_s_getnameinfo): FIX2INT() now returns long.

	* ext/socket/socket.c (init_inetsock_internal): uninitialized
	  variable.

	* ext/syck/rubyext.c (syck_parser_assign_io): add prototype.

	* ext/syck/rubyext.c (rb_syck_mktime, yaml_org_handler): use
	  ISDIGIT() instead of isdigit() to avoid warnings and for
	  platforms which don't support non-ascii charater.

Wed Dec 10 19:28:56 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): set EOF flag at short read.
	  [ruby-dev:22223], [ruby-dev:22224]

Wed Dec 10 18:07:25 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/erb.rb: new method ERB#filename(=). [ruby-dev:22208]

Wed Dec 10 17:54:51 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): do not set EOF flag when
	  requested length is zero.  [ruby-dev:22214]

Wed Dec 10 17:17:18 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (read_all): should return given string even if data read is
	  empty.  [ruby-dev:22207]

Wed Dec 10 17:16:06 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): adjust behavior at reading
	  beyond EOF to IO.  [ruby-dev:22205]

	* test/ruby/ut_eof.rb (TestEOF::Seek): test behaviors at reading
	  beyond EOF.

	* test/ruby/test_file.rb, test/stringio/test_stringio.rb: include
	  TestEOF::Seek test case.

Wed Dec 10 15:01:19 2003  Shugo Maeda  <shugo@ruby-lang.org>

	* test/monitor/test_monitor.rb (test_cond): use Queue#deq
	  instead of sleep.

Wed Dec 10 14:45:39 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/pty/pty.c (HAVE_SYS_IOCTL_H): need to include <sys/ioctl.h>
	  for TIOCSCTTY on *BSD.  based on gotoyuzo's patch.
	  (ruby-bugs:PR#1211)

	* ext/pty/pty.c (establishShell): should close descriptors if fork
	  failed.

Wed Dec 10 12:53:05 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.h: define execv() using do_aspawn().

	* process.c (proc_exec_v): remove #ifdef's which stopped needing.

Tue Dec  9 23:32:23 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb, ext/tk/lib/tkcanvas.rb, ext/tk/lib/tkdialog.rb,
	  ext/tk/lib/tkentry.rb, ext/tk/lib/tkscrollbox.rb, ext/tk/lib/tktext.rb,
	  ext/tk/sample/tkalignbox.rb, ext/tk/sample/tkcombobox.rb,
	  ext/tk/sample/tkmultilistbox.rb, ext/tk/sample/tkoptdb.rb, ext/tk/sample/tktextframe.rb,
	  ext/tk/sample/demos-en/dialog1.rb, ext/tk/sample/demos-en/dialog2.rb,
	  ext/tk/sample/demos-jp/dialog1.rb, ext/tk/sample/demos-jp/dialog2.rb:
	  overrided instance methods, which are private methods on the super
	  class, are changed to 'private'

Tue Dec  9 19:53:02 2003  akira yamada  <akira@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic#route_from0): make case insensitive
	  for host-part.

	* test/uri/test_generic.rb (test_route): added tests for the above
	  change.

Tue Dec  9 14:10:48 2003  Tanaka Akira  <akr@m17n.org>

	* io.c (rb_io_check_readable): don't call io_seek if EOF flag is set,
	  to avoid clearing EOF flag.
	  (rb_io_check_writable): ditto.

Tue Dec  9 02:53:55 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/sample/tkalignbox.rb: new sample script

Tue Dec  9 00:45:00 2003  Nathaniel Talbott  <ntalbott@ruby-lang.org>

	* lib/test/unit/assertions.rb: renamed #assert_raises to #assert_raise
	  and made the former call the latter. [ruby-core:01890]

	* test/testunit/test_assertions.rb: ditto.

Tue Dec  9 00:07:35 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/rpc/standaloneServer.rb: add 'shutdown' and 'status'
	  methods as delegates to WEBrick.

	* test/soap/calc/{test_calc.rb,test_calc2.rb},
	  test/soap/helloworld/test_helloworld.rb,
	  test/wsdl/datetime/test_datetime.rb, test/wsdl/raa/test_raa.rb:
	  follow the change.

Mon Dec  8 22:48:03 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/autorunner.rb: remove dependency to a particular
	  runner.  [ruby-core:01901], [ruby-list:38869]

	* lib/test/unit/ui/testrunnerutilities.rb: moved output level
	  constants from Console.

	* lib/test/unit/ui/console/testrunner.rb: ditto.

	* lib/test/unit/ui/{fox,gtk,gtk2,tk}/testrunner.rb (initialize):
	  accept output_level.

Mon Dec  8 15:03:30 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/syck/syck.c (syck_io_str_read): get rid of buffer overflow.

Mon Dec  8 13:02:11 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/uri/common.rb: new method URI.regexp. [ruby-dev:22121]

	* test/uri/test_common.rb: add test for URI.regexp.

Mon Dec  8 12:44:14 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c: define swap16 and swap32 only if they are not
	  defined. OpenBSD defines these macros. [ruby-dev:22181]

Sun Dec  7 20:54:17 2003  Tanaka Akira  <akr@m17n.org>

	* ext/iconv/iconv.c (map_charset): make case sensitive.
	  ext/iconv/charset_alias.rb (charset_alias): don't ignore
	  config.charset's information.  sort aliases.

Sat Dec  6 22:58:03 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_ssl.c (ossl_start_ssl): new function to wrap
	  SSL_connect and SSL_accept; if SSL_connect (or SSL_accept) returned
	  but not finished the handshake process, we should retry it.

	* ext/openssl/ossl_ssl.c (ossl_ssl_connect): call ossl_start_ssl.

	* ext/openssl/ossl_ssl.c (ossl_ssl_accept): ditto.

	* ext/openssl/ossl_ssl.c (ossl_ssl_read): allow signal traps.

Sat Dec  6 21:45:10 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* io.c (flush_before_seek): flush before seek on any platform.

	* configure.in: ditto.

Sat Dec  6 17:23:00 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/soap.rb(SOAP::Env.getenv): allow upcase environment variable
	  as well as downcase one.

	* lib/soap/netHttpClient.rb(SOAP::NetHttpClient#proxy=): check URI.

Fri Dec  5 23:22:30 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (Test::Unit::Assertions::assert_raises,
	  Test::Unit::Assertions::assert_nothing_raised): use the last
	  argument as message unless class object.

	* test/testunit/test_assertions.rb (test_assert_raises): test for
	  multiple exception list.  [ruby-core:01891]

	* test/testunit/test_assertions.rb (test_assert_nothing_raised): test
	  for non-exception classes.

Fri Dec  5 22:23:04 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/netHttpClient.rb: proxy support did not work.  fixed.

	* lib/soap/property.rb: add class methods for loading property from
	  stream/file/propertyfile.  propertyfile is a file which is located at
	  somedir in $:.

	* lib/soap/soap.rb, lib/soap/wsdlDriver.rb, lib/soap/rpc/driver.rb,
	  lib/wsdl/importer.rb: load property from propertyfile 'soap/property'
	  e.g. /usr/local/lib/ruby/site_ruby/1.8/soap/property.

	* test/soap/test_property.rb, test/soap/test_streamhandler.rb: new file.

Fri Dec  5 17:26:23 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_exec_end_proc): maintain tmp_end_procs.
	  [ruby-dev:22154]

Fri Dec  5 13:36:59 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_exec_end_proc): should not clear end_procs and
	  ephemeral_end_procs before execution. [ruby-dev:22144]

	* eval.c (rb_obj_extend): call Module#extended hook after
	  extended_object.  [ruby-list:38866]

	* object.c (Init_Object): Module#extended defined.

Fri Dec  5 13:17:30 2003  Tanaka Akira  <akr@m17n.org>

	* test/ruby/test_pipe.rb: use IO.pipe instead of IO.popen.

Fri Dec  5 11:54:45 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): follow IO#read.

	* test/ruby/ut_eof.rb, test/ruby/test_file.rb, test/ruby/test_pipe.rb,
	  test/stringio/test_stringio.rb: add EOF test.

Fri Dec  5 02:49:35 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (Test::Unit::Assertions::assert_raises):
	  allow multiple exception list.  [ruby-core:01884]

	* lib/test/unit/assertions.rb (Test::Unit::Assertions::assert_nothing_raised):
	  check whether arguments are subclass of Exception.

Thu Dec  4 23:54:00 2003  Rick Ohnemus  <rick.ohnemus@systemware.com>

	* dln.c (aix_loaderror): should not use member named 'errno' which
	  might be a macro (e.g. on AIX).

Thu Dec  4 23:32:26 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (read_all): do not depend on lseek position.
	  [ruby-dev:22026]

Thu Dec  4 22:37:26 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_eval): preserve $! value when retry happens in the
	  rescue clause.  [ruby-talk:86697]

Thu Dec  4 21:50:07 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/drb/drb.rb (DRb::DRbMessage::send_request, send_reply):
	  should rescue errors and re-raise DRbConnError on write too.
	  [ruby-dev:22132]

Thu Dec  4 16:41:17 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (exc_list): allow expanding list.  [ruby-dev:22134]

Thu Dec  4 14:09:24 2003  Minero Aoki  <aamine@loveruby.net>

	* test/fileutils/test_fileutils.rb (test_cp): test if the error is
	  kind of SystemCallError.  It is needless details that which errno
	  is set on each systems.

Thu Dec  4 13:24:13 2003  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/monitor.rb: use Object#__send__ instead of Object#send.

Thu Dec  4 13:17:45 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/streamHandler.rb: support latest released version of
	  http-access2.

Thu Dec  4 13:04:44 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/soap.rb: add SOAP::Env module for environment repository
	  such as HTTP_PROXY.

	* lib/soap/property.rb: property implementation.

	* lib/soap/streamHandler.rb, lib/soap/wsdlDriver.rb,
	  lib/soap/rpc/driver.rb: use soap/property.rb.

	* lib/wsdl/importer.rb, lib/soap/wsdlDriver.rb, lib/soap/rpc/driver.rb:
	  use SOAP::Env.

	* lib/soap/netHttpClient.rb: add basic_auth, ssl_config, and cookie
	  management interface, but ignored for now.

	* lib/xsd/charset.rb: add XSD::Charset.encoding= interface to set
	  wiredump charset explicitly.  it was fixed to 'utf-8' when iconv or
	  uconv module was found.

Thu Dec  4 10:43:58 2003  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/dl/sym.c (rb_dlsym_guardcall): __declspec(noinline) is VC7
	  feature.

Thu Dec  4 10:27:12 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb: update hyperlink to the Japanese document.

Thu Dec  4 09:12:43 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_asn1.c (asn1time_to_time): should check that
	  the underlying value of ASN1_TIME isn't NULL. [ruby-core:01881]

Thu Dec  4 08:29:43 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/server.rb (GenericServer#start): should rescue
	  Exception to avoid unexpected aborting. [ruby-core:01853]

	* lib/webrick/server.rb (GenericServer#start_thread): should check
	  that peeraddr isn't nil before printing.

	* lib/webrick/httpresponse.rb (HTTPResponse#start_thread): should
	  rescue Exception to avoid unexpected aborting of thread.

Thu Dec  4 03:48:59 2003  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb (Pathname#link, Pathname#symlink): obsoleted.
	  (Pathname#make_link, Pathname#make_symlink): new method.

Thu Dec  4 01:45:24 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_read): should not terminate on empty string; wait
	  until real EOF.  [ruby-dev:21969]

	* io.c (argf_read): should adjust length to read, when length is
	  specified and read spans command line argument files.

Wed Dec  3 19:38:36 2003  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb: correct fcntl parameter. [ruby-dev:22120]

Wed Dec  3 13:49:07 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: 'format'==>'Kernel.format' (avoid override trouble)

	* ext/tk/lib/tkafter.rb: ditto.

	* ext/tk/lib/tkcanvas.rb: ditto.

	* ext/tk/lib/tkdialog.rb: ditto.

	* ext/tk/lib/tktext.rb: ditto.

Wed Dec  3 13:28:13 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in (lex.c): try gperf first, and copy from the source
	  directory if failed.  [ruby-dev:22123]

	* ext/extmk.rb (MTIMES): let makefiles depend to mkmf.rb.

	* lib/mkmf.rb (configuration): DLDFLAGS was duplicated.

Tue Dec  2 23:18:12 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb: wrote the warning about HTTP_PROXY environment
	  variable.

Tue Dec  2 21:31:42 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* bin/testrb: new test runner.  [ruby-core:01845]

	* lib/test/unit/autorunner.rb (Test::Unit::AutoRunner.run,
	  Test::Unit::AutoRunner#process_args): take test list to run and
	  options.

	* lib/test/unit/autorunner.rb (Test::Unit::AutoRunner::RUNNERS,
	  Test::Unit::AutoRunner#run): should not exit inside a library,
	  just return the result instead.

	* lib/test/unit.rb: ditto.

	* test/runner.rb: exit with the test result.

Tue Dec  2 20:18:48 2003  Eric Sunshine <sunshine@sunshineco.com>

	* configure.in (AC_PROG_YACC): AC_DEFINE(OLD_YACC) if Yacc is found
	  instead of Bison or byacc.

	* parse.y: If OLD_YACC is defined, ensure that YYMAXDEPTH is at least
	  10000 (Bison's default) since some old versions of Yacc define it as
	  low as 150 by default, which is too low for Ruby to parse some files,
	  such as date/format.rb.  Among other issues, the parse problem causes
	  "make test" to fail.

Tue Dec  2 20:03:20 2003  Minero Aoki  <aamine@loveruby.net>

	* test/fileutils/test_fileutils.rb: check if Pathnames are usable
	  for arguments.

Tue Dec  2 04:22:00 2003  Nathaniel Talbott  <ntalbott@ruby-lang.org>

	* lib/test/unit/assertions.rb: fixed #assert_no_match message.

	* test/testunit/test_assertions.rb: ditto.

Tue Dec  2 00:43:00 2003  why the lucky stiff  <why@ruby-lang.org>

	* ext/syck/syck.c: string buffering bug.  decrementing by full
	  max_size now. [ruby-core:01834]

Mon Dec  1 21:33:08 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (num_sadded): prohibit singleton method definition for
	  Numerics.  fill yet another gap between Fixnum and Bignum.

Mon Dec  1 17:33:47 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (htov16): converts endian using swap16. htov32(), hton16,
	  hton32 as well. [ruby-talk:85377]

	* pack.c (swap16): swap 2 bytes no matter how big short is on the
	  platform.  swap32() is also prepared.

	* numeric.c (rb_num2int): returns long to preserve information.
	  rb_fix2int(), rb_num2uint(), rb_fix2uint() as well.
	  [ruby-talk:85377]

	* numeric.c (rb_num2uint): should not check for value range if the
	  source value is negative.

Mon Dec  1 17:14:34 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sample/optparse/opttest.rb: added.

Mon Dec  1 16:10:52 2003  Dave Thomas  <dave@pragprog.com>

	* lib/rdoc/rdoc.rb: (etc) initial merge into main tree.

Mon Dec  1 14:17:49 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (fu_each_src_dest0): call #to_str to allow
	  Pathname for arguments. [ruby-core:01795]

	* test/fileutils/test_fileutils.rb: does much strict test on
	  "same" files detecting.

Mon Dec  1 09:28:14 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* bcc32/Makefile.sub, win32/Makefile.sub, wince/Makefile.sub
	  (XCFLAGS): re-export $(XCFLAGS).

	* bcc32/Makefile.sub, win32/Makefile.sub, wince/Makefile.sub
	  (ARCH_FLAG): export $(ARCH_FLAG) (perhaps empty value).

Mon Dec  1 01:03:27 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/mkmf.rb (TRY_LINK, link_command): added support for DLDFLAGS
	  and ARCH_FLAG.  [ruby-dev:22085]

Sun Nov 30 20:18:07 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: keep ARCH_FLAG separate. export ARCH_FLAG.
	  [ruby-core:01819]

	* Makefile.in: add ARCH_FLAG to CFLAGS.

	* Makefile.in: add @CPPFLAGS@ to CPPFLAGS.

	* lib/mkmf.rb (link_command, cc_command): use ARCH_FLAG.

	* lib/mkmf.rb (configuration): add ARCH_FLAG to DLDFLAGS.

	* Makefile.in: add ARCH_FLAG to DLDFLAGS.

	* configure.in: should put getcwd in AC_CHECK_FUNCS, not
	  AC_REPLACE_FUNCS.  [ruby-core:01826]

Sun Nov 30 18:22:48 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: do not override CCDLDFLAGS, LDFLAGS, XLDFLAGS,
	  DLDFLAGS and LDSHARED.

	* configure.in: XCFLAGS for compiling ruby itself.  ARCH_FLAG is
	  reflected in CFLAGS.

	* lib/mkmf.rb: ditto.  do not import XCFLAGS from config.status.

Sun Nov 30 17:37:36 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: bug fix [ruby-talk:86746]

Sun Nov 30 13:02:00 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/encodingstyle/soapHandler.rb: refactoring - Simplifying
	  Conditional Expressions.

	* lib/wsdl/soap/definitions.rb: refactoring - Move Method.

	* test/xsd/{test_noencoding.rb,noencoding.xml}: new files.  test for
	  encoding unspecified XML file parsing.

	* test/wsdl/{test_fault.rb,map,datetime}: new files.  test of
	  SOAPFault, dateTime and Apache's Map.

Sun Nov 30 09:35:14 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_update): get rid of SEGV at just allocated String.
	  [ruby-core:01812]

Fri Nov 28 23:19:34 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (gc_mark): explicitly check mark recursion levels, instead
	  of unreliable stack length.

Fri Nov 28 22:49:56 2003  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/rinda/rinda.rb: fix TupleSpaceProxy#read, read_all.

Fri Nov 28 21:44:40 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* test/fileutils/test_fileutils.rb (test_ln_s): should be a file, not
	  a directory for FreeBSD.

Fri Nov 28 19:37:56 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (env_has_value, env_index): must match exactly.

	* test/ruby/test_env.rb (test_has_value, test_index): condition for
	  aboves.

Fri Nov 28 17:59:20 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* test/ruby/test_env.rb: add tests for ENV.

Fri Nov 28 17:47:46 2003  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb (DRbMessage#load): rescue Errno::* and raise
	  DRbConnError.

Fri Nov 28 15:41:15 2003  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb (Pathname#realpath): obsolete the force_absolute
	  argument.

Fri Nov 28 14:41:52 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/streamHandler.rb: drop unused http parameters.

	* lib/soap/encodingstyle/soapHandler.rb, lib/soap/mapping/factory.rb,
	  lib/soap/mapping/mapping.rb, lib/soap/mapping/registry.rb,
	  lib/wsdl/soap/complexType.rb: ApacheSOAP's map support was broken
	  under WSDL dynanic client environment.  fixed.

	* test/wsdl/raa/*: add tests.

	* lib/xsd/datatypes.rb: dateTime precision bug fix (at least, I hope.)
	  bug of soap4r.  XSDDateTimeImple.to_time passed a Float to
	  Time.local/Time.gm as an usec, and NUM2LONG(rb_num2long for Float)
	  causes rounding error.

	* test/soap/test_basetype.rb, test/xsd/test_xsd.rb: add tests.

Fri Nov 28 04:15:24 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (method_arity): used wrong Proc object.  [ruby-talk:86504]

Fri Nov 28 00:47:29 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_f_exit), process.c (rb_f_exit_bang): treat true as
	  success, false as failure.  [ruby-dev:22067]

	* eval.c (rb_f_abort, rb_thread_switch), process.c (rb_f_system): use
	  ANSI macro instead of hard coded value.

	* eval.c (rb_f_exit), process.c (rb_f_exit_bang): use VALUEs not but
	  TYPEs.

Thu Nov 27 22:05:48 2003  Akinori MUSHA  <knu@iDaemons.org>

	* eval.c, gc.c: FreeBSD/ia64 currently does not have a way for a
	  process to get the base address for the RSE backing store, so
	  hardcode it for the moment.
	  [submitted by: Marcel Moolenaar <marcel@FreeBSD.org>]

Thu Nov 27 17:36:42 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tkafter.rb: bug fix on TkTimer#cancel_on_exception=(mode).
	  TkTimer#wait recieves the exception of the callback.
	  The exception is kept on @return_value.

Thu Nov 27 16:58:48 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c (rb_w32_stat): remove _fullpath() for NUL: device.

Wed Nov 26 15:38:47 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* test/fileutils/test_fileutils.rb (test_ln_s): should take the
	  existing symbolic link for OpenBSD.

Wed Nov 26 04:48:42 2003  why the lucky stiff  <why@ruby-lang.org>

	* ext/syck/token.c: removed YYTOKTMP references which
	  were causing buffer overflows on large block scalars,
	  comments, quoted scalars and plain scalars.

	* ext/syck/rubyext.c: dynamic changing of buffer size.

	* ext/syck/syck.h: default buffer size of 4k.

Wed Nov 26 00:55:30 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/httpresponse.rb: add HTTPResponse#keep_alive=.

	* lib/webrick/httpserver.rb (HTTPServer#run): should pass the
	  request's keep_alive flag to the response.

Tue Nov 25 21:41:35 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* defines.h (ENV_IGNORECASE): should define when DOSISH without
	  human68k. [ruby-dev:22047]

	* hash.c (env_has_value, env_index): don't ignore case of value.
	  [ruby-dev:22048]

Tue Nov 25 21:39:37 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (path_check_1): honor sticky bits always.
	  [ruby-talk:86273]

Tue Nov 25 20:02:14 2003  Minero Aoki  <aamine@loveruby.net>

	* test/fileutils/test_fileutils.rb: do test in more deep
	  directory.

	* test/fileutils/test_nowrite.rb: ditto.

Tue Nov 25 19:04:23 2003  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (URI::Generic#find_proxy): ENV case sensitivity test
	  refined.

Tue Nov 25 18:13:30 2003  Minero Aoki  <aamine@loveruby.net>

	* test/fileutils/test_fileutils.rb: chdir Dir.tmpdir before each
	  test. [ruby-dev:22045]

	* test/fileutils/test_nowrite.rb: ditto.

Tue Nov 25 17:52:11 2003  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (URI::Generic#find_proxy): use http_proxy under CGI
	  if the environment variable is case sensitive.

Tue Nov 25 16:41:33 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* test/wsdl/multiplefault.wsdl, test/wsdl/test_multiplefault.rb:
	  removed.  this test requires extra libraries in soap4r/1.5.*.

Tue Nov 25 16:24:42 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/**/*.rb, lib/wsdl/**/*.rb, lib/xsd/**/*.rb: changed license;
	  GPL2 -> Ruby's.

	* lib/soap/rpc/driver.rb, lib/soap/wsdlDriver.rb,
	  lib/soap/streamHandler.rb: add interface to streamhandler.

	* lib/soap/marshal.rb: raise error if parse fails.

	* lib/soap/netHttpClient.rb: add https support.  Patched by
	  Oliver M. Bolzer.

	* lib/soap/netHttpClient.rb: dump HTTP response message body by itself.

	* lib/soap/rpc/driver.rb, lib/soap/rpc/proxy.rb,
	  lib/soap/wsdlDriver.rb: add driver#mandatorycharset interface to foce
	  using charset for parsing response from buggy server.

	* lib/soap/encodingstyle/soapHandler.rb: support Apache Axis's half
	  typed multi-ref array.

	* lib/soap/mapping/factory.rb, lib/soap/mapping/registry.rb: map
	  SOAPStruct which has multi-accessors which name are the same, to an
	  array.

	* lib/soap/rpc/element.rb: fixed illegal parameter order.

	* lib/soap/rpc/element.rb: element name of response message could have
	  the name other than 'return'.

	* lib/wsdl/operation.rb, lib/wsdl/operationBinding.rb,
	  lib/wsdl/soap/classDefCreator.rb, lib/wsdl/soap/methodDefCreator.rb,
	  lib/wsdl/soap/methodDefCreatorSupport.rb: WSDL/1.1 allows plural
	  fault definition in a operation. [ruby-talk:84948]

	* test/wsdl/multiplefault.wsdl, test/wsdl/test_multiplefault.rb: add
	  test for above fix.

	* lib/wsdl/soap/complexType.rb: support WSDL array definition with
	  maxOccures="unbound".

	* lib/xsd/charset.rb: use cp932 under emx.  Patched by
	  Siena. / SHINAGAWA, Norihide in [ruby-dev:21972]

	* lib/xsd/xmlparser/parser.rb: set @charset nil by default.  Nil means
	  'follow encoding declaration in XML'.

	* sample/soap/digraph.rb, sample/wsdl/amazon/wsdlDriver.rb,
	  sample/wsdl/googleSearch/sampleClient.rb,
	  sample/wsdl/googleSearch/wsdlDriver.rb,
	  test/wsdl/test_emptycomplextype.rb,
	  test/wsdl/marshal/test_wsdlmarshal.rb,
	  test/xsd/test_xmlschemaparser.rb: use File.open(...) { |f| f.read }
	  instead of File.open(...).read. [ruby-dev:21964]

	* test/wsdl/emptycomplextype.wsdl, test/wsdl/test_emptycomplextype.rb:
	  simplify the test case.

	* test/wsdl/axisArray/*: add tests for axis's array encoding.

Tue Nov 25 16:15:29 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ruby.h: don't treat Cygwin as Windows.

Tue Nov 25 15:18:28 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* configure.in: change default value of --enable-pthread (default: no)

Tue Nov 25 07:31:16 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (primary): allow newlines just before right argument
	  parenthesis.  (ruby-bugs:PR#1221)

Mon Nov 24 23:32:06 2003  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (OpenURI.open_loop, URI::HTTP#proxy_open): use
	  catch/throw for redirection instead of exception.
	  (OpenURI.open_loop, OpenURI.redirectable?): restrict redirection.

Mon Nov 24 19:59:48 2003  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (URI::Generic#find_proxy): use CGI_HTTP_PROXY
	  instead of HTTP_PROXY in the CGI environment.

Mon Nov 24 19:32:55 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/etc/extconf.rb: check for pw_passwd in struct passwd and
	  gr_passwd in struct group for DJGPP.

	* ext/etc/etc.c: ditto.

	* ext/Setup.dj: support for curses, etc, zlib.

Mon Nov 24 17:00:00 2003  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb: validate option names.
	  :content_length_proc and :progress_proc option implemented.

Mon Nov 24 14:53:10 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* bcc32/Makefile.sub, win32/Makefile.sub, wince/Makefile.sub
	  (XCFLAGS): output empty value instead of `-DRUBY_EXPORT'.

Sat Nov 22 23:09:45 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: set enable_pthread to no on MinGW.

Sat Nov 22 22:56:20 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* configure.in: add --enable-pthread option (default: yes)

Sat Nov 22 22:48:46 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: add Tk.grab_release and fix bug of TkComposite

	* ext/tk/lib/tkafter.rb: bug fix of TkAfter#start

	* ext/tk/sample/tkcombobox.rb: new sample script

	* ext/tcltklib/tcltklib.c: add native thread check

Sat Nov 22 18:49:47 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* ext/curses/curses.c (window_nodelay): nodelay() of NetBSD's
	  libcruses returns no value, just like keypad().

Sat Nov 22 17:36:36 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* bcc32/Makefile.sub, win32/Makefile.sub, wince/Makefile.sub
	  (HAVE_GETCWD): output to config.h.

	* bcc32/Makefile.sub, win32/Makefile.sub, wince/Makefile.sub
	  (XCFLAGS): output to config.status.

Sat Nov 22 13:10:10 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (have_st_ino?): djgpp has valid st_ino.

Sat Nov 22 11:28:48 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (Init_stack): stack region is far smaller than usual if
	  pthread is used.

Sat Nov 22 07:30:00 2003  Nathaniel Talbott  <ntalbott@ruby-lang.org>

	* lib/test/unit/util/backtracefilter.rb: fixed a bug that occurred
	  when an exception had no backtrace.

	* test/testunit/util/test_backtracefilter.rb: ditto.

Fri Nov 21 16:44:18 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tkentry.rb: fix the encoding trouble of percent
	  substitutions on validatecommand option of TkEntry widget

	* ext/tk/lib/tk.rb: fix bug on {pack|grid}_propagate() method

Fri Nov 21 16:12:11 2003  Akinori MUSHA  <knu@iDaemons.org>

	* ruby.1: Fix markups and grammar.

Fri Nov 21 14:49:42 2003  Minero Aoki  <aamine@loveruby.net>

	* ruby.1: wrote about ruby related environment variables.

Fri Nov 21 12:28:03 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_extended): singleton methods should not be checked
	  when dumping via marshal_dump() or _dump(). [ruby-talk:85909]

Fri Nov 21 01:40:00 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* configure.in: check <pthread.h>

	* ruby.h: include pthread.h if existence.
	  define is_ruby_native() macro when not HAVE_NATIVETHREAD

	* eval.c: undef is_ruby_native() function when not HAVE_NATIVETHREAD

Fri Nov 21 00:43:00 2003  Nathaniel Talbott  <ntalbott@ruby-lang.org>

	* lib/test/unit/assertions.rb: use #__send__ instead of #send.

	* lib/test/unit/testcase.rb: ditto.

Thu Nov 20 19:19:22 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: don't find the Cygwin's pthread library on MinGW.

Thu Nov 20 19:15:50 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (have_st_ino?): emx (OS/2 with EMX) does not
	  have st_ino (always 0). [ruby-dev:21972]

	* lib/fileutils.rb (rename_cannot_overwrite_file?): emx does not
	  allow overwriting files by rename(2).

	* test/fileutils/test_fileutils.rb: windows? ->
	  have_drive_letter?, have_file_perm?

Thu Nov 20 17:50:58 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/sample/tkballoonhelp.rb: new sample script

	* ext/tk/sample/tkmultilistbox.rb: ditto

	* ext/tk/sample/tktextframe.rb: ditto

Thu Nov 20 13:37:34 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ruby.h: define is_ruby_native_thread() for no native thread
	  environment

	* eval.c: ditto

Thu Nov 20 12:42:47 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* configure.in: always check existence of the pthread library

	* ruby.h: define macros for ruby's native thread check

	* eval.c: add ruby's native thread check

	* gc.c: ditto

Wed Nov 19 14:45:18 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb (to_ary): print more friendly warning message.

Wed Nov 19 14:32:08 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (fu_same?): add djgpp and wince.

	* lib/fileutils.rb (cannot_overwrite_file?): add wince.

Wed Nov 19 11:04:47 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* lib/fileutils.rb (cannot_overwrite_file?, have_st_ino?): bccwin32
	  is same as mswin32.

Wed Nov 19 07:54:00 2003  Nathaniel Talbott  <ntalbott@ruby-lang.org>

	* lib/test/unit.rb: do not run tests if $! is set.

	* lib/test/unit/assertionfailederror.rb: extend StandardError instead
	  Exception (irb catches the former but not the latter).

Tue Nov 18 23:31:36 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* missing/memmove.c (memmove): take void *, not char *.

	* missing.h (memmove): ditto.

	* missing.h (strchr, strrchr): return char *, not int.

Tue Nov 18 22:20:10 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (fu_same?): temporal fix for windows.

Tue Nov 18 19:05:04 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (fu_same?): check by inode instead of path
	  name, to detect two hard links pointing to the same content.

	* test/fileutils.rb: did not create correctly looped symlinks.

Tue Nov 18 18:23:05 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): behave as IO at empty string.
	  [ruby-dev:21939], [ruby-dev:21941]

	* ext/stringio/stringio.c (strio_getc, strio_getline): set EOF flag.

	* ext/stringio/stringio.c (strio_rewind, strio_seek, strio_ungetc):
	  clear EOF flag.

	* test/stringio/test_stringio.rb: imported from [ruby-dev:21941].

Tue Nov 18 14:06:35 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/fileutils.rb (fu_each_src_dest): raise if src==dest.
	  [ruby-talk:85344] [ruby-core:01699]

	* lib/fileutils.rb: use Object#is_a? instead of Class#=== to allow
	  e.g. remote objects for receivers.

	* lib/fileutils.rb: FileTest -> File.

	* lib/fileutils.rb: put parentheses for arguments of File.xxxx?

	* test/fileutils/test_fileutils.rb (test_cp): test "cp a a".

	* test/fileutils/test_fileutils.rb (test_mv): test "mv a a".

	* test/fileutils/test_fileutils.rb (test_ln): test "ln a a".

	* test/fileutils/test_fileutils.rb (test_ln_s): test "ln_s a a".

	* test/fileutils/test_fileutils.rb (test_install): test "install a a".

	* test/fileutils/fileasserts.rb: new method assert_symlink.

	* test/fileutils/fileasserts.rb: assert_is_directory -> assert_directory.

Mon Nov 17 19:38:49 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (getcwdofdrv): avoid using getcwd() directly, use
	  my_getcwd() instead.

	* merged NeXT, OpenStep, Rhapsody ports patch from Eric Sunshine
	  <sunshine@sunshineco.com>.  [ruby-core:01596]

Mon Nov 17 10:50:27 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::Completion::complete): allow least
	  common completion for three or more candidates.

Mon Nov 17 09:41:38 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/ui/tk/testrunner.rb,
	  lib/test/unit/ui/gtk/testrunner.rb:
	  run GUI main loop in sub thread.

	* lib/test/unit/ui/gtk2/testrunner.rb: imported from rough.

	* lib/test/unit/autorunner.rb (keyword_display): sort keywords.

Sun Nov 16 18:10:57 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_eval): iterator should return value from next inside
	  begin/rescue/end.  (ruby-bugs:PR#1218)

Sun Nov 16 13:26:07 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_object): LINK check earlier than anything else,
	  i.e. do not dump TYPE_IVAR for already dumped objects.
	  (ruby-bugs:PR#1220)

	* eval.c (rb_eval): call "inherited" only when a new class is
	  generated; not on reopening.

	* eval.c (eval): prepend error position in evaluating string to
	  "mesg" attribute string only when it's available and is a
	  string.

Sun Nov 16 12:16:10 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/net/protocol.rb: logging response body. [experimental]
	  [ruby-list:38800]

Sun Nov 16 10:49:38 2003  Gavin Sinclair <gsinclair@soyabean.com.au>

	* lib/thread.rb (Thread.exclusive): wrap method definition in
	  class Thread to enable rdoc to process.

Sun Nov 16 09:45:23 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb (set_debug_output): warn if method is called
	  after #start.  [ruby-dev:38798]

Sun Nov 16 04:41:33 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (eval): do not re-raise exception to avoid unnecessary
	  exception copying, instead modify exception and internal
	  information to adjust eval().

	* eval.c (backtrace): can return the current frame information
	  only if lev < -1.

Sat Nov 15 22:16:42 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* /ext/openssl/ossl_x509ext.c (ossl_x509extfactory_create_ext):
	  refine error message.

Sat Nov 15 10:05:40 2003  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (OpenURI.open_loop, OpenURI::HTTP#proxy_open):
	  refactored to support options.
	  (Buffer): maintain size by this class.

Sat Nov 15 07:40:14 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_method_node): new API to retrieve method body.

Fri Nov 14 13:21:30 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: fix (en-bugged at 2003/11/07)

	* ext/tk/lib/tkdialog.rb: TkDialog.new accepts a parent widget
	  argument [ruby-talk:85066]

Thu Nov 13 20:53:35 2003  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (Kernel[#.]open): hard coded URI schemes removed.
	  [ruby-ext:02251]

Thu Nov 13 19:17:00 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* lib/test/unit/ui/tk/testrunner.rb: use grid and panedwindow
	  (if available)

Thu Nov 13 17:56:41 2003  Tanaka Akira  <akr@m17n.org>

	* lib/open-uri.rb (OpenURI.open_uri): use File::RDONLY.
	  reported by Take_tk <ggb03124@nifty.ne.jp>.
	  [ruby-ext:02245]

Thu Nov 13 16:45:53 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_x509req.c (ossl_x509req_to_der): add function for
	  X509::Request#to_der.

Thu Nov 13 11:31:14 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::Completion#complete): prior shorter
	  name to containing longer name.

Thu Nov 13 06:08:54 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: stop freezing some classes

	* ext/tk/lib/multi-tk.rb: ditto.

Wed Nov 12 17:32:49 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (assert_throws, assert_nothing_thrown):
	  uncaught throw in sub thread raises ThreadError.

	* lib/test/unit/ui/tk/testrunner.rb (setup_ui): "expand" is not
	  necessary.

Wed Nov 12 14:09:43 2003  Shugo Maeda  <shugo@ruby-lang.org>

	* test/monitor/test_monitor.rb: fix the timing problem by Queue.

Wed Nov 12 12:59:44 2003  Shugo Maeda  <shugo@ruby-lang.org>

	* test/monitor/test_monitor.rb: added.

Wed Nov 12 10:14:28 2003  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/monitor.rb: refactored. Thanks, Gennady Bystritsky.

Wed Nov 12 06:11:39 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl.c (ossl_x509_sk2ary, ossl_x509crl_sk2ary):
	  add functions to convert STACK into Array.

	* ext/openssl/ossl.h: add prototypes.

	* ext/openssl/ossl_pkcs7.c (ossl_pkcs7_set_certificates,
	  ossl_pkcs7_get_certificates, ossl_pkcs7_get_crls,
	  ossl_pkcs7_set_crls): add functions for PKCS7#certificates=
	  PKCS7#certificates, PKCS7#crls= and PKCS7#crls.

Wed Nov 12 00:47:00 2003  Nathaniel Talbott  <ntalbott@ruby-lang.org>

	* lib/test/unit/ui/testrunnermediator.rb: should require 'test/unit'.

Tue Nov 11 23:54:00 2003  Nathaniel Talbott  <ntalbott@ruby-lang.org>

	* lib/test/unit/ui/gtk/testrunner.rb: added a rescue clause to handle
	  the case when the requested font is not available.

Tue Nov 11 22:44:08 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (appendline): file may not end with newline.  a bug if
	  READ_DATA_PENDING_PTR is defined. [ruby-talk:84925]

Tue Nov 11 10:42:41 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: raise an exception when creating TkWindow
	  object, because TkWindow class is an abstract class.

Tue Nov 11 03:30:43 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/ext/openssl/ossl_conf.c (ossl_config_get_value): return nil
	  if the specified value doesn't exist.

	* lib/ext/openssl/ossl_conf.c (ossl_config_get_section): return
	  a empty hash if the specified section doesn't exist.

Mon Nov 10 11:40:29 2003  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/monitor.rb (wait): return true on signal/broadcastfalse and
	  false on timeout. Thanks Gennady Bystritsky.

Mon Nov 10 00:07:10 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (primary): primary_value may be 0 when syntax error.
	  [ruby-talk:84893]

Sun Nov  9 02:05:00 2003  Nathaniel Talbott  <ntalbott@ruby-lang.org>

	* lib/test/unit/assertions.rb: un-deprecated #assert_not_nil to
	  maintain symmetry with #assert_nil. Also added better output for
	  #assert_kind_of.

	* test/testunit/tc_assertions.rb: ditto.

Sat Nov  8 18:50:20 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* test/wsdl/raa/*: add new testcase for WSDL loading, parsing and
	  reading.

	* test/soap/marshal/*: backport from soap4r/1.5.1.  all differences are
	  for ruby/1.6.

	* lib/soap/*: backport from soap4r/1.5.1.  all differences are for
	  ruby/1.6.

	* lib/wsdl/data.rb, lib/wsdl/xmlSchema/data.rb: move definition of
	  ArrayTypeAttrName from ::WSDL::XMLSchema::* to ::WSDL::*.
	  [ruby-talk:84813]

	* lib/wsdl/soap/definitions.rb: element name typo in custom exception
	  struct definition which is needed for wsdlDriver; camelCase ->
	  underscore_name.

Sat Nov  8 13:49:50 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* configure.in: improvement of pthread check

Sat Nov  8 13:28:46 2003 Takaaki Tateishi <ttate@ttsky.net>
	* ext/dl/sym.c: Add DL.win32_last_error and DL.last_error.
	  Thanks, Kaoru Shirai.

Sat Nov  8 06:19:38 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tcltklib/tcltklib.c: To fix 'pthread-enabled Tcl/Tk' problem,
	  TclTkIp#_eval calls Tcl_Eval() on the mainloop thread only
	  (queueing a handler to the EventQueue).

	* ext/tcltklib/README.1st: edit the description of '--with-pthread-ext'

Fri Nov  7 23:23:04 2003  Tanaka Akira  <akr@m17n.org>

	* lib/pathname.rb (Pathname#+): if self or the argument is `.', return
	  another.
	  (Pathname#parent): if self is `.', return `..'.
	  (Pathname#children): if self is `.', don't prepend self for a
	  pathname in a result.
	  (Pathname#join): re-implemented using Pathname#+.
	  (Pathname#find): if self is `.', remove `./' prefix of yielding
	  pathname.

Fri Nov  7 10:23:24 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/socket.c (make_hostent): get rid of SEGV on aliases
	  lookup failure.  (ruby-bugs:PR#1215)

Fri Nov  7 04:08:05 2003  UENO Katsuhiro  <katsu@blue.sky.or.jp>

	* ext/zlib/zlib.c (Init_zlib): define Zlib::GzipReader#each_line as
	  an alias of Zlib::GzipReader#each.

Fri Nov  7 01:03:16 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_load): save and restore rb_prohibit_interrupt.
	  [ruby-dev:21857]

Thu Nov  6 18:05:07 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_inspect): show the path also at a closed file.
	  [ruby-dev:21851]

Thu Nov  6 11:42:07 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_set_string, strio_reopen): check
	  tainted.

	* ext/stringio/stringio.c (strio_copy, strio_ungetc, strio_write,
	  strio_putc): add infection.

	* ext/stringio/stringio.c (strio_path): just nil.  [ruby-dev:21846]

	* ruby.c (proc_options): reserve searched script path in the
	  source file name table.  [ruby-list:38765]

	* lib/optparse.rb (OptionParser::Completion#complete): default not to
	  ignore case on completion.  [ruby-talk:84726]

	* win32/win32.c (make_cmdvector): process backslashes even if a quote
	  is not enclosed.

Wed Nov  5 23:49:45 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* sample/openssl/gen_csr.rb: there (at least) is a CA which does not
	  accept DN in UTF8STRING format.  it's a sample.

Wed Nov  5 22:55:16 2003  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* configure.in, eval.c, signal.c: : add '--with-pthread-ext'
	  option to fix the pthread trouble on 'tcltklib'

	* ext/tcltklib/README.1st: add the description of '--with-pthread-ext'

	* ext/tk/lib/tktext.rb : add TkText#text_copy, text_cut, text_paste
	  to support Tcl/Tk8.4's tk_textCopy, tk_textCut, tk_textPaste

	* ext/tk/lib/tk.rb : add TkMenu#set_focus support Tcl/Tk's
	  tk_menuSetFocus

Wed Nov  5 17:33:45 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_load): allow interrupt during loaded program
	  evaluation.  [ruby-dev:21834]

	* hash.c (rb_hash_fetch): always warn if default argument and a
	  block are supplied at the same time. [ruby-dev:21842]

	* hash.c (env_fetch): ditto.

	* array.c (rb_ary_fetch): ditto.

Wed Nov  5 19:08:47 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser::Switch::PlacedArgument::parse):
	  do not remove next argument if empty value is placed.

	* test/optparse: added.

Wed Nov  5 17:05:18 2003  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/ui/gtk/testrunner.rb: typo.

Wed Nov  5 11:13:32 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* string.c: add #include "version.h". this file still depends on it.

	* Makefile.in, bcc32/Makefile.sub, win32/Makefile.sub,
	  wince/Makefile.sub: add version.h dependency to string.c.

Wed Nov  5 09:14:23 2003  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/monitor.rb: revert to the previous revision.

Wed Nov  5 08:39:51 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/https.rb (HTTPRequest#parse): set @client_cert_chain.

	* lib/webrick/https.rb (HTTPRequest#meta_vars): create
	  SSL_CLIENT_CERT_CHAIN_n from @client_cert_chain.

	* ext/openssl/ossl_ssl.c (ossl_ssl_get_peer_cert_chain): return nil
	  if no cert-chain was given.

Tue Nov  4 23:44:48 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* bcc32/Makefile.sub, win32/Makefile.sub, wince/Makefile.sub:
	  remove needless version.h dependency.

Tue Nov  4 23:38:43 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* class.c, hash.c, string.c: remove #include "version.h".

	* Makefile.in: remove needless version.h dependency.

Tue Nov  4 06:54:52 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (read_all): fptr->f may be NULL, if IO is closed in the
	  signal handler.

	* io.c (io_read): ditto.

	* string.c (get_pat): remove 1.8.0 warning code.

	* string.c (rb_str_match): extend warning until 1.8.2.

	* string.c (rb_str_match2): ditto.

	* class.c (class_instance_method_list): remove 1.8.0 warnings.
	  method_list now recurs.  [ruby-dev:21816]

	* class.c (rb_obj_singleton_methods): ditto.

	* array.c (rb_ary_select): remove select with block.
	  [ruby-dev:21824]

	* hash.c (rb_hash_select): ditto.

	* hash.c (env_select): ditto.

	* re.c (match_select): ditto.

	* struct.c (rb_struct_select): ditto.

Mon Nov  3 22:53:21 2003  Minero Aoki  <aamine@loveruby.net>

	* lib/racc/parser.rb: synchronize with Racc 1.4.4.

	* ext/racc/cparse/cparse.c: ditto.

	* ext/racc/cparse/cparse.c (parse_main): should abort when
	  the length of LR state stack <=1, not ==0.

Mon Nov  3 08:50:47 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* process.c (check_uid_switch): remove duplicated error messages.

	* process.c (check_gid_switch): ditto.

Sun Nov  2 02:28:33 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* lib/webrick/ssl.rb: new option :SSLExtraChainCert.

Sun Nov  2 01:02:04 2003  Akinori MUSHA  <knu@iDaemons.org>

	* string.c (rb_str_hash): Update the HASH_PERL alternative hash
	  algorithm in sync with Perl 5.8.

	* st.c (strhash): Ditto.

Sat Nov  1 18:21:09 2003  GOTOU Yuuzou  <gotoyuzo@notwork.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_peer_cert_chain): add new method
	  SSLSocket#peer_cert_chain.

	* ext/openssl/ossl_x509req.c (GetX509ReqPtr): new function
	  which returns underlying X509_REQ.

	* ext/openssl/ossl_x509ext.c (ossl_x509extfactory_set_issuer_cert,
	  ossl_x509extfactory_set_subject_cert, ossl_x509extfactory_set_crl,
	  ossl_x509extfactory_set_subject_req, ossl_x509extfactory_set_config):
	  use underlying C struct without duplication not to leak momory.

Sat Nov  1 01:49:03 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/mapping/factory.rb: mark marshalled basetype objects when
	  @allow_original_mapping is true.  multi-referencing basetype node is
	  prohibited in SOAP/1.1 encoding but soap4r's original ruby object
	  mapping requires basetype to be marked to detect self referencing
	  loop.  e.g. o = 1; o.instance_eval { @iv = o }  soap4r's original
	  mapping is only used through soap/marshal API.

	* test/soap/marshal/test_marshal.rb: add tests for self referencing
	  immutable objects.

	* test/soap/calc/test_calc_cgi.rb: fix test name.

Fri Oct 31 22:26:29 2003  Takaaki Uematsu  <uema2x@jcom.home.ne.jp>

	* wince/string_wce.c (strrchr): should decrement pointer.

	* wince/Makefile.sub: correct a range of isdigit().

Fri Oct 31 12:55:24 2003  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in, lib/mkmf.rb: add RPATHFLAG for NetBSD.
	  [ruby-dev:21791]

	* bcc32/Makefile.sub, win32/Makefile.sub, win32/Makefile.sub: ditto.

Fri Oct 31 01:38:14 2003  NAKAMURA Usaku <usa@ruby-lang.org>

	* wince/Makefile.sub, win32/Makefile.sub (.y.c): allow white spaces
	  at the beginning of line to remove by sed. (ruby-bugs-ja:PR#580)

Fri Oct 31 01:02:24 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* compar.c (cmp_equal): protect exceptions from <=> comparison
	  again.  returns nil if any exception or error happened during
	  comparison.

	* eval.c (search_required): should update *featurep when DLEXT2 is
	  defined. (ruby-bugs-ja:PR#581)

Thu Oct 30 23:41:04 2003  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb: add DRbArray

	* lib/drb/invokemethod.rb: fix Hash#each problem. [ruby-dev:21773]

	* lib/drb/unix.rb: add LoadError. [ruby-dev:21743]

Thu Oct 30 23:19:11 2003  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/soap/generator.rb: better XML pretty printing.

	* lib/soap/encodingstyle/soapHandler.rb: remove unnecessary namespace
	  assignment in the element which has "encodingStyle" attribute, and
	  add necessary namespace assignment for "arrayType" attribute.

	* test/soap/calc/test_calc_cgi.rb: take over $DEBUG to ruby process
	  through CGI.

Thu Oct 30 22:59:39 2003  why the lucky stiff  <why@ruby-lang.org>

	* ext/syck/yaml2byte.c: HASH const too long.  Thanks, matz.

Thu Oct 30 19:13:53 2003  Akinori MUSHA  <knu@iDaemons.org>

	* ext/syck/MANIFEST: Add yamlbyte.h.

Thu Oct 30 14:25:31 2003  Yukihiro Matsumoto  <matz@ruby-lang.org>

